/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package facade;

import atarraya.BatchExecutor;
import atarraya.element.node;
import atarraya.element.solution;
import atarraya.event.eventQueue;
import atarraya.event.event_sim;
import atarraya.constants;
import atarraya.element.edge;
import atarraya.event.NodeHandler;
import atarraya.event.timestamp;
import java.awt.Point;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;
import java.util.concurrent.Semaphore;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.filechooser.FileNameExtensionFilter;


/**
 *
 * @author Mayra Zurbarn
 */
public class Facade implements Observable, constants{

    //view
    private Observer view;

    /********************************************
     * Simulation agent and and Batch Simulation
     ********************************************/
    public double clock;                                      // Variable that stores the simulators clock

    BatchExecutor the_batch_sim;        //Auxiliary thread for batch execution on background of frame operations

    //simulador
    the_sim mysim;
    the_sim tempsim;
    boolean TC_Prot_final;                        // It marks the ending of the TC protocol, on the first run, on check_sim_finish()
    double max_clock_time;
    public boolean topology_loaded;                    //Boolean variable that defines if a topology has been loaded.

    // Batch simulation variables
    boolean batch_simulation;           // Condition that determines if the simulator is in batch_execution mode.
    boolean batch_creation;                 // Signal of being in batch_creation mode

    //for NodeGeneratorForBatch()
    public boolean createAllSteps;
    public String CGStep;

    int resultTryAgain;                 //Flag to try again when the maximum amount of trials is reached

    //Variables for batch simulation control of files and current execution
    int current_topology_from_batch;
    int current_instance_topology_from_batch;
    public int num_files_topology_from_batch;
    int num_topology_from_batch;
    int total_num_topologies;

    boolean allAlphas;
    double alpha_ini, alpha_fin, alpha_step;

    public boolean sw_just_min;


    /***********************************************
     * Protocol management
     ***********************************************/

    // Protocols handler and executer
    NodeHandler simulator;

    //Index of the selected protocols
    public int selected_TCprotocol;
    public int selected_TMprotocol;
    public int selected_SDprotocol;
    public int selected_COMMprotocol;
    public int selected_Motionprotocol;
    public int selected_energy_model;
    public int selected_comm_model;

    //Boolean that signals if a protocol of each type were selected
    public boolean sim_assigned;
    public boolean TC_Selected;
    public boolean TM_Selected;
    public boolean SD_Selected;
    public boolean COMM_Selected;

    public int treeID;                          // Temporary variable

    /************************************************
     * Topology Information and Topology Creation variables
     ************************************************/

    public Vector<String> node_creation_words;
    public Vector<String> sink_creation_words;

    public boolean sinkNode;
    //Needed for the connectivity check
    Vector<Integer> temp_ids;

    public int start_index;
    int numTopologies;                  //Number of topologies

    boolean checkTrials;                    // This variable enables Atarraya to avoid loops on batch creation when topology definition is impossible to create
    
    //Metric Weights
    public double weight_metric1;
    public double weight_metric2;


    //Node Creation Word Attributes
    int numnodes_;
    double comm_rad_;
    double sense_rad_;
    double interquery_time_;
    int pos_dist_;
    int mean_x;
    int mean_y;
    int energy_dist_;
    int energy_max;
    int energy_mean;
    double pos_param;
    double energy_param;
    boolean move;
    int _energy_model;
    int _comm_model;
    int tree_sel_;
    int _width;
    int _height;

    int max_retx;               //Maximum number of packet retransmissions
    double NEXT_RESET_TIMEOUT;
    double TM_ENERGY_THSLD_STEP;


    // Temporary variables to be used as a reference for grid construction and other minor operations
    public double diameter, sense_diameter,radius,sense_radius;

    //
    public double pref_radius;

    //position related
    public int rand_distribution;
    Point p;
    public double sigma;

    // Variables associated to energy and position distribution of the random variables, when nodes are created
    // Energy related
    public int energy_distribution;
    public double energy_distribution_parameter;
    public double sigma_e;
    public double MAX_ENERGY;

    //Variables for Topology Construction protocols

    public int kneigh_k;
    public int kneigh_type;

    /*
     * File related variables
     */

    
    
    String the_parent_dir,the_name, the_name2;
    File myFile;
    public File[] myFiles;
    public FileNameExtensionFilter filter;
    
    FileWriter fout;
    BufferedWriter mywrite;
    FileReader fin;
    BufferedReader myread;

    //File readers for the creation words file
    File myCreationWordsFile;
    FileWriter fout_cw;
    BufferedWriter mywrite_cw;
    FileReader fin_cw;
    BufferedReader myread_cw;

    //File readers for the lifetime log file
    File myLogFile_STAT_LT;
    FileWriter fout_log_lt;
    BufferedWriter mywrite_log_lt;
    FileReader fin_log_lt;
    BufferedReader myread_log_lt;

    //File readers for the results log file
    File myLogFile_RESULTS;
    FileWriter fout_log_results;
    BufferedWriter mywrite_log_results;

    //File readers for the stats log file
    File myLogFile_STAT;
    FileWriter fout_log_stat;
    BufferedWriter mywrite_log_stat;
    FileReader fin_log_stat;
    BufferedReader myread_log_stat;

    //File readers for the events log file
    File myLogFile_STAT_EV;
    FileWriter fout_log_ev;
    BufferedWriter mywrite_log_ev;
    FileReader fin_log_ev;
    BufferedReader myread_log_ev;

    

     /******************************************
     * Statistics variables
     ******************************************/
    //Variables for reports
    public String statsPaneText;
    public String report;
    String stats;                                   // Statistics string
    String stats_from_panel;

    public boolean indiv_reports;
    public boolean sumarized_reports;
    public boolean excel_ready_reports;
    public String report_descriptor;
    public boolean save_stats;
    public boolean save_all_stats;
    public int save_all_stats_step;
    public boolean save_lifetime_log;
    String temp_lifetime_string;
    String temp_lifetimeSurvivors_string;
    String temp_lifetimeBFS_string;
    String temp_lifetimeBFS_Coverage_c_string;
    String temp_lifetimeBFS_Coverage_s_string;
    String temp_lifetimeMessageLoss_string;
    public boolean save_events_log;
    public boolean save_results_log;

    int num_events;                            // Total number of events on the event log
    int num_messages;                        // Total number of short messages sent
    int num_messages_long;                // Total number of long messages sent
    int num_messages_r;                     // Total number of short messages received
    int num_messages_long_r;             // Total number of long messages received
    int num_messages_l;                     // Total number of short messages lost
    int num_messages_long_l;             // Total number of long messages lost
    int num_messages_data_r_sink;     // Total number of messages received by the sink
    int num_messages_data_generated;  //Total number of generated messages from the nodes
    
    public int count_TM_invocations;       //Counts how many times the TM protocol was invocked

    double ctr;                                     //Critical Transmission Range calculated

    double total_energy_spent;
    public double total_energy;
    double total_energy_ini;
    double total_energy_tree;
    double energy_TX_regular;
    double energy_RX_regular;
    double energy_TX_long;
    double energy_RX_long;

    public boolean check_connectivity;

    boolean liveStats;          //update stats

    // Gigant Component test and CTR related variables
    boolean GC_Test;                      //Shows that the GC Test is being perfomed
    Semaphore sem_GC;                     //Grant access to continue the process of GC after the topologies have been created
    int num_nodes_ctr;                     //Number of nodes used on the Theoretical CTR tests
    int area_side_ctr;                        //Area Side
    int comm_radius_ctr;                  // Comm radius for CTR
    int num_topologies_ctr;                // Number of topologies for the Giant Component Test
    double initial_ctr;                        // Initial comm radius fo the Giant Component Test
    double step_ctr;                        // Step in comm radius fo the Giant Component Test

    double initial_k_ctr;                    //Initial value of the parameter K
    double final_k_ctr;                     //Final value of the parameter K
    double step_k_ctr;                      //Rate of change of the parameter K
    int initial_i_exp_l_ctr;                    //Initial value of the parameter i on the formula for defining parameter L
    int final_i_exp_l_ctr;                       //Final value of the parameter i on the formula for defining parameter L
    boolean dense;
    boolean nodeDegreeRatio;
    boolean sparse;

    public Facade(Observer view){
        this.view = view;
        //mysim = new the_sim();
        clock = 0.0;

        mysim = new the_sim();

        the_batch_sim = new BatchExecutor(this);
        the_batch_sim.start();

        TC_Selected = false;
        TM_Selected = false;
        SD_Selected = false;
        COMM_Selected = false;

        selected_TCprotocol = 0;
        selected_TMprotocol = 0;
        selected_SDprotocol = 0;
        selected_COMMprotocol = 0;
        selected_Motionprotocol = 0;
        selected_energy_model = 0;
        selected_comm_model = 0;

        filter = new FileNameExtensionFilter("ata","ATA");
        
        radius=100;
        sense_radius = 20;
        diameter=2*radius;
        sense_diameter=2*sense_radius;
        treeID = -1;
        pref_radius = 100;

        num_messages=0;
        num_messages_long=0;
        num_messages_r=0;
        num_messages_long_l=0;
        num_messages_l=0;
        num_messages_long_r=0;
        num_messages_data_r_sink=0;
        num_messages_data_generated=0;
        num_events = 0;
        simulator = new NodeHandler(this);
        save_stats = false;
        save_all_stats = false;
        save_all_stats_step = 20;
        save_lifetime_log = false;
        save_events_log = false;
        save_results_log = false;
        indiv_reports = true;
        sumarized_reports = false;
        excel_ready_reports = false;
        report_descriptor="";

        energy_TX_regular=0;
        energy_RX_regular=0;
        energy_TX_long=0;
        energy_RX_long=0;
        total_energy_spent=0;
        
        sim_assigned = false;
        temp_ids = new Vector<Integer>();
        count_TM_invocations = 0;
        topology_loaded = false;
        max_clock_time =3000000.0;
        TC_Prot_final = false;
        node_creation_words = new Vector<String>();
        sink_creation_words = new Vector<String>();
        sinkNode = false;        
        start_index = 0;
        numTopologies =1;
        checkTrials = true;
        weight_metric1 = 0.5;
        weight_metric2 = 0.5;
        NEXT_RESET_TIMEOUT = 1000.0;
        TM_ENERGY_THSLD_STEP = 0.9;
        _width = 600;
        _height = 600;

        max_retx = 5;
        check_connectivity = true;
        batch_simulation = false;
        batch_creation = false;
        liveStats = false;

        num_nodes_ctr=100;
        area_side_ctr=100;
        comm_radius_ctr=0;
        num_topologies_ctr = 100;
        initial_ctr = 0.01;
        step_ctr = 0.01;
        GC_Test = false;
        sem_GC = new Semaphore(0);
        dense = false;
        nodeDegreeRatio = false;
        sparse = false;

        energy_distribution=0;
        energy_distribution_parameter=1000;
        MAX_ENERGY = 1000;
        p = new Point();
        sigma = 5;
        rand_distribution=0;

        resultTryAgain = 0;
        stats="";
        stats_from_panel="";
        statsPaneText="";
        report="";

        kneigh_k = 6;
        kneigh_type = KN_JUST_LEVEL;

        current_topology_from_batch = 0;
        current_instance_topology_from_batch = 0;
        num_files_topology_from_batch = 0;
        num_topology_from_batch = 0;
        total_num_topologies = 0;
        allAlphas = false;
        alpha_ini=1;
        alpha_fin=0;
        alpha_step=0;

        sw_just_min = false;

        CGStep = "0.25";
        createAllSteps = false;

        

    }

    public void setView(Observer v) throws Exception {
            view = v;
    }

    public void removeView(Observer v) throws Exception{
        view = null;
    }

    public void resetSim(){
        mysim = null;
        mysim = new the_sim();
    }
    
    public the_sim getMysim() {
        return mysim;
    }

    public NodeHandler getSimulator() {
        return simulator;
    }

    public void setSimulator(NodeHandler simulator) {
        this.simulator = simulator;
    }

    
    
    public the_sim getTempsim()
    {
        return tempsim;
    }
    
    public int getNumTopologies() {
        return numTopologies;
    }

    public void setNumTopologies(int numTopologies) {
        this.numTopologies = numTopologies;
    }

    public boolean isLiveStats() {
        return liveStats;
    }

    public void setLiveStats(boolean liveStats) {
        this.liveStats = liveStats;
    }

    public void setNum_topology_from_batch(int num_topology_from_batch) {
        this.num_topology_from_batch = num_topology_from_batch;
    }

    public void setView_covered_area_stat(boolean view_covered_area_stat) {
        mysim.view_covered_area_stat = view_covered_area_stat;
    }

    public void saveCreationWordsFile(String fn, String numTopologies, String startindex){
        try {
            myCreationWordsFile = new File(fn);

            fout_cw = new FileWriter(myCreationWordsFile);
            mywrite_cw = new BufferedWriter(fout_cw);
        
            mywrite_cw.write(""+mysim.h);        //height
            mywrite_cw.newLine();
            mywrite_cw.write(""+mysim.w);        //width
            mywrite_cw.newLine();
            mywrite_cw.write(numTopologies);       //# topologies
            mywrite_cw.newLine();
            mywrite_cw.write(startindex);    //start index
            mywrite_cw.newLine();
            for (String word:node_creation_words ){
                mywrite_cw.write(word);
            }                                   //nodes creation words

            for (String word:sink_creation_words ){
                mywrite_cw.write(word);
            }                                   //sinks creation words
        }catch(Exception ex){ex.printStackTrace();}
            try {
                if (mywrite_cw != null) {
                    mywrite_cw.flush();
                    mywrite_cw.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
    }

    public void InvalidateAllEventsFromIDFromTimeTOfCodeC(int id, double t, int c, int tree){
        mysim.InvalidateAllEventsFromIDFromTimeTOfCodeC(id,t,c,tree);
    }

    public void InvalidateAllEventsFromIDFromTimeTOfTypeTy(int id, double t, int Ty, int tree){
        mysim.InvalidateAllEventsFromIDFromTimeTOfTypeTy(id,t,Ty,tree);
    }

    public void InvalidateAllEventsFromIDFromTimeTOfTypeTyOfCodeC(int id, double t, int Ty, int c, int tree){
        mysim.InvalidateAllEventsFromIDFromTimeTOfTypeTyOfCodeC(id,t,Ty,c, tree);
    }

    public void InvalidateAllEventsFromIDFromTimeT(int id, double t, int tree){
        mysim.InvalidateAllEventsFromIDFromTimeT(id,t, tree);
    }

    public void loadCreationWordsFiles(File[] files, String path) {
        String line = null;
        int n;
        for(File f:files){
            try {
                fin_cw = new FileReader(f);
                myread_cw = new BufferedReader(fin_cw);
                if ((line = myread_cw.readLine()) != null){
                    mysim.h = Integer.parseInt(line);
                    line = myread_cw.readLine();
                    mysim.w = Integer.parseInt(line);
                    n = Integer.parseInt(myread_cw.readLine());
                    start_index = Integer.parseInt(myread_cw.readLine());
                    node_creation_words.clear();
                    sink_creation_words.clear();
                    while ((line = myread_cw.readLine()) != null){
                        if(line.substring(0, 1).equals("0"))
                            node_creation_words.add(line);
                        else
                            sink_creation_words.add(line);
                    }
                    int NodeGeneratorForbatch = NodeGeneratorForbatch(n-start_index, path);
                }
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
            } catch (IOException ex) {
                ex.printStackTrace();
            } finally {
                try {
                    if (myread_cw != null)
                        myread_cw.close();
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            }
        }
    }

    public void LoadDeployment(String the_file){

        LoadDeployment(the_file, -1);

    }

    
    
    public void LoadDeployment(String the_file, double rad){

        String temp="";
        String[] temp_read;
        int i,j;
        myFile = new File(the_file);
        int positionx;
        int positiony;
        double energy;
        mysim.clearnodes();

        total_energy_ini = 0;
        int countNeighbs=0;
        int cont=0,cont2=0;
        double temp_radius, temp_sense_radius;
        view.update(Observer.CLEAR_PANEL, "");
        int temp_trees=0;
        int temp_num_sinks=0;
        mysim.numsinks=0;
        double interquery_time_=10,weight_e=0.5, weight_d=0.5;
        int motion = 0;
        int energy_model=0;
        int comm_model=0;

        try{

            fin = new FileReader(the_file);
            myread = new BufferedReader(fin);


            temp = myread.readLine();

            if(temp!=null){

                try{

                    view.update(Observer.CLEAR_SIM, "");

                    mysim.numnodes = Integer.parseInt(temp);
                    view.update(Observer.SHOW_NUM_NODES, ""+mysim.numnodes);

                    temp = myread.readLine();
                    temp_trees = Integer.parseInt(temp);

                    for(i=0;i<temp_trees;i++){
                        temp = myread.readLine();
                        temp_num_sinks = Integer.parseInt(temp);
                        mysim.num_sinks_per_tree[i] = temp_num_sinks;
                        mysim.numsinks+=temp_num_sinks;
                    }

                    temp = myread.readLine();
                    radius = Double.parseDouble(temp);
                    view.update(Observer.SHOW_COMM_RADIUS, ""+radius);

                    temp = myread.readLine();
                    sense_radius = Double.parseDouble(temp);

                    temp = myread.readLine();
                    mysim.h = Integer.parseInt(temp);

                    temp = myread.readLine();
                    mysim.w = Integer.parseInt(temp);

                    view.update(Observer.SET_PANEL_AREA, "");

                    //Updating range areas for visual effects
                    Vector<Boolean> v = new Vector<Boolean>(2);
                    v.add(false);
                    v.add(false);
                    view.update(Observer.SET_RANGE_AREA, v);
                    //myPanel.setRangeArea(false, false);

                    //Updating the total number of points in the area = nodes + sinks
                    mysim.numpoints = mysim.numnodes + mysim.numsinks;

                    for(i=0;i<mysim.numpoints;i++){

                        temp = myread.readLine();
                        temp_read = temp.split("@");

                        positionx = Integer.parseInt(temp_read[0]);
                        positiony = Integer.parseInt(temp_read[1]);
                        energy = Double.parseDouble(temp_read[2]);

                        if(temp_read.length > 3){
                            if(rad == -1)
                                temp_radius = Double.parseDouble(temp_read[3]);
                            else
                                temp_radius = rad;

                            temp_sense_radius = Double.parseDouble(temp_read[4]);
                            interquery_time_= Double.parseDouble(temp_read[5]);
                            weight_e = Double.parseDouble(temp_read[6]);
                            weight_d = Double.parseDouble(temp_read[7]);

                            if(temp_read.length > 8)
                                motion = Integer.parseInt(temp_read[8]);
                            if(temp_read.length > 9)
                                energy_model = Integer.parseInt(temp_read[9]);
                            if(temp_read.length > 10)
                                comm_model = Integer.parseInt(temp_read[10]);

                            mysim.mynodes.add(new node(i, new Point(positionx,positiony), energy, temp_radius, temp_sense_radius,interquery_time_,weight_e,weight_d,motion,energy_model, comm_model));
                        }else
                            mysim.mynodes.add(new node(i, new Point(positionx,positiony), energy, radius, sense_radius));

                        total_energy_ini += energy;
                    }

                    }catch(Exception e){e.printStackTrace();}

            fin.close();
            }
            topology_loaded=true;
        }catch(Exception e){e.printStackTrace();}


        //Defining the role of SINKS to all sinks on each of the trees.
        cont = mysim.numnodes;
        for(j=0;j<MAX_TREES;j++){
            temp_num_sinks= mysim.num_sinks_per_tree[j];
            if(temp_num_sinks >0){
                for(i=0;i<mysim.numpoints;i++){
                    getNode(i).SetInfrastructureStarted(j, true);
                }
            }
            for(i=0;i<temp_num_sinks;i++){
                getNode(cont).setRole(j,ROLE_SINK);
                cont++;
            }
        }


        //Calculate the neighborhood of the nodes
        for(i=0;i<mysim.numpoints;i++){
            getNode(i).setSortingMode(mysim.sortingmode);
            mysim.avgNeighb += BuildNeighborhood(i);
        }

        mysim.avgNeighb = mysim.avgNeighb/mysim.numpoints;
        view.update(Observer.SHOW_AVG_NGB, ""+mysim.avgNeighb);

        if(!batch_simulation){
            view.update(Observer.REPAINT, "");
            view.update(Observer.CHANGE_PANE_VIEW, 1);
            view.update(Observer.PRINT_MSG, "Deployment loaded!");
        }

    }

    /*Number of generated messages by the nodes*/
    public void addGeneratedMessage(){
        num_messages_data_generated++;
    }
    
    /*Number of generated messages by the nodes over the number of messages received by the sink node*/
    public double getMessageLossRatio(){
        if(num_messages_data_r_sink!=0)
            return 1-(num_messages_data_generated/num_messages_data_r_sink);
        
        return 1.0;
        
    }
    
    public void addLineToLifetimeLog(String s){
        try{
            mywrite_log_lt.write(s+","+temp_lifetime_string+"\n");
            mywrite_log_lt.write(s+","+temp_lifetimeSurvivors_string+"\n");
            mywrite_log_lt.write(s+","+temp_lifetimeBFS_string+"\n");
            mywrite_log_lt.write(s+","+temp_lifetimeBFS_Coverage_c_string+"\n");
            mywrite_log_lt.write(s+","+temp_lifetimeBFS_Coverage_s_string+"\n");
            mywrite_log_lt.write(s+","+temp_lifetimeMessageLoss_string+"\n");
        }catch(Exception ex){ex.printStackTrace();}
    }

    public void addLineToResultsLog(String s){

        solution sol = new solution(mysim.numpoints);
        int i, t=0, at=0;

        for(i=0;i<mysim.numpoints;i++){
            at = mysim.getNode(i).getActiveTree();
            if(mysim.getNode(i).isActive(at))
                t=1;
            else
                t=0;

            sol.set(i, t);
        }

        try{
            mywrite_log_results.write(s+","+sol.toString()+sol.getSum()+"\n");
        }catch(Exception ex){ex.printStackTrace();}
    }

    public void addStatToLifetimeLog(String s){

        temp_lifetime_string = temp_lifetime_string + s +",";
        temp_lifetimeBFS_string = temp_lifetimeBFS_string + BFS(BFS_MODE_ACTIVE_ALIVE_FROM_SINKS_CHILDREN_ONLY) +",";
        temp_lifetimeSurvivors_string = temp_lifetimeSurvivors_string + (mysim.numpoints-mysim.count_dead) + ",";
        temp_lifetimeBFS_Coverage_c_string = temp_lifetimeBFS_Coverage_c_string+mysim.covered_area_from_sink_c+",";
        temp_lifetimeBFS_Coverage_s_string = temp_lifetimeBFS_Coverage_s_string+mysim.covered_area_from_sink_s+",";
        temp_lifetimeMessageLoss_string = temp_lifetimeMessageLoss_string+this.getMessageLossRatio()+",";

    }

    public void addStatToLifetimeLogEvent(){
        if(save_lifetime_log){
              addStatToLifetimeLog(""+clock);
        }
    }
    
    public void addStatToReport(String s){
        addStatToReport(s, "");
    }
    
    public void addStatToReport(String s, String extra){
        
        try{
            if(extra.equals("")){
                if(excel_ready_reports)
                        mywrite_log_stat.write(getStatsRowForExcel(s,extra));
                    else{
                        view.update(Observer.SET_STATS, "");
                        mywrite_log_stat.write("Stats from file: "+s+"\n"+statsPaneText+"\n"+extra+"\n\n");
                    }
            } else {
                if(excel_ready_reports)
                        mywrite_log_stat.write(getStatsRowForExcel(s));
                else{
                    view.update(Observer.SET_STATS, "");
                    mywrite_log_stat.write("Stats from file: "+s+"\n"+statsPaneText+"\n\n");
                }
            }    
        }catch(Exception ex){
            ex.printStackTrace();
        }
        
    }

    public void SaveReport(){

        try{

            mywrite_log_stat.flush();
            mywrite_log_stat.close();
            fout_log_stat.close();

        }catch(Exception ex){ex.printStackTrace();}

    }

    public void SaveReportLifetime(){

        try{
            mywrite_log_lt.flush();
            mywrite_log_lt.close();
            fout_log_lt.close();

        }catch(Exception ex){ex.printStackTrace();}

    }

    public void SaveReportResults(){

        try{
            mywrite_log_results.flush();
            mywrite_log_results.close();
            fout_log_results.close();

        }catch(Exception ex){ex.printStackTrace();}

    }

    public void addDefaultSinkCreationWord(){
        sinkNode = true;
        //setNodeCreationWordAttributes(1, 100.0, 20.0, 10, 3, 300, 300, 0, 1000, 1000, 1, 1, weight_metric1, weight_metric2, false, 0, 0, 0, 600, 600);
        
        addNodeCreationWord();

        sinkNode = false;
    }
    
    public void addTMInvocation(){
        count_TM_invocations++;
    }

    public void applySolution(solution sol){

        int i=0;

        for(i=0; i<mysim.numpoints; i++){
            getNode(i).setNodeStateBFS(sol.get(i));
        }

    }

     public void setNodeCreationWordAttributes(int numnodes_, double comm_rad_, double sense_rad_,
                                    double interquery_time_, int pos_dist_, int mean_x,
                                    int mean_y, int energy_dist_, int energy_max, int energy_mean, double pos_param,
                                    double energy_param, double wMetric1, double wMetric2, boolean move, int _energy_model, int _comm_model,
                                    int tree_sel_, int _width, int _height, int _max_retx){
        
            this.numnodes_ = numnodes_;
            this.comm_rad_ = comm_rad_;
            this.sense_rad_ = sense_rad_;
            this.interquery_time_= interquery_time_;
            this.pos_dist_ = pos_dist_;
            this.mean_x = mean_x;
            this.mean_y = mean_y;
            this.energy_dist_ = energy_dist_;
            this.energy_max = energy_max;
            this.energy_mean = energy_mean;
            this.pos_param = pos_param;
            this.energy_param = energy_param;
            this.weight_metric1 = wMetric1;
            this.weight_metric2 = wMetric2;
            this.move = move;
            this._energy_model = _energy_model;
            this._comm_model = _comm_model;
            this.tree_sel_ = tree_sel_;
            this._width = _width;
            this._height = _height;
            this.max_retx = _max_retx;
        
        

    }



     public void addNodeCreationWord(){

/*
         *  word format:
         * sink@                        {0,1}= no, yes
         * tree selection@          int
         * number of nodes@     int
         * comm rad@               int
         * sensing rad@            int
         * Interquery time@       double
         * position distrib@        {0-5} = uniform, normal, grid HV, grid HVD, constant, center
         * mean x@                   int
         * mean Y@                   int
         * parameter@               double
         * energy distrib@        {0-5} = uniform, normal,poisson, constant
         * max value@               int
         * mean value@              int
         * parameter@               double
         * motion@                   {0,1}= no, yes
         */

        //int numnodes_=0;
        //double comm_rad_=40.0, sense_rad_=20.0;
        int sink_=0/*, tree_sel_=0*/;
        //double interquery_time_=10;
        //int pos_dist_=0, mean_x=300, mean_y=300;
        //int energy_dist_=0, energy_max=1000, energy_mean=1000;
        //double pos_param=1, energy_param=1;
        int temp=0;
        int _numnodes=0;
        //int _width=600, _height=600;
        int motion = 0;
        //int _energy_model = 0;


        String the_word;

            /*
             * Sink information
             */
            if(sinkNode){
                sink_ = 1;
                temp = pos_dist_;
                _numnodes = numnodes_;
                pos_dist_ = CENTER;
                numnodes_ = 1;
            }
            /*
             * Motion activation definition
             */

            if(move)
                motion = 1;

                 the_word = ""+sink_+"@"+
                 tree_sel_+"@"+
                 numnodes_+"@"+
                 comm_rad_+"@"+
                 sense_rad_+"@"+
                 interquery_time_+"@"+
                 pos_dist_+"@"+
                 mean_x+"@"+
                 mean_y+"@"+
                 pos_param+"@"+
                 _width+"@"+
                 _height+"@"+
                 energy_dist_+"@"+
                 energy_max+"@"+
                 energy_mean+"@"+
                 energy_param+"@"+
                 weight_metric1+"@"+
                 weight_metric2+"@"+
                 motion+"@"+
                 _energy_model+"@"+
                 _comm_model+"@\n";
                 if(sink_==0)
                    node_creation_words.add(the_word);
                 else
                    sink_creation_words.add(the_word);

                 view.update(Observer.UPDATE_NODE_CREATION_WORDS, "");

                 if(sinkNode){
                    pos_dist_ = temp;
                    numnodes_ = _numnodes;
                }
        }

   
     /*public the_sim getSim(){
         return mysim;
     }*/
    
    public void selectSimulator(){
    
        
         simulator.SetHandler(TC_PROTOCOL,selected_TCprotocol);
         
         if(selected_TCprotocol == PROTOCOL_ECDS ||selected_TCprotocol == PROTOCOL_CDS_RULEK){
            view.update(Observer.SHOW_SORTING_MODE, METRIC1_ONLY);//jComboBox5.setSelectedIndex(METRIC1_ONLY);
            mysim.sortingmode = METRIC1_ONLY;
         }
        
         if(selected_TMprotocol != TM_PROTOCOL_NO_SELECTED)
            simulator.SetHandler(TM_PROTOCOL,selected_TMprotocol);
         
         if(selected_SDprotocol != SENSOR_PROTOCOL_NO_SELECTED)
            simulator.SetHandler(SENSOR_PROTOCOL,selected_SDprotocol);
         
         if(selected_COMMprotocol != COMM_PROTOCOL_NO_SELECTED)
            simulator.SetHandler(COMM_PROTOCOL,selected_COMMprotocol);

         if(selected_Motionprotocol != MOTION_PROTOCOL_NO_SELECTED)
            simulator.SetHandler(MOTION_PROTOCOL,selected_Motionprotocol);
         
    }

    public void setBatchSimAttributes(double alpha_ini, double alpha_fin,
            double alpha_step, int multiplicity, String report_descriptor){
        this.alpha_ini = alpha_ini;
        this.alpha_fin = alpha_fin;
        this.alpha_step = alpha_step;
        mysim.multiplicity = multiplicity;
        this.report_descriptor = report_descriptor;
    }

    public void batchSimulation(){
        if(num_files_topology_from_batch>0){
            timestamp t = new timestamp();
            String the_path;
            
            int k=0;

            if( allAlphas){

           

                    mysim.alpha_coverage_value = alpha_ini;
                    mysim.total_alpha = (int)java.lang.Math.round(java.lang.Math.abs((alpha_fin-alpha_ini)/alpha_step))+1;

                    if(mysim.total_alpha < 1)
                        mysim.total_alpha =1;

                
            }else{


                mysim.alpha_coverage_value = alpha_ini;
                alpha_fin = alpha_ini;
                mysim.total_alpha =1;

            }


            batch_simulation=true;
            mysim.multiplicity = 1;
            

            total_num_topologies = num_files_topology_from_batch*mysim.multiplicity;
            view.update(Observer.SIMULATION_PROGRESS_BAR_MAX, total_num_topologies);//jProgressBar1.setMaximum(total_num_topologies);
            view.update(Observer.SIMULATION_PROGRESS_BAR, 0);//jProgressBar1.setValue(0);
            view.update(Observer.SIMULATION_PROGRESS, "Progress: 0 of "+total_num_topologies+" files.");//jLabel50.setText("Progress: 0 of "+total_num_topologies+" files.");


            current_topology_from_batch=0;
            view.update(Observer.SET_STATS_LOG, "");

            the_parent_dir = myFiles[0].getParent();
            the_name2 = report_descriptor + "_" + t.toString2();

              try{
                if(save_stats){
                    if(excel_ready_reports)
                        fout_log_stat = new FileWriter(the_parent_dir+"\\stats_"+the_name2+".csv");
                    else
                        fout_log_stat = new FileWriter(the_parent_dir+"\\stats_"+the_name2+".atar");
                    mywrite_log_stat = new BufferedWriter(fout_log_stat);
                    mywrite_log_stat.write(getStatsHeaderForExcel());
                }else
                    view.update(Observer.SHOW_STATS_LOG, getStatsHeaderForExcel());

                //Save the lifetime log of several simulations
                if(save_lifetime_log){
                    fout_log_lt = new FileWriter(the_parent_dir+"\\lifetime_"+total_num_topologies+"_"+the_name2+".csv");
                    mywrite_log_lt = new BufferedWriter(fout_log_lt);
                }

                if(save_results_log){
                    fout_log_results = new FileWriter(the_parent_dir+"\\results_"+total_num_topologies+"_"+the_name2+".csv");
                    mywrite_log_results = new BufferedWriter(fout_log_results);
                }

            }catch(Exception ex){ex.printStackTrace();}

            int j, i;
            for(j=0;j<myFiles.length;j++){

                        if(!myFiles[j].isDirectory()){

                            /*
                             * This cycle works for multiple executions on the same network
                             */

                            the_path = myFiles[j].getPath();
                            the_parent_dir = myFiles[j].getParent();
                            the_name = myFiles[j].getName();
                            the_name2 = myFiles[j].getName() + "_" + t.toString2();

                            /*for(i=0;i<multiplicity;i++){

                                LoadDeployment(the_path);

                                view_active_tree=true;
                                myPanel.setActiveNodes(true);
                                myPanel.setAtarraya(true);

                                jCheckBox1.setSelected(true);
                                jCheckBox3.setSelected(true);
                                jCheckBox10.setSelected(true);

                                try{

                                    if(save_events_log){
                                        fout_log_ev = new FileWriter(the_parent_dir+"\\events_"+the_name2+".csv");
                                        mywrite_log_ev = new BufferedWriter(fout_log_ev);
                                    }

                                }catch(Exception ex){ex.printStackTrace();}

                                selectSimulator();
                                sim_assigned = true;
                                clock=0;
                                StartSimulation();

                            }*/

                            LoadDeployment(the_path);
                            for(i=0;i<mysim.multiplicity;i++){

                                mysim.alpha_coverage_value = alpha_ini;
                                for(k=0;k<mysim.total_alpha;k++){

                                view.update(Observer.SET_VIEW_ACTIVE_TREE, true);//view_active_tree=true;
                                view.update(Observer.SET_ACTIVE_NODES, true);//myPanel.setActiveNodes(true);
                                view.update(Observer.SET_ATARRAYA, true);//myPanel.setAtarraya(true);
                              
                                try{

                                    if(save_events_log){
                                        fout_log_ev = new FileWriter(the_parent_dir+"\\events_"+the_name2+".csv");
                                        mywrite_log_ev = new BufferedWriter(fout_log_ev);
                                    }

                                }catch(Exception ex){ex.printStackTrace();}

                                selectSimulator();
                                sim_assigned = true;
                                clock=0;
                                StartSimulation();

                                reset_topology();
                                mysim.alpha_coverage_value = mysim.alpha_coverage_value + alpha_step;

                                }

                            }

                        }
                    }
        }
        view.update(Observer.CLEAR_SIM, "");//clear_all_sim();
    }

    /*
     * BFS graph visiting technique. If the count of the nodes visited is less that the number of points, is not connected.
     */
    public int BFS(int mode_BFS){
        int t = 0,i=0, max=0,tam=0,j=0, temp2=0, k=0;

        if(mysim.numsinks>0)
            tam = mysim.numpoints;
        else
            tam = mysim.numnodes;

        if(mode_BFS >1){
             i=mysim.numnodes;
             //BFS in order to find the greates component, starting only from a sink node
            while(i<tam){
                temp2 = mysim.num_sinks_per_tree[j];
                t=0;
                for(k=0;k<temp2;k++){

                    if(mysim.getNode(i+k).getStateBFS() == S_NOT_VISITED){
                        t+= BFS(mode_BFS, i+k);

                        if(t > max)
                            max=t;
                    }
                }
                i+=temp2;
                j++;
            }
        }else{
            //BFS in order to find the greates component, not only starting from a sink node
            for(i=0; i<tam;i++){
                if(mysim.getNode(i).getStateBFS() == S_NOT_VISITED){
                    t = BFS(mode_BFS, i);

                    if(t > max)
                        max=t;

                }
            }
        }

        if(save_lifetime_log || mysim.view_covered_area_stat || save_stats){
            mysim.covered_area_from_sink_c = calc_coverage_area_BFS(0);
            mysim.covered_area_from_sink_s = calc_coverage_area_BFS(1);
        }

        for(i=0;i<tam;i++){
                mysim.getNode(i).setStateBFS(S_NOT_VISITED);
            }
        temp_ids.clear();

        return max;
    }

        public int BFS(int mode_BFS, int node){

            temp_ids.clear();
            int temp_id, temp_id2,temp_num_neighb,i,count=0, temp_tree,templevel=0;

            temp_ids.add(node);
            mysim.getNode(node).setStateBFS(S_VISITED);
            mysim.getNode(node).setLevelBFS(templevel);

            if(mode_BFS == BFS_MODE_ACTIVE_ALIVE_OPTIMAL)
                temp_tree = -1;
            else
                temp_tree = mysim.getNode(node).getActiveTree();

            while(temp_ids.size()>0){
                count++;
                temp_id = temp_ids.get(0);
                temp_ids.remove(0);

                if(mode_BFS == BFS_MODE_ACTIVE_ALIVE_FROM_SINKS_CHILDREN_ONLY){
                    temp_num_neighb = mysim.getNode(temp_id).getNumNeighbors();
                    templevel = mysim.getNode(temp_id).getLevelBFS();

                    for(i=0;i<temp_num_neighb;i++){
                        temp_id2 = mysim.getNode(temp_id).getNeighborID(i);
                        if(mysim.getNode(temp_id2).getStateBFS()!=S_VISITED && mysim.getNode(temp_id2).isActive(temp_tree) && mysim.getNode(temp_id2).isAlive() && mysim.getNode(temp_id2).getDefaultGateway(temp_tree)== temp_id){
                            temp_ids.add(temp_id2);
                            mysim.getNode(temp_id2).setStateBFS(S_VISITED);
                            mysim.getNode(temp_id2).setLevelBFS(templevel+1);
                        }

                    }


                }else{
                    temp_num_neighb = mysim.getNode(temp_id).getNumNeighbors();
                    templevel = mysim.getNode(temp_id).getLevelBFS();

                    for(i=0;i<temp_num_neighb;i++){
                        temp_id2 = mysim.getNode(temp_id).getNeighborID(i);
                        if(mode_BFS == BFS_MODE_ACTIVE_ALIVE || mode_BFS == BFS_MODE_ACTIVE_ALIVE_FROM_SINKS || mode_BFS == BFS_MODE_ACTIVE_ALIVE_OPTIMAL){
                            if(mysim.getNode(temp_id2).getStateBFS()!=S_VISITED && mysim.getNode(temp_id2).isActive(temp_tree) && mysim.getNode(temp_id2).isAlive()){
                                temp_ids.add(temp_id2);
                                mysim.getNode(temp_id2).setStateBFS(S_VISITED);
                                mysim.getNode(temp_id2).setLevelBFS(templevel+1);
                            }
                        }else{
                                if(mysim.getNode(temp_id2).getStateBFS()!=S_VISITED){
                                temp_ids.add(temp_id2);
                                mysim.getNode(temp_id2).setStateBFS(S_VISITED);
                                mysim.getNode(temp_id2).setLevelBFS(templevel+1);
                            }
                        }
                    }
                }
            }

            return count;
        }

        public int calc_BFS(){

            int i=0, t = 0;
            int temp=0, max=0, tam=0;

            if(mysim.numsinks>0)
                tam = mysim.numpoints;
            else
                tam = mysim.numnodes;

            for(i=0;i<tam;i++){
                if(getNode(i).getStateBFS() == S_NOT_VISITED){
                    temp=BFS(BFS_MODE_STANDARD,i);
                }
                if(temp>max)
                    max = temp;
            }

            for(i=0;i<mysim.numpoints;i++){
                    getNode(i).setStateBFS(S_NOT_VISITED);
                }
            temp_ids.clear();

            return max;
        }
        
        public double calc_coverage_area_BFS(int mode){
    
            int i,j,k=0, temp_tree=0;
            double count=0;
            boolean sw=true;
            int x=0,y=0,range=0, dia=0;
            int tx=0,ty=0, temp=0;
            int desp_x=0, desp_y=0;

            for(i=0;i<mysim.w;i++){
                for(j=0;j<mysim.h;j++){
                    mysim.mat_area[i][j] = 0;
                }
            }

            for(k=0;k<mysim.numpoints;k++){
                temp_tree = getNode(k).getActiveTree();

                //if(getNode(k).isActive(temp_tree)){
                if(getNode(k).getStateBFS() == S_VISITED){
                    //Coordinates of the center of the comm range
                    x = (int)getNode(k).getPosition().getX();
                    y = (int)getNode(k).getPosition().getY();

                    if(mode==0){
                        //Radius of the comm range
                        range = (int)getNode(k).getRadius(temp_tree);
                    }else if(mode==1)
                        range = (int)getNode(k).getSense_Radius();

                    dia = range*2-1;

                    //coordinates od the upper corner of a square containing the comm area
                    tx = x-range;
                    ty = y-range;

                    //Distance from a corner to the circunference
                    temp = (int)java.lang.Math.floor(range*0.4147);

                    for(i=0;i<=range;i++){
                        for(j=0;j<=i;j++){

                            //upper left corner checking
                            desp_y = ty+i-j;
                            desp_x = tx+j;
                            //upper left corner checking
                            if(mysim.getMatArea(desp_y, desp_x) == 0){
                                if(getNode(k).covers(desp_x, desp_y,mode)){
                                    mysim.mat_area[desp_y][desp_x] = 1;
                                }
                            }
                            desp_y = y-i+j;
                            desp_x = x-j;
                            if(mysim.getMatArea(desp_y, desp_x) == 0){
                                mysim.mat_area[desp_y][desp_x] = 1;
                            }

                            //upper right corner checking
                            desp_y = ty+i-j;
                            desp_x = tx+dia-j;
                            //upper left corner checking
                            if(mysim.getMatArea(desp_y, desp_x) == 0){
                                if(getNode(k).covers(desp_x, desp_y,mode)){
                                    mysim.mat_area[desp_y][desp_x] = 1;
                                }
                            }
                            desp_y = y-i+j;
                            desp_x = x+j;
                            if(mysim.getMatArea(desp_y, desp_x) == 0){
                                mysim.mat_area[desp_y][desp_x] = 1;
                            }

                            //lower left corner checking
                            desp_y = ty+dia-i+j;
                            desp_x = tx+j;
                            //upper left corner checking
                            if(mysim.getMatArea(desp_y, desp_x) == 0){
                                if(getNode(k).covers(desp_x, desp_y,mode)){
                                    mysim.mat_area[desp_y][desp_x] = 1;
                                }
                            }
                            desp_y = y+i-j;
                            desp_x = x-j;
                            if(mysim.getMatArea(desp_y, desp_x) == 0){
                                mysim.mat_area[desp_y][desp_x] = 1;
                            }


                            //lower right corner checking
                            desp_y = ty+dia-i+j;
                            desp_x = tx+dia-j;
                            //upper left corner checking
                            if(mysim.getMatArea(desp_y, desp_x) == 0){
                                if(getNode(k).covers(desp_x, desp_y,mode)){
                                    mysim.mat_area[desp_y][desp_x] = 1;
                                }
                            }
                            desp_y = y+i-j;
                            desp_x = x+j;
                            if(mysim.getMatArea(desp_y, desp_x) == 0){
                                mysim.mat_area[desp_y][desp_x] = 1;
                            }


                        }
                    }

                }
            }

            for(i=0;i<mysim.w;i++){
                for(j=0;j<mysim.h;j++){
                    count += mysim.mat_area[i][j];
                }
            }

            return count/((double)(mysim.h*mysim.w));
        }

        public int BuildNeighborhood (int nodeID){
            int i;
            setContNeighb(0);


            //contNeighb = getNode(nodeID).getNumNeighbors();

            //Remove all previous neighbors from the max power graph
            //for(i=0;i<contNeighb;i++){
              //  myPanel.removeLine(nodeID,getNode(nodeID).getNeighborID(i));
            //}

            view.update(Observer.REMOVE_NODE_LINES, nodeID);//myPanel.removeAllLinesFromSource(nodeID);
            Vector v = new Vector(2);
            //Remove all previous neighbors from the node's data structure
            getNode(nodeID).cleanNeighbors();
            
            //Regenerate the neighborhood on the max power graph
            for(i=0;i<getNumpoints();i++){
                if(i!=nodeID){
                if(getNode(nodeID).isNeighbor2(getNode(i))){
                    if(!isBatch_creation())
                        v.clear();
                        v.add(nodeID);
                        v.add(i);
                        view.update(Observer.ADD_LINE, v);//myPanel.addLine(nodeID,i);
                        setContNeighb(getContNeighb()+1);
                    }
                }
                
            }
            
            getNode(nodeID).SortNeighbors();
            return (int)mysim.contNeighb;
        }

        public void broadcast(double final_time, double current_time, int _sender, int _destination, int _code,int _type){
            broadcast(final_time, current_time, -1,-1,_sender, _destination, _code, "",-1,_type);
        }

        public void broadcast(double final_time, double current_time, int _sender, int _destination, int _code, int _tree,int _type){
            broadcast(final_time, current_time, -1,-1,_sender, _destination, _code, "",_tree,_type);
        }

        public void broadcast(double final_time, double current_time, int _sender, int _destination, int _code, String _data,int _type){
            broadcast(final_time, current_time,-1, -1,_sender, _destination, _code, _data,-1,_type);
        }

        public void broadcast(double final_time, double current_time, int _sender, int _destination, int _code, String _data, int _tree,int _type){
            broadcast(final_time, current_time, -1,-1, _sender, _destination, _code, _data,_tree,_type);
        }


        public void broadcast(double final_time, double current_time, int _source, int _final_destination, int _sender, int _destination, int _code, String _data, int _tree, int _type){

            int numneighb, i, temp_ID,j;
            int size_packet;

            int numrx = 1;

            // If the node is alive and has its radio on...
            //if(getNode(sender).isAlive() && getNode(sender).isRadioOn(_tree)){
            if(getNode(_sender).isAlive()){

                
                //Obtain the radius of the particular transmission range in which the node is working on a particular tree

                //temp_radius=getNode(_sender).getRadius(_tree);

                size_packet = simulator.GetMessageSize(_code, _type);

                //prob_error = 1-java.lang.Math.pow(1-mysim.bit_error_rate,8*size_packet);

                numneighb = getNode(_sender).getNumNeighbors();

                //The sender is defining the next step on the path. Having destination == -2 only happens in DATA messages events.
                if(_destination == -2){
                        _destination = getNode(_sender).getGateway(_tree, _final_destination);
                    }

                if(this.selected_comm_model!=this.SIMPLE_COMM_MODEL)
                    numrx = CalcNumTx(_sender, _destination, size_packet);

                for(j=0;j<numrx;j++){
                    mysim.Push(new event_sim(final_time+(j*this.MAX_TX_DELAY_RANDOM), current_time, _source,_final_destination, _sender, _destination, -1, _code, _data,_tree,_type, OPER_TX));

                    for(i=0;i<numneighb;i++){
                        temp_ID = getNode(_sender).getNeighborID(i);
                    
                        //Program the event of a node receiving the message if the receiver is awake
                        mysim.Push(new event_sim(final_time+(j*this.MAX_TX_DELAY_RANDOM)+getRandom(DELTA_TIME), current_time, _source,_final_destination, _sender, _destination, temp_ID, _code, _data,_tree,_type, OPER_RX));
                    }
                    
                }

        }

        }

        public int CalcNumTx(int sender, int receiver, int size){
 
            if(receiver == -1){
                receiver = getNode(sender).getFarthestNeighbor();
            }
            
             double ber = getNode(sender).getNeighborFromID(receiver).getBer();
             double prob_error = 1.0-java.lang.Math.pow(1.0-ber,8*size);
             
            
             //The number of TX trials is given by the expecter value of the geometric function and limited by the parameter max_retx
             int count=(int)java.lang.Math.round(java.lang.Math.min(max_retx, 1/prob_error));

             //System.out.println(""+max_retx+", "+1/prob_error+", "+count);
             
             /*while(prob_error > 0.1){
                 prob_error=prob_error*0.95;
                 count++;
             }*/

             return count;

         }
        
        public void resetCommRange(int nodeID, int new_range){

            getNode(nodeID).setRadius(new_range);
            BuildNeighborhood(nodeID);
        }

        public void reset_topology(){

            int i=0;

            //Restart every node on the topology
            for(i=0;i<mysim.numpoints;i++){
                getNode(i).reset_all_node();
            }
            for(i=0;i<mysim.numpoints;i++){
                BuildNeighborhood(i);
            }
            //Repaint the topology
            view.update(Observer.REPAINT, "");//myPanel.repaint();

            //Notify Atarraya that a new topology has been loaded
            topology_loaded = true;

            //Notify Atarraya that this will be the first atempt to start this topology... remember that
            // when the Start Atarraya button is pressed several times, it will try to start each of the
            // possibles VNI on the topology. Bu turning this value to -1, the first one will the VNI 0.
            treeID = -1;

        }

    public boolean checkGraphConnected(){
        boolean _sw=false;
        int count = BFS(BFS_MODE_STANDARD);
        if(count<mysim.numpoints)
            view.update(Observer.CONNECTED_TOPOLOGIES, "Disconnected Topology! "+count);
        else{
            view.update(Observer.CONNECTED_TOPOLOGIES, "Connected  Topology! "+count);//jLabel36.setText("Connected  Topology! "+count);
            _sw=true;
        }
        return _sw;
    }

    public void checkEnergy(int id){


        //if(getNode(id).isAlive()){

            if(TM_Selected && simulator.getTMType() == TM_ENERGY){
                if(mysim.getNode(id).checkTMEnergy()){
                    int tree=mysim.getNode(id).getActiveTree();
                    pushEvent(new event_sim(clock+getRandom(PROCESSING_DELAY), clock,id,id,id, SEND_REACTIVATE_MESSAGE,"",tree,TM_PROTOCOL));
                    addStatToLifetimeLogEvent();
                }
            }

            if(mysim.getNode(id).getEnergyRatio()<DEATH_THSLD_ENERGY && !mysim.getNode(id).isSink()){
                mysim.getNode(id).setDead();
                mysim.count_dead++;
                addStatToLifetimeLogEvent();

            }

        //}
            
    }

    public void clean_creation_words(){

        node_creation_words.clear();
        sink_creation_words.clear();
        view.update(Observer.CLEAN_CREATION_WORDS, "");
    }

    public boolean checkSolution(int total_active){

        int count=0, i=0, numneigh=0, j=0, temp=0, temp_id=0;
        boolean sw=true;


        //Checking if every node has at least one active node on its neghborhood
        while(i<mysim.numnodes && sw){
            temp=0;
            numneigh = getNode(i).getNumNeighbors();
            for(j=0;j<numneigh;j++){
                temp_id = getNode(i).getNeighborID(j);
                if(getNode(temp_id).isActive(-1))
                    temp++;
            }
            //There is a node with no active neighbors, so it is not covered!
            if(temp == 0)
                sw=false;
            i++;
        }

        if(sw){
            //Check the size of the BFS of active nodes.
            count = BFS(BFS_MODE_ACTIVE_ALIVE_OPTIMAL);
            if(count < total_active)
                return false;
            else
                return true;
        }
        return false;
    }

    public solution generateSolution(int num){

        solution new_sol = new solution(mysim.numpoints);

        int temp=0;
        int temp_num = num;

        // Generate Solution!!

        for(int i=mysim.numnodes-1; i>=0; i--){
            temp = temp_num/(int)java.lang.Math.pow(2, i);
            temp_num-= temp*(int)java.lang.Math.pow(2, i);
            new_sol.set(i, temp);
        }

        return new_sol;

    }

    public void CountNotVisited(){
        mysim.CountNotVisited();
    }

    public void CreatePositionFiles(){

        int i=0;
        int j=0,l=0;
        int numfiles=0;
        String the_path="";
        String the_name3="";
        timestamp t;
        String st="";
        String temp, the_file;
        String[] temp_read;
        int positionx, positiony, temp_trees, temp_num_sinks;

         view.update(Observer.SET_MYFILES, "");

        if (myFiles != null) {
        
            numfiles = myFiles.length;

            for(i=0;i<numfiles; i++){

                try{
                    fin = new FileReader(myFiles[i]);
                    myread = new BufferedReader(fin);

                    fout = new FileWriter(myFiles[i].getParent()+"\\Positions_" + myFiles[i].getName()+".csv");
                    mywrite = new BufferedWriter(fout);

                    temp = myread.readLine();

                    if(temp!=null){

                        mysim.numnodes = Integer.parseInt(temp);
                        view.update(Observer.SHOW_NUM_NODES, ""+mysim.numnodes);//jLabel6.setText(""+mysim.numnodes);

                        temp = myread.readLine();
                        temp_trees = Integer.parseInt(temp);

                        mysim.numsinks=0;
                        for(l=0;l<temp_trees;l++){
                            temp = myread.readLine();
                            temp_num_sinks = Integer.parseInt(temp);
                            mysim.num_sinks_per_tree[l] = temp_num_sinks;
                            mysim.numsinks+=temp_num_sinks;
                        }

                        temp = myread.readLine();
                        radius = Integer.parseInt(temp);
                        //jLabel7.setText(""+radius);

                        temp = myread.readLine();
                        sense_radius = Integer.parseInt(temp);

                        temp = myread.readLine();
                        //h = Integer.parseInt(temp);

                        temp = myread.readLine();
                        //w = Integer.parseInt(temp);

                        //Updating range areas for visual effects
                        //myPanel.setRangeArea(false, false);

                        //Updating the total number of points in the area = nodes + sinks
                        mysim.numpoints = mysim.numnodes + mysim.numsinks;

                        st=""+mysim.numpoints+"\n"+radius+"\n"+sense_radius+"\n";

                        for(j=0;j<mysim.numpoints;j++){

                            temp = myread.readLine();
                            temp_read = temp.split("@");

                            positionx = Integer.parseInt(temp_read[0]);
                            positiony = Integer.parseInt(temp_read[1]);

                            st = st+positionx+","+positiony+"\n";

                        }

                        mywrite.write(st);

                        mywrite.flush();
                        mywrite.close();
                        fout.close();

                        fin.close();
                    }

                }catch(Exception e){e.printStackTrace();}

            }

            view.update(Observer.PRINT_MSG, "Positions List saved");

        }

    }

    public void ExecuteMST(){

        int i,j,tam,temp_id;
        double temp_dist;
        edge temp_edge;

        Vector<edge> edges_list = new Vector<edge>();
        Vector<edge> selected_edges_list = new Vector<edge>();

        for(i=0;i<mysim.numpoints;i++){
            getNode(i).setFragmentID(i);

            tam = getNode(i).getNumNeighbors();

            for(j=0;j<tam;j++){

                temp_id = getNode(i).getNeighborID(j);

                if(temp_id>i){
                    temp_dist = getNode(i).getNeighborDistance(j);

                    edges_list.add(new edge(i,temp_id, temp_dist));
                }

            }

        }

        java.util.Collections.sort(edges_list);

        while(edges_list.size() > 0){

            temp_edge = edges_list.firstElement();

            if(getNode(temp_edge.getX()).getFragmentID() != getNode(temp_edge.getY()).getFragmentID()){
                selected_edges_list.add(temp_edge);
                updateFragment(getNode(temp_edge.getX()).getFragmentID(), getNode(temp_edge.getY()).getFragmentID());
                getNode(temp_edge.getX()).addGateway(0, temp_edge.getY(),0);
                getNode(temp_edge.getY()).addGateway(0, temp_edge.getX(),0);
            }

            edges_list.removeElementAt(0);
        }

        temp_dist=0;
        for(i=0;i<selected_edges_list.size();i++){
            temp_dist+= selected_edges_list.get(i).getZ();
        }

        view.update(Observer.SHOW_SUM_OF_EDGES, "Sum of Edges: "+temp_dist);
        view.update(Observer.SET_ATARRAYA, true);


        view.update(Observer.REPAINT, "");
    }

    public void updateFragment(int oldFragment, int newFragment){
        int i;

        for(i=0; i<mysim.numpoints ; i++){
            if(getNode(i).getFragmentID() == oldFragment)
                getNode(i).setFragmentID(newFragment);
        }

    }

    public double fact(int n){

        int i=1;
        double temp=1;

        for(i=1;i<n;i++)
            temp*=i;

        return temp;
    }

    public double calc_combinations(int k, int n){

        return fact(n)/(fact(k)*fact(n-k));

    }

    public Point GaussianRandomGenerator(double mean1, double mean2, double _sigma){
         /*
        Box-Muller generator (1958)
        Box, G.E.P, M.E. Muller 1958; A note on the generation of random normal deviates, Annals
        Math. Stat, V. 29, pp. 610-611

        Generate a random value from a starndard gaussian Z and then,
        apply the transformation of Z into X = sigma*Z + Mu

         */

         Point tp = new Point();
        double x1, x2, w1, y1, y2;
        int x,y;

        do {
                 x1 = 2.0 * getRandom(1) - 1.0;
                 x2 = 2.0 * getRandom(1) - 1.0;
                 w1 = x1 * x1 + x2 * x2;
         } while ( w1 >= 1.0 );

         w1 = java.lang.Math.sqrt( (-2.0 * java.lang.Math.log( w1 ) ) / w1 );
         y1 = x1 * w1;
         y2 = x2 * w1;

        //transformation of Z into X = sigma*Z + Mu
        tp.x=(int)java.lang.Math.round(y1*_sigma+mean1);
        tp.y=(int)java.lang.Math.round(y2*_sigma+mean2);

        return tp;
    }

    public int PoissonRandomGenerator(double lambda){
        /*
         * Taken from wikipedia, cited from:
         * Donald E. Knuth (1969). Seminumerical Algorithms, The Art of Computer Programming, Volume 2. Addison Wesley.
         */
        double l,_p;
        int k,i;
        double u;

        l = java.lang.Math.exp(-lambda);

        _p=1;
        k=0;

        do{
            k = k+1;
            u = getRandom(1);
            _p=_p*u;
        }while(_p>=l);

        return k-1;
    }

    public double GenerateEnergy(int energy_dist, int max_energy, int mean_energy, double parameter ){

        double energy=max_energy;

        switch(energy_dist){

                //Constant distribution for energy
                case ENERGY_CONSTANT:
                       energy = java.lang.Math.min(energy, mean_energy);
                       break;

                //Normal distribution for energy
                case ENERGY_NORMAL:
                       p=GaussianRandomGenerator(mean_energy,0,parameter);
                       energy = java.lang.Math.min(max_energy,p.getX());
                       break;

                //Poisson distribution for energy
                case ENERGY_POISSON:
                       energy = java.lang.Math.min(max_energy,PoissonRandomGenerator(parameter));
                       break;

                //Uniform distribution for energy between 0 and max_energy
                case ENERGY_UNIFORM:
                        energy = java.lang.Math.min(max_energy,getRandom(max_energy));
                        break;

                }
        return energy;

    }

    public double GenerateEnergy(){

        double energy=MAX_ENERGY;

        switch(energy_distribution){

                //Constant distribution for energy
                case ENERGY_CONSTANT:
                       energy = java.lang.Math.min(MAX_ENERGY, energy_distribution_parameter);
                       break;

                //Normal distribution for energy
                case ENERGY_NORMAL:
                       p=GaussianRandomGenerator(energy_distribution_parameter,0,sigma_e);
                       energy = java.lang.Math.min(MAX_ENERGY,p.getX());
                       break;

                //Poisson distribution for energy
                case ENERGY_POISSON:
                       energy = java.lang.Math.min(MAX_ENERGY,PoissonRandomGenerator(energy_distribution_parameter));
                       break;

                case ENERGY_UNIFORM:
                        energy = java.lang.Math.min(MAX_ENERGY,getRandom(energy_distribution_parameter));
                        break;

                }
        return energy;
    }

    public void setGiantComponentTestAttributes(int num_nodes_ctr, int area_side_ctr,
            int num_topologies_ctr, double initial_ctr, double step_ctr,
            double initial_k_ctr,double final_k_ctr, double step_k_ctr, int initial_i_exp_l_ctr,
            int final_i_exp_l_ctr, boolean dense, boolean nodeDegreeRatio, boolean sparse){

        double dn=0;
        double dr=0;
        double dl=0;

        this.num_nodes_ctr = num_nodes_ctr;
        this.area_side_ctr = area_side_ctr;
        this.num_topologies_ctr = num_topologies_ctr;
        this.initial_ctr = initial_ctr;
        this.step_ctr = step_ctr;

        this.initial_k_ctr= initial_k_ctr;
        this.final_k_ctr= final_k_ctr;
        this.step_k_ctr= final_k_ctr;
        this.initial_i_exp_l_ctr= initial_i_exp_l_ctr;
        this.final_i_exp_l_ctr= final_i_exp_l_ctr;
        this.dense = dense;
        this.nodeDegreeRatio = nodeDegreeRatio;
        this.sparse = sparse;

        //CTR Dense Penrose - Santi
        ctr = java.lang.Math.sqrt((java.lang.Math.log(num_nodes_ctr)+java.lang.Math.log(java.lang.Math.log(num_nodes_ctr)))/(num_nodes_ctr*java.lang.Math.PI))*area_side_ctr;
        view.update(Observer.SHOW_CTR_DENSE_PS, ""+ctr);//jLabel32.setText(""+ctr);

        ctr =  initial_k_ctr*java.lang.Math.pow(area_side_ctr,0.75)*java.lang.Math.sqrt(java.lang.Math.log(area_side_ctr)/java.lang.Math.log(2));
        view.update(Observer.SHOW_CTR_DENSE_SANTI, ""+ctr);//jLabel80.setText(""+ctr);

        if(this.dense/*jRadioButton1.isSelected()*/)
            this.comm_radius_ctr = (int)java.lang.Math.ceil(ctr);


        //CTR Santi-Blough

        //dl = java.lang.Math.pow(2,2*initial_i_exp_l_ctr);
        dl = area_side_ctr;
        
        view.update(Observer.UPDATE_L, "L = "+dl);
        dn = java.lang.Math.sqrt(dl);
        view.update(Observer.UPDATE_N, "n = sqrt(l) = "+dn);
        ctr =  initial_k_ctr*java.lang.Math.pow(dl,0.75)*java.lang.Math.sqrt(java.lang.Math.log(dl)/java.lang.Math.log(2));
        view.update(Observer.UPDATE_R, "r = k*l^(3/4)*sqrt(log2(l)) = "+ctr);
        //ctr = java.lang.Math.pow(initial_k_ctr,2)*java.lang.Math.pow(dl, 2)*(java.lang.Math.log(dl)/java.lang.Math.log(2))/dn;
        view.update(Observer.SHOW_CTR_SPARSE_SANTI, ""+ctr);

        ctr = java.lang.Math.sqrt((java.lang.Math.log(dn)+java.lang.Math.log(java.lang.Math.log(dn)))/(dn*java.lang.Math.PI))*dl;
        view.update(Observer.SHOW_CTR_SPARSE_PS, ""+ctr);

        if(this.sparse)
            comm_radius_ctr = (int)java.lang.Math.ceil(ctr);

        
    }

    public void GiantComponentTest(){

        int i=0,j=0,k=0;
        int ctr_int=0, ctr_old=0;
        double di=0, dk=0, dl=0, dr=0, dn=0;
        double temp_bfs=0.0;
        double count_connected_ctr=0;
        double avg_bfs_size=0, percent_count_connected_ctr=0;
        Vector<Double> GC_info1 = new Vector<Double>();
        Vector<Double> GC_info2 = new Vector<Double>();
        Vector<Double> GC_info3 = new Vector<Double>();
        ctr_int = (int)java.lang.Math.round(initial_ctr*area_side_ctr);
        ctr_old = ctr_int;
        double total_avg_neighbors=0;
        String the_path="";
        batch_simulation=true;
        GC_Test = true;
        boolean sw=false;
        double total_experiments=0;
        String tempString="";
        File tempFile;
        BatchExecutor smallexec = new BatchExecutor(this);
        smallexec.start();

        timestamp t;



        /*num_nodes_ctr=100;
        area_side_ctr=100;
        comm_radius_ctr=13;
        initial_ctr = 0.01;
        step_ctr = 0.01;

        initial_k_ctr= 0.5;
        final_k_ctr= 1;
        step_k_ctr= 0.1;
        initial_i_exp_l_ctr= 4;
        final_i_exp_l_ctr= 10;*/

        /*try{
            num_nodes_ctr = Integer.parseInt(jTextField6.getText());
            area_side_ctr = Integer.parseInt(jTextField11.getText());
            num_topologies_ctr = Integer.parseInt(jTextField5.getText());
            initial_ctr = Double.parseDouble(jTextField29.getText());
            step_ctr = Double.parseDouble(jTextField10.getText());

            initial_k_ctr= Double.parseDouble(jTextField35.getText());
            final_k_ctr= Double.parseDouble(jTextField36.getText());
            step_k_ctr= Double.parseDouble(jTextField37.getText());
            initial_i_exp_l_ctr= Integer.parseInt(jTextField33.getText());
            final_i_exp_l_ctr= Integer.parseInt(jTextField34.getText());


        }catch(Exception ex){ex.printStackTrace();}*/


                //This is where a real application would open the file.

                /*-------------------------------------------------------
                 * JUST IN CASE i WOULD LIKE TO CONTINUE WITH IT...
                 * this version calculatesthe averages topology by topology, saving time on the loading, but somethign is
                 * not working properly... more time to spend later on it...
                 * ------------------------------------------------------
                for(i=0;i<100;i++){
                    GC_info1.add(0.0);
                    GC_info2.add(0.0);
                    GC_info3.add(0.0);
                    GC_info4.add(0.0);
                }

                for(i=0;i<myFiles.length;i++){
                    LoadDeployment(myFiles[i].getPath());
                    k=0;
                    ctr_int = (int)java.lang.Math.round((initial_ctr+(k*step_ctr))*area_side_ctr);
                    avg_bfs_size=0;
                    while(avg_bfs_size<100){
                        avgNeighb=0;
                        for(j=0;j<numpoints;j++){
                            getNode(j).cleanNeighbors();
                            getNode(j).setRadius(ctr_int);
                            avgNeighb += BuildNeighborhood(j);
                        }

                        temp_num_nodes_1 = GC_info4.get(k)+1.0;
                        GC_info4.set(k, temp_num_nodes_1);

                        avg_bfs_size = (double)(calc_BFS()/(double)numpoints)*100.0;
                        temp_bfs = (double)((avg_bfs_size + GC_info1.get(k)*i)/temp_num_nodes_1);
                        GC_info1.set(k, temp_bfs);

                        if(checkGraphConnected2()){
                            count_connected_ctr = (1.0+GC_info2.get(k));
                            GC_info2.set(k, count_connected_ctr);
                        }

                        total_avg_neighbors = (double)((avgNeighb/(double)numpoints + GC_info3.get(k)*i)/temp_num_nodes_1);
                        GC_info3.set(k, total_avg_neighbors);

                        while(ctr_old == ctr_int){
                            k++;
                            ctr_int = (int)java.lang.Math.round((initial_ctr+(k*step_ctr))*area_side_ctr);
                        }
                        ctr_old = ctr_int;
                        jTextField2.setText(""+ctr_int);
                        jLabel77.setText("Current CTR: "+ctr_int);
                        jTextArea2.append(""+ctr_int+","+GC_info1.lastElement()+","+GC_info2.lastElement()+","+GC_info3.lastElement()+"\n");

                    }

                }

                for(i=0;i<100;i++){
                    if(GC_info4.get(i)==0.0){
                        GC_info1.set(i,GC_info1.get(i-1));
                        GC_info2.set(i,GC_info2.get(i-1));
                        GC_info3.set(i,GC_info3.get(i-1));
                        GC_info4.set(i,GC_info4.get(i-1));
                    }
                }

                for(i=0;i<100;i++){
                    count_connected_ctr = (double)(GC_info2.get(i)/GC_info4.get(i))*100.0;
                    GC_info2.set(i,count_connected_ctr);
                }
                */

                if(dense){
                    //GC on Dense Networks

                    view.update(Observer.SET_FILE_SELECTION_MODE, javax.swing.JFileChooser.DIRECTORIES_ONLY);
                    view.update(Observer.SET_MYFILE, "");

                     /*jFileChooser1.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);

                     l = jFileChooser1.showOpenDialog(this);*/


                    if (myFile != null) {
                       
                        //Generate the topologies here according to the definitions

                        //Regular n nodes
                        
                        numnodes_ = num_nodes_ctr;

                        //Communication radius
                        comm_rad_ = comm_radius_ctr;

                        //Setting the side of the square deployment area
                        _height = area_side_ctr;
                        _width = area_side_ctr;

                        //Reseting the creations words
                        clean_creation_words();

                        //Adding the regular nodes
                        addNodeCreationWord();

                        //Adding one sink in a random position
                        sinkNode = true;
                        //No sinks required for this operation
                        numnodes_ = 0;
                        addNodeCreationWord();
                        sinkNode = false;

                        //Set number of topologies in the Batch Creation field
                        numTopologies = num_topologies_ctr;
                        //Enable the Batch Creation Field
                        batch_creation = true;
                        //Disable the option for stoping creation after max trials
                        checkTrials = false;
                        //Disable checking for connectivity
                        check_connectivity = false;


                        view.update(Observer.SHOW_CREATING_TOPOS, "Creating Topologies...");

                        if(myFile.isDirectory())
                            the_path = myFile.getPath();
                        else
                            the_path = myFile.getParent();

                        t = new timestamp();
                        tempString = the_path+"\\test_"+t.toString2();
                        tempFile = new File(tempString);
                        
                        if(tempFile.mkdir())
                            the_path = tempFile.getPath();



                        smallexec.setParamsForBatchCreation(num_topologies_ctr, the_path);
                        smallexec.setWork(GENERATE_TOPOS);
                        smallexec.setEnd();
                        view.update(Observer.TOPOLOGY_PROGRESS_BAR_MAX, num_topologies_ctr);
                        view.update(Observer.TOPOLOGY_PROGRESS_BAR, 0);


                        try{
                            sem_GC.acquire();
                        }catch(Exception ex){ex.printStackTrace();}

                        myFiles = tempFile.listFiles();

                        view.update(Observer.SHOW_CREATING_TOPOS, "Calculating GC test...");


                        while(avg_bfs_size<100){
                            count_connected_ctr=0;
                            temp_bfs=0;
                            avg_bfs_size=0;
                            num_topologies_ctr=0;

                            for(i=0;i<myFiles.length;i++){

                                if(filter.accept(myFiles[i])){

                                    LoadDeployment(myFiles[i].getPath(), ctr_int);

                                    if(nodeDegreeRatio)
                                        total_avg_neighbors += mysim.avgNeighb/(double)mysim.numpoints;
                                    else
                                        total_avg_neighbors += mysim.avgNeighb;

                                    if(checkGraphConnected())
                                        count_connected_ctr++;
                                    temp_bfs += calc_BFS();

                                    num_topologies_ctr++;

                                }

                            }

                            avg_bfs_size = (double)((temp_bfs/i)/(double)mysim.numpoints)*(double)(100.0);
                            percent_count_connected_ctr = (double)((count_connected_ctr/i)*(double)(100.0));
                            if(nodeDegreeRatio)
                                total_avg_neighbors = (total_avg_neighbors/((double)num_topologies_ctr))*100.0;
                            else
                                total_avg_neighbors = (total_avg_neighbors/((double)num_topologies_ctr));

                            GC_info1.add(avg_bfs_size);
                            GC_info2.add(percent_count_connected_ctr);
                            GC_info3.add(total_avg_neighbors);

                            while(ctr_old == ctr_int){
                                j++;
                                ctr_int = (int)java.lang.Math.round((initial_ctr+(j*step_ctr))*area_side_ctr);
                            }
                            ctr_old = ctr_int;
                            comm_rad_ = ctr_int;
                            view.update(Observer.SHOW_CURRENT_CTR, "Current CTR: "+ctr_int);
                            view.update(Observer.SHOW_STATS_LOG, ""+ctr_int+","+GC_info1.lastElement()+","+GC_info2.lastElement()+","+GC_info3.lastElement()+"\n");

                        }

                        try{

                            fout = new FileWriter(the_path+"\\GC_"+t.toString2()+".csv");
                            mywrite = new BufferedWriter(fout);
                            mywrite.write("Radius, MaxComponentSize, ConnectedTopologies, AverageNodeDegree\n");

                            temp_bfs = GC_info1.size();
                            for(i=0;i<temp_bfs;i++){
                                ctr_int = (int)java.lang.Math.round((initial_ctr+(i*step_ctr))*area_side_ctr);
                                mywrite.write(""+ctr_int+","+GC_info1.get(i)+","+GC_info2.get(i)+","+GC_info3.get(i)+"\n");
                            }

                            mywrite.flush();
                            mywrite.close();
                            fout.close();

                        }catch(Exception ex){ex.printStackTrace();}

                        view.update(Observer.PRINT_MSG, "GC stat created!!");

                    } else {
                        view.update(Observer.SHOW_MSG, "Open command cancelled by user.");
                    }

                     view.update(Observer.SET_FILE_SELECTION_MODE, javax.swing.JFileChooser.FILES_AND_DIRECTORIES);//jFileChooser1.setFileSelectionMode(javax.swing.JFileChooser.FILES_AND_DIRECTORIES);

            } else if(sparse){
                //GC on Sparse Networks
                view.update(Observer.SET_FILE_SELECTION_MODE, javax.swing.JFileChooser.DIRECTORIES_ONLY);
                view.update(Observer.SET_MYFILE, "");
                


                if (myFile != null) {
                    


                    total_experiments = java.lang.Math.round((final_i_exp_l_ctr-initial_i_exp_l_ctr+1)*((final_k_ctr-initial_k_ctr+step_k_ctr)/step_k_ctr));

                    di = initial_i_exp_l_ctr;

                    while(di <= final_i_exp_l_ctr){


                        //Updating parameters L y n, or dl and dn.
                        dl = java.lang.Math.pow(2,(2*di));
                        view.update(Observer.UPDATE_L, "L=2^(2*i) = "+dl);
                        dk = initial_k_ctr;
                        dn = java.lang.Math.round(java.lang.Math.sqrt(dl));
                        view.update(Observer.UPDATE_N, "n = sqrt(l) = "+dn);

                        //Setting the side of the square deployment area
                        _width = (int)dl;
                        
                        _height = (int)dl;

                        while (dk <= final_k_ctr){

                            //Reseting the counter values for the combination of l and k.
                            count_connected_ctr=0;
                            temp_bfs=0;
                            avg_bfs_size=0;
                            total_avg_neighbors=0;

                            //Updating the radius because it depends on K, or dk in this case
                            dr = java.lang.Math.round(dk * java.lang.Math.pow(dl,0.75)*java.lang.Math.sqrt(java.lang.Math.log(dl)/java.lang.Math.log(2)));
                            view.update(Observer.UPDATE_R, "r = k*l^(3/4)*sqrt(log2(l)) = "+dr);

                            //Communication radius
                            comm_rad_ = (int)dr;

                            //Regular n nodes... need to update here because the 0 I had to put for the sink creation word.
                            numnodes_ = (int)dn;

                            //Reseting the creations words
                            clean_creation_words();

                            //Adding the regular nodes
                            addNodeCreationWord();

                            //Adding one sink in a random position
                            sinkNode = true;
                            //No sinks required for this operation
                            numnodes_ = 0;
                            addNodeCreationWord();
                            sinkNode =false;

                            //Disable the option for stoping creation after max trials
                            checkTrials = false;
                            //Enable checking for connectivity, just in case it was disabled
                            check_connectivity = true;

                            for(i=0; i<num_topologies_ctr; i++){

                                view.update(Observer.CLEAR_SIM, "");
                                sw = NodeGenerator();

                                if(sw)
                                    count_connected_ctr++;

                                temp_bfs += calc_BFS();

                                if(nodeDegreeRatio)
                                        total_avg_neighbors += mysim.avgNeighb/(double)mysim.numpoints;
                                    else
                                        total_avg_neighbors += mysim.avgNeighb;

                                view.update(Observer.SHOW_CREATING_TOPOS, "Calculating GC test: Evaluating "+(GC_info1.size()+1)+" of "+total_experiments);

                            }

                            avg_bfs_size = (temp_bfs/(dn*num_topologies_ctr))*(100.0);
                            percent_count_connected_ctr = (count_connected_ctr/((double)num_topologies_ctr))*(100.0);
                            if(nodeDegreeRatio)
                                total_avg_neighbors = (total_avg_neighbors/((double)num_topologies_ctr))*(100.0);
                            else
                                total_avg_neighbors = (total_avg_neighbors/((double)num_topologies_ctr));

                            GC_info1.add(avg_bfs_size);
                            GC_info2.add(percent_count_connected_ctr);
                            GC_info3.add(total_avg_neighbors);

                            dk+=step_k_ctr;
                        }

                        di++;

                    }


                try{
                    t = new timestamp();
                    fout = new FileWriter(myFile.getPath()+"\\GC_"+t.toString2()+".csv");
                    mywrite = new BufferedWriter(fout);

                    i=0;
                    dk = initial_k_ctr;
                    while(dk <= final_k_ctr){

                        tempString = tempString+",GC K="+dk;

                        dk+=step_k_ctr;
                    }

                    dk = initial_k_ctr;
                    while(dk <= final_k_ctr){

                        tempString = tempString+",CT K="+dk;

                        dk+=step_k_ctr;
                    }

                    dk = initial_k_ctr;
                    while(dk <= final_k_ctr){

                        tempString = tempString+",AvgNodeDegree K="+dk;

                        dk+=step_k_ctr;
                    }

                    //Header with the values of K
                    mywrite.write(tempString+"\n");

                    i=0;
                    j=0;
                    k=0;

                    di = initial_i_exp_l_ctr;
                    while(di <= final_i_exp_l_ctr){

                        dl = java.lang.Math.pow(2,(2*di));

                        tempString="";

                        dk = initial_k_ctr;
                        while (dk <= final_k_ctr){

                            tempString = tempString+","+GC_info1.get(i);

                            i++;
                            dk+=step_k_ctr;

                        }

                        dk = initial_k_ctr;
                        while (dk <= final_k_ctr){

                            tempString = tempString+","+GC_info2.get(j);

                            j++;
                            dk+=step_k_ctr;

                        }

                        dk = initial_k_ctr;
                        while (dk <= final_k_ctr){

                            tempString = tempString+","+GC_info3.get(k);

                            k++;
                            dk+=step_k_ctr;

                        }

                        mywrite.write(""+dl+tempString+"\n");
                        di++;

                    }

                    mywrite.write("\n\nTable of Communication Radius\n");
                    mywrite.write("\nL,n,K\n");
                    tempString="";

                    dk = initial_k_ctr;
                    while (dk <= final_k_ctr){
                        tempString = tempString+dk+",";
                        dk+=step_k_ctr;
                    }
                    mywrite.write(" , ,"+tempString+"\n");

                    di = initial_i_exp_l_ctr;
                    while(di <= final_i_exp_l_ctr){
                        dk = initial_k_ctr;
                        dl = java.lang.Math.pow(2,(2*di));
                        dn = java.lang.Math.sqrt(dl);

                        tempString="";

                        while (dk <= final_k_ctr){

                            dr = java.lang.Math.round(dk * java.lang.Math.pow(dl,0.75)*java.lang.Math.sqrt(java.lang.Math.log(dl)/java.lang.Math.log(2)));
                            tempString = tempString+","+dr;

                            dk+=step_k_ctr;

                        }

                        mywrite.write(""+dl+","+dn+tempString+"\n");
                        di++;

                    }


                    mywrite.flush();
                    mywrite.close();
                    fout.close();
                }catch(Exception ex){ex.printStackTrace();}

                view.update(Observer.PRINT_MSG, "GC stat created!!");

            } else {
                        view.update(Observer.SHOW_MSG, "Open command cancelled by user.");
                    }

            }
        view.update(Observer.SET_FILE_SELECTION_MODE, javax.swing.JFileChooser.FILES_AND_DIRECTORIES);

        batch_simulation=false;
        GC_Test = false;
        //no_paint = true;
        view.update(Observer.CLEAR_SIM, "");

    }

    public boolean isBatch_creation() {
        return batch_creation;
    }

    public boolean isBatch_simulation(){
        return batch_simulation;
    }

    public boolean isSimulationStarted(){
        return tempsim.isSimulationStarted();
    }

    /*public boolean isSimulationStarted(){
        return mysim.isSimulationStarted();
    }*/
    
    public double getRandom(double max_val){
        return java.lang.Math.random()*max_val;
    }

    public int getRandomInt(int max_val){
        return (int)java.lang.Math.floor(java.lang.Math.random()*max_val);
    }

    public String getStatsHeaderForExcel(){
        int i;
        stats="Filename"+
                                ",Clock"+
                                ",# of Nodes"+
                                ",# of Sinks"+
                                ",Not Covered"+
                                ",Ratio"+
                                ",Not Visited"+
                                ",Avg. Level"+
                                ",Avg. Num. Neighb"+
                                ",Avg. Num. Active Neighb"+
                                ",# of Reachable Active Neighb. from Sink"+
                                ",# of Messages regular sent"+
                                ",# of Messages long sent"+
                                ",# of Messages regular received"+
                                ",# of Messages long received"+
                                ",# of Lost Messages regular"+
                                ",# of Lost Messages long"+
                                ",# of dead nodes"+
                                ",# of unconnected nodes"+
                                ",# of Data Messages received by sink";

                                for(i=0;i<MAX_TREES;i++)
                                    stats = stats + ",Active Nodes VNI "+i;

                                stats = stats +",Total Energy initial"+
                                ",Total Energy final"+
                                ",Total Energy spent ratio"+
                                ",Total Energy in tree"+
                                ",Ratio Energy"+
                                ",TM invocations"+
                                ",Total Covered Comm Area"+
                                ",Total Covered Sensing Area"+
                                ",Average K Sensing Coverage"+
                                ",Average K Sensing Area Coverage"+
                                ",Total Connected Covered Comm Area"+
                                ",Total Connected Covered Sensing Area"+
                                ",alpha coverage value"+
                                ",Error in Simulation\n";
        return stats;
    }

    public String getStatsRowForExcel(){
        return getStatsRowForExcel("none");
    }

    public String getStatsRowForExcel(String filename){
        return getStatsRowForExcel(filename,"");
    }

    public String getStatsRowForExcel(String filename, String extra){
    int i;
         stats=             filename+
                                ","+clock+
                                ","+mysim.numnodes+
                                ","+mysim.numsinks+
                                ","+mysim.notCovered_Visited[0]+
                                ","+(double)mysim.notCovered_Visited[0]/mysim.numnodes+
                                ","+mysim.notCovered_Visited[1]+
                                ","+mysim.avg_level+
                                ","+mysim.avgNeighb+
                                ","+mysim.avgNeighbActiveNodes+
                                ","+mysim.ReachableNeighbActiveNodes+
                                ","+num_messages+
                                ","+num_messages_long+
                                ","+num_messages_r+
                                ","+num_messages_long_r+
                                ","+num_messages_l+
                                ","+num_messages_long_l+
                                ","+mysim.count_dead+
                                ","+mysim.count_nodes_with_dead_parent+
                                ","+num_messages_data_r_sink;

                                for(i=0;i<MAX_TREES;i++)
                                    stats = stats + ","+mysim.count_active[i];

                                stats = stats +","+total_energy_ini+
                                ","+total_energy+
                                ","+(total_energy_ini-total_energy)/total_energy_ini+
                                ","+total_energy_tree+
                                ","+(total_energy_tree/total_energy)+
                                ","+count_TM_invocations+
                                ","+mysim.covered_area+
                                ","+mysim.covered_area_sens+
                                ","+mysim.covered_area_sens_k+
                                ","+mysim.covered_area_sens_k_all+
                                ","+mysim.covered_area_from_sink_c+
                                ","+mysim.covered_area_from_sink_s+
                                ","+mysim.alpha_coverage_value+
                                ","+mysim.sim_error+
                                 ","+extra+
                                "\n";
        return stats;
    }

    public void TicTac(){
        clock+=CLOCK_TIC;
    }

    public void pushEvent(event_sim e){
        //myqueue.Push(e);
        mysim.Push(e);
    }

    public int getH(){
        return mysim.h;
    }

    public File getMyFile() {
        return myFile;
    }

    public void setMyFile(File myFile) {
        this.myFile = myFile;
    }

    public void setSim_assigned(boolean sim_assigned) {
        this.sim_assigned = sim_assigned;
    }

    public boolean isCheckTrials() {
        return checkTrials;
    }

    public void setCheckTrials(boolean checkTrials) {
        this.checkTrials = checkTrials;
    }

    public boolean getAll_trees() {
        return mysim.all_trees;
    }
    
    public void setAll_trees (boolean all_trees) {
        mysim.all_trees = all_trees;
    }

    public Vector<node> getMynodes(){
        return mysim.mynodes;
    }

    public eventQueue getMyqueue_() {
        return mysim.myqueue_;
    }

    public node getNode(int n){
        return mysim.getNode(n);
    }

    public int[] getNum_sinks_per_tree() {
        return mysim.num_sinks_per_tree;
    }

    public int getNumnodes() {
        return mysim.numnodes;
    }

    public int getNumpoints() {
        return mysim.numpoints;
    }

    public int getNumsinks() {
        return mysim.numsinks;
    }

    public int getTempnumnodes() {
        return mysim.tempnumnodes;
    }

    public BatchExecutor getThe_batch_sim() {
        return the_batch_sim;
    }

    public int getContNeighb() {
        return mysim.contNeighb;
    }

    public void setContNeighb(int contNeighb) {
        mysim.contNeighb = contNeighb;
    }

    public int getTMType(){
        return simulator.getTMType();
    }

    public int getW(){
        return mysim.w;
    }

    public int getRandomActiveNodeID(int tree){

        int i;
        int temp;

        temp = getRandomInt(mysim.numpoints);

        while(!getNode(temp).isActive(tree)){
            temp = getRandomInt(mysim.numpoints);
        }

        return temp;
    }

    public double getVariable(int code){
    double val=0;
    int i=0;

        switch(code){

            case(NUMNODES):
                return mysim.numnodes;

            case(NUMPOINTS):
                return mysim.numpoints;

            case(NUMSINKS):
                return mysim.numsinks;

            case(NUMINFRASTRUCTURES):
                for(i=0;i<MAX_TREES;i++){
                    if(mysim.num_sinks_per_tree[i]>0)
                        val++;
                }
                return val;

            case(CLOCK):
                return clock;


            case(SORTINGMODE):
                return mysim.sortingmode;


            case(SIMMODE):
                return mysim.simmode;


            case(BATCH_SIMULATION):
                if(batch_simulation)
                    val=0;
                else
                    val=1;
                return val;


            case SELECTED_TM_PROTOCOL:
                    return selected_TMprotocol;

            case SELECTED_SD_PROTOCOL:
                    return selected_SDprotocol;

            case CANDIDATE_GROUP_STEP:
                    return mysim.candidate_grouping_step;

            case WEIGHT_METRIC1:
                return weight_metric1;

            case WEIGHT_METRIC2:
                return weight_metric2;

            case NEXT_RESET_PERIOD:
                return NEXT_RESET_TIMEOUT;

            case SELECTED_COMM_PROTOCOL:
                return selected_COMMprotocol;

            case PM_STEP:
                return mysim.pm_step;

            case PM_SLEEP:
                return mysim.pm_sleep;

            case KNEIGH_K:
                return kneigh_k;

            case KNEIGH_TYPE:
                return kneigh_type;

            case ALPHA_COVERAGE:
                return mysim.alpha_coverage_value;

            case PREF_RADIUS:
                return pref_radius;

                
            default:
                break;
        }

        return 0;

    }

    public Observer getView(){
        return view;
    }

    public void setAlpha_coverage_value(double alpha_coverage_value){
        mysim.alpha_coverage_value = alpha_coverage_value;
    }

    public void setCadidate_grouping_step(double candidate_grouping_step){
        mysim.candidate_grouping_step = candidate_grouping_step;
    }

    public void setCurrent_node_count(int current_node_count) {
        mysim.current_node_count = current_node_count;
    }

    public void setBatch_creation(boolean batch_creation) {
        this.batch_creation = batch_creation;
    }

    public void setInterqueryTime(double interquery_time){

        int i=0;
        double interquery_time_=10;
        try{

            this.interquery_time_= interquery_time;

        }catch(Exception ex){ex.printStackTrace();}

        for(i=0;i<mysim.numpoints;i++){
            getNode(i).setInterqueryTime(interquery_time_);
        }

    }

    public void setNumnodes(int numnodes){
        mysim.numnodes = numnodes;
    }

    public void setNumsinks(int numsinks){
        mysim.numsinks = numsinks;
    }

    public void setNumpoints(int numpoints){
        mysim.numpoints = numpoints;
    }

    public void setBatch_simulation(boolean batch_simulation) {
        this.batch_simulation = batch_simulation;
    }

    public void setBit_error_rate(double bit_error_rate){
        mysim.default_bit_error_rate = bit_error_rate;
    }
    
    public void setPm_step(int pm_step){
        mysim.pm_step = pm_step;
    }
    
    public void setPm_sleep(int pm_sleep){
        mysim.pm_sleep = pm_sleep;
    }

    public Point setPointLocation(int x, int y){
        return new Point(x,y);
    }

    public void setResultTryAgain(int resultTryAgain) {
        this.resultTryAgain = resultTryAgain;
    }

    public void setSortingmode(int sortingmode){
        mysim.sortingmode = sortingmode;
    }

    public void setTopology_loaded(boolean topology_loaded) {
        this.topology_loaded = topology_loaded;
    }

    public void setTempnumnodes(int tempnumnodes) {
        mysim.tempnumnodes = tempnumnodes;
    }

    public void setH(int h){
        mysim.h = h;
    }

    public void setW(int w){
        mysim.w = w;
    }



    public int NodeGeneratorForbatch(int n, String the_path){

        view.update(Observer.CONNECTED_TOPOLOGIES, "");
        int in=0,count_trials=0,total_trials=0,j=0;
        boolean sw=false,sw2=false;
        String nom="";
        String extension=".ata";
        double we=0, wd=1, step =0.25;
        timestamp t;


        view.update(Observer.TOPOLOGY_PROGRESS, "Progress: 0 of "+n+" topologies.");
        while(in<n && !sw2){
            sw=false;
            count_trials=0;
            do{
                setNodeCreationWordAttributes(100, 100.0, 20.0, 10, 0, 300, 300, 0, 1000, 1000, 1, 1, weight_metric1, weight_metric2, false, 0, 0, 0, 600, 600, 5);
                sw = NodeGenerator();
                count_trials++;
                total_trials++;
            }while(!sw && count_trials<MAX_TRIALS);

            if(count_trials<MAX_TRIALS){
                if(!createAllSteps){
                    t = new timestamp();
                    if(mysim.numsinks>0)
                        nom = mysim.numnodes+"_"+mysim.numsinks+"_"+mysim.getNode(mysim.numnodes).getRadius()+"_"+mysim.w+"_"+mysim.h+"_"+t.toString2()+"_";
                    else
                        nom = mysim.numnodes+"_"+mysim.numsinks+"_"+mysim.getNode(0).getRadius()+"_"+mysim.w+"_"+mysim.h+"_"+t.toString2()+"_";

                    SaveDeployment(the_path+"\\"+nom+(in+start_index)+extension);
                }else{
                    we=0.0;
                    wd=1.0;
                    try{
                        step = Double.parseDouble(CGStep);
                    }catch(Exception ex){ex.printStackTrace();}
                    while(we<=1){
                        view.update(Observer.SHOW_WE,""+we);
                        view.update(Observer.SHOW_WD,""+wd);
                        setWeights(""+we, ""+wd);
                        t = new timestamp();
                        nom = mysim.numnodes+"_"+mysim.numsinks+"_"+mysim.getNode(mysim.numnodes).getRadius()+"_"+mysim.w+"_"+mysim.h+"_"+we+"_"+wd+"_"+t.toString2()+"_";
                        SaveDeployment(the_path+"\\"+nom+(in+start_index)+extension);
                        we+=step;
                        wd=1.0-we;
                    }
                    if(we>1){
                        view.update(Observer.SHOW_WE,"1");
                        view.update(Observer.SHOW_WD,"0");
                        setWeights("1", "0");
                        t = new timestamp();
                        nom = mysim.numnodes+"_"+mysim.numsinks+"_"+mysim.getNode(mysim.numnodes).getRadius()+"_"+mysim.w+"_"+mysim.h+"_1.0_0.0_"+t.toString2()+"_";
                        SaveDeployment(the_path+"\\"+nom+(in+start_index)+extension);
                    }
                }
                in++;
                view.update(Observer.TOPOLOGY_PROGRESS_BAR, in+1);
                view.update(Observer.TOPOLOGY_PROGRESS, "Progress: "+in+" of "+n+" topologies.");
            }else{
                //javax.swing.JOptionPane.showMessageDialog(this, "Impossible deployment!");
                //sw2=true;

                if(checkTrials){
                    view.update(Observer.SHOW_DIALOG_TRY_AGAIN, "");
                    switch(resultTryAgain) {
                       case 0: // yes
                         count_trials=0;
                         break;
                       case 1: // no
                         count_trials = MAX_TRIALS+1;
                         sw2=true;
                         break;
                       default:
                         break;
                    }
                }else{
                    count_trials=0;
                }


            }

        }

        if(!GC_Test)
            view.update(Observer.SHOW_MSG_DIALOG, ""+in+" saved deployments after "+total_trials+" trials!");
            
        if(GC_Test){
            try{
                sem_GC.release();
            }catch(Exception ex){ex.printStackTrace();}
        }
        return total_trials;
    }

    public boolean NodeGenerator(){

        int i;
        boolean sw=false;
        mysim.contNeighb=0;

        view.update(Observer.UPDATE_NODE_CREATION_WORDS, "");
        //mysim.mynodes.clear();
        mysim.clearnodes();
        
        mysim.numnodes=0;
        mysim.numsinks=0;
        mysim.numpoints=0;
        mysim.current_node_count=0;
        total_energy_ini=0;

        for(i=0;i<MAX_TREES;i++)
            mysim.num_sinks_per_tree[i] = 0;

        if(node_creation_words.isEmpty()){
            addNodeCreationWord();
        }

        if(sink_creation_words.isEmpty()){
            addDefaultSinkCreationWord();
        }


        for(i=0;i<node_creation_words.size();i++){
            mysim.numnodes += NodeGeneratorByWord(node_creation_words.get(i));
        }

        java.util.Collections.sort(sink_creation_words);
        for(i=0;i<sink_creation_words.size();i++){
            mysim.numsinks += NodeGeneratorByWord(sink_creation_words.get(i));
        }

        view.update(Observer.SHOW_NUM_NODES, ""+mysim.numnodes);
        view.update(Observer.SHOW_NUM_SINKS, ""+mysim.numsinks);


        mysim.numpoints = mysim.numnodes + mysim.numsinks;

         for(i=0;i<mysim.numpoints;i++){
            getNode(i).setSortingMode(mysim.sortingmode);
            mysim.avgNeighb += BuildNeighborhood(i);
        }

        mysim.avgNeighb = mysim.avgNeighb/mysim.numpoints;
        view.update(Observer.SHOW_AVG_NGB,""+mysim.avgNeighb);

         if(check_connectivity){
            sw=checkGraphConnected();
        }else
            sw=true;

        if(sw && !batch_creation && !GC_Test)
            view.update(Observer.SHOW_DEPLOYMENT_TAB, "");
            //jTabbedPane1.setSelectedIndex(1);

        view.update(Observer.UPDATE_NO_PAINT, !sw);
        return sw;
    }

    public int NodeGeneratorByWord(String s){

        /*
         *  word format:
         * sink@                    {0,1}= no, yes
         * tree selection@          int
         * number of nodes@         int
         * comm rad@                double
         * sensing rad@             double
         * interquery time@         double
         * position distrib@        {0-5} = uniform, normal, grid HV, grid HVD, constant, center
         * width@                      width of the location distribution square
         * height@                     height of the location distribution square
         * mean x@                  int
         * mean Y@                  int
         * parameter@               double
         * energy distrib@          {0-5} = uniform, normal,poisson, constant
         * max value@               int
         * mean value@              int
         * parameter@               double
         * moving@                    {0,1}= no, yes
         */

        int numnodes_=0;
        double comm_rad_=40.0, sense_rad_=20.0;
        int sink_=0, tree_sel_=0;
        double interquery_time_=10;
        int pos_dist_=0, mean_x=300, mean_y=300;
        int energy_dist_=0, energy_max=1000, energy_mean=1000;
        double pos_param=1, energy_param=1;
        int x=0,y=0,i,j,energy=1000;
        double step_v=40, step_h=40;
        int step=40;
        int temp, limit_h, limit_w;
        double weight_e=0.5, weight_d=0.5;
        int _width=600, _height=600;
        int moving = 0;
        int energy_model = 0;
        int comm_model = 0;
        

        String the_word[];

        the_word = s.split("@");

        try{

            sink_ = Integer.parseInt(the_word[0]);
            tree_sel_ = Integer.parseInt(the_word[1]);
            numnodes_ = Integer.parseInt(the_word[2]);
            comm_rad_ = Double.parseDouble(the_word[3]);
            sense_rad_ = Double.parseDouble(the_word[4]);
            interquery_time_= Double.valueOf(the_word[5]);
            pos_dist_ = Integer.parseInt(the_word[6]);
            mean_x = Integer.parseInt(the_word[7]);
            mean_y = Integer.parseInt(the_word[8]);
            pos_param = Double.valueOf(the_word[9]);
            _width = Integer.parseInt(the_word[10]);
            _height = Integer.parseInt(the_word[11]);
            energy_dist_ = Integer.parseInt(the_word[12]);
            energy_max = Integer.parseInt(the_word[13]);
            energy_mean = Integer.parseInt(the_word[14]);
            energy_param = Double.valueOf(the_word[15]);
            weight_e= Double.valueOf(the_word[16]);
            weight_d= Double.valueOf(the_word[17]);
            moving= Integer.parseInt(the_word[18]);
            energy_model = Integer.parseInt(the_word[19]);
            if(the_word.length == 21)
                comm_model = Integer.parseInt(the_word[20]);
            else{
                if(energy_model == this.WASPMOTE_ENERGY_MODEL)
                    comm_model = this.WASPMOTE_COMM_MODEL;
                else if(energy_model == this.MICA2_ENERGY_MODEL)
                    comm_model = this.MICA2_COMM_MODEL;
                else 
                    comm_model = this.SIMPLE_COMM_MODEL;
            }

        }catch(Exception ex){ex.printStackTrace();}

        if((pos_dist_ < GRID_H_V) || sink_==1){

            for(i=0;i<numnodes_;i++){

                switch(pos_dist_){

                    //This option will generate uniform nodes in a rectangle with center in (mean_x, mean_y) and side _width and _height.
                    case UNIFORM_DIST:
                        x = (int)java.lang.Math.round(java.lang.Math.random()*_width)+(mean_x-(_width/2));
                        y = (int)java.lang.Math.round(java.lang.Math.random()*_height)+(mean_y-(_height/2));
                        break;

                    //This option will generate a node in the normally distributed random position with mean in (mean_x, mean_y)
                    // and a standar deviation of _pos_param.
                    case NORMAL_DIST:
                        p=GaussianRandomGenerator(mean_x,mean_y,pos_param);
                        x=(int)p.getX();
                        y=(int)p.getY();
                        break;

                    //This option will generate a node in the position defined by (mean_x, mean_y) in the deployment area
                    case CONSTANT:
                        x=mean_x;
                        y=mean_y;
                        break;

                    //This option will generate a node in the center of the deployment area
                    case CENTER:
                        x=(mysim.w/2);
                        y=(mysim.h/2);
                        break;

                }

                energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                total_energy_ini += energy;

                mysim.mynodes.add(new node(mysim.current_node_count, new Point(x,y), energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                if(sink_==1){
                    getNode(mysim.current_node_count).setRole(tree_sel_, ROLE_SINK);
                }
                mysim.current_node_count++;



            }

            if(sink_==1 && numnodes_>0){
                mysim.num_sinks_per_tree[tree_sel_]+=numnodes_;
            }

        }else{

            switch(pos_dist_){

                case GRID_H_V:
                    step = (int)comm_rad_;
                    break;

                case GRID_H_V_D:
                    step = (int)java.lang.Math.floor(comm_rad_/java.lang.Math.sqrt(2));
                    break;

                case GRID_OPT_STRIP:
                     step_h = java.lang.Math.round(java.lang.Math.min(comm_rad_, sense_rad_*java.lang.Math.sqrt(3)));
                     step_v = sense_rad_ + java.lang.Math.ceil( java.lang.Math.sqrt(sense_rad_*sense_rad_ - step_h*step_h/4));
                    break;

                case GRID_OPT_COMB:
                    step_h = sense_rad_*(1.732);
                    //step_h = sense_rad_*2;
                    //step_h = java.lang.Math.min(comm_rad_, sense_rad_*(1.732));
                    step_v = sense_rad_/2;
                    break;

                case GRID_OPT_TRIANGLE:
                    step_h = sense_rad_/2;
                    step_v = sense_rad_*(1.732)/2;
                    break;

                case GRID_OPT_SQUARE:
                    step = (int)sense_rad_;
                    break;

                case GRID_POISSON:
                case GRID_LAMBDA:
                    step = (int)sense_rad_;
                    break;


                default:
                    step=40;
                    break;

            }

            switch(pos_dist_){

                case GRID_H_V:
                case GRID_H_V_D:
                case GRID_OPT_SQUARE:

                    limit_h = (mysim.h/step)+1;
                    limit_w = (mysim.w/step)+1;
                    numnodes_ = limit_h*limit_w;
                    view.update(Observer.UPDATE_NUM_NODES_FIELD, ""+mysim.numnodes);
                    view.update(Observer.SHOW_NUM_NODES, ""+mysim.numnodes);

                    for(i=0;i<limit_h;i++){
                        for(j=0;j<limit_w;j++){

                            energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                            total_energy_ini += energy;

                            p=setPointLocation(j*step, i*step);
                            mysim.mynodes.add(new node(mysim.current_node_count, p, energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                            mysim.current_node_count++;

                        }
                    }
                break;

                case GRID_OPT_STRIP:

                    int temp2 = -1;

                    //Create the strips
//                    limit_h = (int)(h/step_v);
  //                  limit_w = (int)(w/step_h);

                    limit_h = (int)(java.lang.Math.ceil(mysim.h/(step_v)));
                    limit_w = (int)(java.lang.Math.ceil(mysim.w/step_h));


                    for(i=0;i<limit_h;i++){
                        for(j=0;j<limit_w;j++){

                            energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                            total_energy_ini += energy;

                            p=setPointLocation((int)(step_h/4+ j*step_h + (java.lang.Math.pow(temp2, i))*(step_h/4)), (int)(i*step_v));


                            mysim.mynodes.add(new node(mysim.current_node_count, p, energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                            mysim.current_node_count++;

                        }

                        if(i%2 == 1){

                            energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                            total_energy_ini += energy;

                            p=setPointLocation((int)(step_h/4+ j*step_h + (java.lang.Math.pow(temp2, i))*(step_h/4)), (int)(i*step_v));


                            mysim.mynodes.add(new node(mysim.current_node_count, p, energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                            mysim.current_node_count++;
                        }

                    }

                    //Initial deviation
                    temp = (int)(step_v/2.0);

                    //step_v = java.lang.Math.sqrt(step_h*step_h/4 + step_v*step_v);

                    //limit_h = (int)(w/step_v)+1;

                    if(((double)comm_rad_/(double)sense_rad_) <= java.lang.Math.sqrt(3)){
                        //Generate the nodes to connect the strips
                        for(i=0;i<limit_h-1;i++){

                            energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                            total_energy_ini += energy;

                            //p=setPointLocation((int)(2*step_h + (java.lang.Math.pow(temp2, i))*(step_h/4)), (int)(i*step_v + temp));
                            p=setPointLocation((int)(step_h + step_h/4), (int)(i*step_v + temp));

                            mysim.mynodes.add(new node(mysim.current_node_count, p, energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                            mysim.current_node_count++;


                        }
                    }
                    numnodes_ = mysim.current_node_count;
                    view.update(Observer.UPDATE_NUM_NODES_FIELD, ""+mysim.numnodes);
                    view.update(Observer.SHOW_NUM_NODES, ""+mysim.numnodes);

                break;

                case GRID_OPT_COMB:

                    temp2 = 0;

                    //Create the strips
                    limit_h = (int)(java.lang.Math.round(mysim.h/(step_v*3)));
                    limit_w = (int)(java.lang.Math.round(mysim.w/step_h));

                    for(i=0;i<limit_h;i++){


                        for(j=0;j<limit_w;j++){

                            energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                            total_energy_ini += energy;

                            p=setPointLocation((int)(step_h/4+ j*step_h + temp2*(step_h/2)), (int)(i*step_v*3));

                            mysim.mynodes.add(new node(mysim.current_node_count, p, energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                            mysim.current_node_count++;

                        }


                        if(temp2 == 0)
                            temp2=1;
                        else
                            temp2=0;

                        //if(i+1<limit_h){
                            for(j=0;j<limit_w;j++){

                                energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                                total_energy_ini += energy;

                                p=setPointLocation((int)(step_h/4+ j*step_h + temp2*(step_h/2)), (int)((i+1)*step_v*3 - 2*step_v));

                                mysim.mynodes.add(new node(mysim.current_node_count, p, energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                                mysim.current_node_count++;

                            }
                        //}
                    }

                    numnodes_ = mysim.current_node_count;
                    view.update(Observer.UPDATE_NUM_NODES_FIELD, ""+mysim.numnodes);
                    view.update(Observer.SHOW_NUM_NODES, ""+mysim.numnodes);
                break;

                case GRID_OPT_TRIANGLE:

                    temp2 = 0;

                    //Create the strips
                    limit_h = (int)(java.lang.Math.ceil(mysim.h/(step_v)));
                    limit_w = (int)(java.lang.Math.ceil(mysim.w/step_h));

                    for(i=0;i<limit_h;i++){

                        j=0;
                        while(j<limit_w){

                            temp2=i%2;

                            //first point
                            energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                            total_energy_ini += energy;

                            p=setPointLocation((int)((j+temp2)*step_h),(int)(i*step_v));

                            mysim.mynodes.add(new node(mysim.current_node_count, p, energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                            mysim.current_node_count++;

                            if(temp2==1){
                                    //To separate tthe nodes 1*sense_rad
                                    j+=2;
                                }else{
                                    j+=4;
                                }

                            if(j<limit_w){
                                energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                                total_energy_ini += energy;

                                p=setPointLocation((int)((j+temp2)*step_h),(int)(i*step_v));

                                mysim.mynodes.add(new node(mysim.current_node_count, p, energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                                mysim.current_node_count++;

                                if(temp2==0){
                                    //To separate tthe nodes 1*sense_rad
                                    j+=2;
                                }else{
                                    j+=4;
                                }
                            }
                        }



                    }

                    numnodes_ = mysim.current_node_count;
                    view.update(Observer.UPDATE_NUM_NODES_FIELD, ""+mysim.numnodes);
                    view.update(Observer.SHOW_NUM_NODES, ""+mysim.numnodes);

                    break;

                case GRID_POISSON:
                case GRID_LAMBDA:

                    temp=0;
                    temp2 = 0;
                    int delta = 1;
                    int temp_delta = delta;
                    int k=0;

                    try{
                        delta = (int)sigma;
                        temp_delta = delta;
                    }catch(Exception ex){ex.printStackTrace();}

                    //Create the strips
                    limit_h = (int)(java.lang.Math.ceil(mysim.h/(step)));
                    limit_w = (int)(java.lang.Math.ceil(mysim.w/step));

                    for(i=0;i<limit_h;i++){

                        for(j=0;j<limit_w;j++){

                            if(pos_dist_ == GRID_POISSON)
                                temp_delta = PoissonRandomGenerator(delta);

                            for(k=0;k<temp_delta;k++){

                                energy = (int)GenerateEnergy(energy_dist_, energy_max, energy_mean, energy_param );
                                total_energy_ini += energy;

                                temp = getRandomInt(step);
                                temp2 = getRandomInt(step);

                                p=setPointLocation((int)((j*step)+temp),(int)((i*step)+temp2));

                                mysim.mynodes.add(new node(mysim.current_node_count, p, energy, comm_rad_, sense_rad_,interquery_time_,weight_e,weight_d,moving, energy_model, comm_model));
                                mysim.current_node_count++;

                            }

                        }
                    }

                    numnodes_ = mysim.current_node_count;
                    view.update(Observer.UPDATE_NUM_NODES_FIELD, ""+mysim.numnodes);
                    view.update(Observer.SHOW_NUM_NODES, ""+mysim.numnodes);


                    break;


                default:
                    break;

            }

        }

        return numnodes_;
    }

    public void setWeights(String we, String wd){

        int i=0;

        try{

            weight_metric1= Double.parseDouble(we);

            weight_metric2= Double.parseDouble(wd);

        }catch(Exception ex){ex.printStackTrace();}

        for(i=0;i<mysim.numpoints;i++){
            getNode(i).setWeight(WEIGHT_ENERGY, weight_metric1);
            getNode(i).setWeight(WEIGHT_DISTANCE, weight_metric1);
        }

    }

    public void showSolution(solution sol){

        int i=0, numneigh=0, j=0, temp_id=0;


        // Updating the state in tree 0 to show on the interface
        for(i=0; i<mysim.numpoints; i++){
            getNode(i).setNodeStateBFS(sol.get(i));
            getNode(i).defineLabels(S_INACTIVE_BFS, S_ACTIVE_BFS, S_INACTIVE_BFS, S_INACTIVE_BFS);
            if(sol.get(i) == S_ACTIVE_BFS){
                getNode(i).setParentState(0, true);
            }else
                getNode(i).setParentState(0, false);
        }

        for(i=0;i<mysim.numpoints;i++){
            if(getNode(i).isActive(0)){
                numneigh = getNode(i).getNumNeighbors();
                for(j=0;j<numneigh;j++){
                temp_id = getNode(i).getNeighborID(j);
                    getNode(i).addGateway(0, temp_id, temp_id);
                    getNode(temp_id).setDefaultGateway(0, i);
                }
            }
        }
        view.update(Observer.UPDATE_TREEIDVIZ, 0);
        view.update(Observer.UPDATE_ALL_GATEWAYS, true);
        view.update(Observer.REPAINT, "");
    }

    public boolean SaveBFSMatrix(){

        int j=0, temp_level=0;
        String st="";
        boolean result = true;;

        for(int i=0;i<mysim.numpoints;i++){
            temp_level=getNode(i).getLevelBFS();
            for(j=0;j<mysim.numpoints;j++){
                if(j!=temp_level)
                    st = st+"0,";
                else
                    st = st+"1,";
            }
            st = st+"\n";
        }

        String the_path="";
        String the_name3="";
        timestamp t;


            
             view.update(Observer.SET_MYFILE, javax.swing.JFileChooser.FILES_AND_DIRECTORIES);

            if (myFile != null) {

                    if(myFile.isFile())
                        the_path = myFile.getParent();
                    else
                        the_path = myFile.getPath();

                    try{
                        t = new timestamp();

                        the_name3 = report_descriptor + "_" + mysim.numnodes + "_" + mysim.numsinks+ "_" + mysim.w + "_" + mysim.h + "_" + t.toString2();

                        fout = new FileWriter(the_path+"\\BFS_Matrix_"+the_name3+".csv");

                        mywrite = new BufferedWriter(fout);
                        mywrite.write(st);

                        mywrite.flush();
                        mywrite.close();
                        fout.close();

                    }catch(Exception ex){
                        ex.printStackTrace();
                        result = false;
                    }

        }
        else{
            result = false;
        }

        return result;

    }

    public boolean SaveNeighborhoods(){
        int i=0, j=0, tam=0;
        int[] vect = new int[mysim.numpoints];
        String neighb="";
        String the_path="";
        String the_name3="";
        timestamp t;
        boolean result = true;

        view.update(Observer.SET_MYFILE, javax.swing.JFileChooser.FILES_AND_DIRECTORIES);

        if (myFile != null) {
                

                if(myFile.isFile())
                    the_path = myFile.getParent();
                else
                    the_path = myFile.getPath();

                try{
                    t = new timestamp();

                    the_name3 = report_descriptor + "_" + mysim.numnodes + "_" + mysim.numsinks + "_" + mysim.w + "_" + mysim.h + "_" + t.toString2();

                    fout = new FileWriter(the_path+"\\neighbohoods"+the_name3+".csv");

                    mywrite = new BufferedWriter(fout);


                    for(i=0;i<mysim.numpoints;i++){

                        neighb="";
                        for(j=0;j<mysim.numpoints;j++)
                            vect[j]=0;

                        tam = mysim.mynodes.get(i).getNumNeighbors();
                        for(j=0;j<tam;j++)
                            vect[mysim.mynodes.get(i).getNeighbor(j).getID()]=1;

                        for(j=0;j<mysim.numpoints;j++)
                            neighb=neighb+vect[j]+",";

                        mywrite.write(neighb+"\n");
                    }

                    mywrite.flush();
                    mywrite.close();
                    fout.close();

                    //printmessage("Neighborhoods saved");

            }catch(Exception ex){
                ex.printStackTrace();
                result = false;
            }


        }
        else
            result = false;
        return result;

    }

    public void SaveDeployment(String the_file){

        int i;
        int count_trees=0;
        try{

            
            fout = new FileWriter(the_file);
            mywrite = new BufferedWriter(fout);

            mywrite.write(""+mysim.numnodes);
            mywrite.newLine();

            //Calculating the number of active trees
            for(i=0;i<MAX_TREES;i++){
                if(mysim.num_sinks_per_tree[i]!=0)
                    count_trees++;
            }
            mywrite.write(""+count_trees);
            mywrite.newLine();

            //Calculating the number of sinks on each active tree
            for(i=0;i<MAX_TREES;i++){
                if(mysim.num_sinks_per_tree[i]!=0){
                    mywrite.write(""+mysim.num_sinks_per_tree[i]);
                    mywrite.newLine();
                }
            }

            mywrite.write(""+radius);
            mywrite.newLine();
            mywrite.write(""+sense_radius);
            mywrite.newLine();
            mywrite.write(""+mysim.w);
            mywrite.newLine();
            mywrite.write(""+mysim.h);
            mywrite.newLine();

            for(i=0;i<mysim.numpoints;i++){
                mywrite.write(mysim.getNode(i).toStringforDeployment());
                mywrite.newLine();
            }
            mywrite.flush();
            fout.flush();
            fout.close();


        }catch(Exception e){e.printStackTrace();}


        if(!batch_creation)
            view.update(Observer.PRINT_MSG, "Deployment saved!");//javax.swing.JOptionPane.showMessageDialog(this, "Deployment saved!");

    }

    public void SolveBatchCDS(){

         
         int j,k;
         Vector<solution> temp_sols;
         timestamp time = new timestamp();
         batch_simulation = true;
         view.update(Observer.SET_MYFILES, "");
        if (myFiles.length > 0) {

                try{
                    fout = new FileWriter(myFiles[0].getParent()+"\\CDS_Optimal_"+myFiles.length+"_"+time.toString2()+".csv");
                    mywrite = new BufferedWriter(fout);

                    //This is where a real application would open the file.
                    for(j=0;j<myFiles.length;j++){
                        LoadDeployment(myFiles[j].getPath());
                        temp_sols = SolveCDS2();

                        for(k=0;k<temp_sols.size();k++){
                            mywrite.write(myFiles[j].getName()+","+temp_sols.get(k).toString()+temp_sols.get(k).getSum());
                            mywrite.newLine();
                        }
                    }

                    mywrite.flush();
                    fout.flush();
                    fout.close();

                    view.update(Observer.PRINT_MSG, "All experiments done!");
               }catch(Exception ex){ex.printStackTrace();}

            } else {
                view.update(Observer.SHOW_MSG, "Open command cancelled by user.");
            }
        batch_simulation = false;
        view.update(Observer.CLEAR_SIM, "");

    }

    public void SolveCDS(){

        int count_eval_sols=0;
        int count_eval_sols_2=0;
        int i=0;
        int min_size = mysim.numpoints;
        int max_solutions = (int)java.lang.Math.pow(2, mysim.numnodes);
        solution new_sol;
        Vector<solution> best_solutions = new Vector<solution>();

        for(i=0;i<max_solutions;i++){

            new_sol = generateSolution(i);
            if(new_sol.getSum() <= min_size){
                // Update the node states of the nodes, based on the solution
                applySolution(new_sol);
                //Check the solution for coverage and connectivity
                count_eval_sols++;
                if(checkSolution(new_sol.getSum())){
                    count_eval_sols_2++;
                    if(new_sol.getSum() < min_size){
                        // The new solution was better than the previous one
                        best_solutions.clear();
                        // Update the size of the minimum solution
                        min_size = new_sol.getSum();
                    }
                    // Add the new optimal solution
                    best_solutions.add(new_sol);

                }
            }

        }
        view.update(Observer.PRINT_MSG, "<html>Finished - Found "+best_solutions.size()+" solutions with "+min_size+" active nodes, <br> after evaluating "+
                count_eval_sols+" potential solutions and found "+count_eval_sols_2+" candidate solutions</html>");
        if(best_solutions.size() > 0)
            showSolution(best_solutions.get(0));
    }

    public Vector<solution> SolveCDS2(){

        long count_eval_sols=0;
        long count_eval_sols_2=0;
        int count_temp_sols=0;
        int i=0;
        int min_size = mysim.numpoints;
        solution new_sol = new solution(mysim.numpoints);
        Vector<solution> best_solutions = new Vector<solution>();

        java.text.DecimalFormat df = new java.text.DecimalFormat("#,##0.##E0");
        java.text.DecimalFormat df2 = new java.text.DecimalFormat("#,##0");

        double temp_combs;

        boolean sw=true, sw2=true;
        //sw_just_min = jCheckBox27.isSelected();

        //Vector<Integer> pointers = new Vector<Integer>(numpoints);
        int[] pointers = new int[mysim.numpoints];

        for(i=0; i<mysim.numpoints; i++)
            pointers[i]=-1;

        int j=0;

        int higher_elem = mysim.numnodes;
        int lower_elem = 1;
        int current_elements = (mysim.numnodes+1)/2;
        int temp_pointer = current_elements-1;

        while(higher_elem >= lower_elem){
            temp_combs = calc_combinations(current_elements,mysim.numnodes);
            if(best_solutions.size() == 0)
                view.update(Observer.SHOW_CREATING_TOPOS, "Current n: "+current_elements+", Combs: "+df.format(temp_combs));
            else
                 view.update(Observer.SHOW_CREATING_TOPOS,"Current n: "+current_elements+", Combs: "+df.format(temp_combs)+", Best n found: "+best_solutions.get(0).getSum());


            //Initializing the values of the pointers: 0,1,2,3,...
            for(j=0;j<current_elements;j++){
                pointers[j]= j;
            }
            sw=true;
            count_temp_sols=0;
            while(sw){

                //Fill up with zeros
                new_sol.clear();

                //in here I create the solution based on the values in the pointers, according to the number of elements
                for(j=0;j<current_elements;j++){
                    new_sol.set(pointers[j],1);
                }

                if(new_sol.getSum() <= min_size){
                    // Update the node states of the nodes, based on the solution
                    applySolution(new_sol);
                    //Check the solution for coverage and connectivity
                    count_eval_sols++;
                    if(checkSolution(new_sol.getSum())){
                        count_eval_sols_2++;
                        if(new_sol.getSum() < min_size){
                            // The new solution was better than the previous one
                            best_solutions.clear();
                            // Update the size of the minimum solution
                            min_size = new_sol.getSum();

                            if(sw_just_min)
                                sw=false;
                        }
                        // Add the new optimal solution
                        best_solutions.add(new solution(new_sol));
                        count_temp_sols++;

                    }
                }

                //Update the
                pointers[temp_pointer]++;

                // If the pointer reached the limit
                if(pointers[temp_pointer] == mysim.numnodes){
                    j=2;
                    temp_pointer--;
                    sw2=true;
                    while(temp_pointer >=0 && sw2){
                        if(pointers[temp_pointer] == mysim.numnodes - j){
                            temp_pointer--;
                            j++;
                        }else{
                            sw2=false;
                        }
                    }

                    if(temp_pointer == -1)
                        sw=false;
                    else{
                        pointers[temp_pointer]++;
                        for(i=temp_pointer+1; i<current_elements;i++){
                            pointers[i] = pointers[i-1]+1;
                        }
                        temp_pointer=current_elements-1;
                    }
                }


            }// While(sw) which explores all the combinations of sets of suze current_element



            if(count_temp_sols==0){
                lower_elem = current_elements+1;
            }else{
                higher_elem = current_elements-1;
            }

            current_elements = (higher_elem + lower_elem)/2;

            temp_pointer = current_elements-1;


        }
        if(best_solutions.size() > 0 && !batch_simulation){
            view.update(Observer.SHOW_CREATING_TOPOS, "Current n: "+best_solutions.get(0).getSum()+", Combs: "+calc_combinations(current_elements,mysim.numnodes)+", Best n found: "+best_solutions.get(0).getSum());
            view.update(Observer.PRINT_MSG, "<html>Finished - Found "+best_solutions.size()+" solutions with "+best_solutions.get(0).getSum()+" active nodes, <br> after evaluating "+
                df2.format(count_eval_sols)+" potential solutions and found "+df2.format(count_eval_sols_2)+" candidate solutions</html>");
            
            showSolution(best_solutions.get(0));
            view.update(Observer.SET_ATARRAYA, true);
            view.update(Observer.SET_ACTIVE_NODES, true);
        }

        return best_solutions;

    }

     public void UpdateStats(){
            mysim.CountNotVisited();
            int i=0;
            if(liveStats){
            stats="Clock: "+clock+
                                "\n# of Nodes: "+mysim.numnodes+
                                "\n# of Sinks: "+mysim.numsinks+
                                "\nNot Covered: "+mysim.notCovered_Visited[0]+
                                "\nRatio: "+(double)mysim.notCovered_Visited[0]/mysim.numnodes+
                                "\nNot Visited: "+mysim.notCovered_Visited[1]+
                                "\nAvg. Level: "+mysim.avg_level+
                                "\nAvg. Num. Neighb.: "+mysim.avgNeighb+
                                "\nAvg. Num. Active Neighb.: "+mysim.avgNeighbActiveNodes+
                                "\nReachable. Num. Active Neighb. from Sink: "+mysim.ReachableNeighbActiveNodes+
                                "\n# of Messages regular sent: "+num_messages+
                                "\n# of Messages long sent: "+num_messages_long+
                                "\n# of Messages regular received: "+num_messages_r+
                                "\n# of Messages long received: "+num_messages_long_r+
                                "\n# of Lost Messages regular: "+num_messages_l+
                                "\n# of Lost Messages long: "+num_messages_long_l+
                                "\n# of Data Messages received by sink: "+num_messages_data_r_sink+
                                "\n# of dead nodes: "+mysim.count_dead+
                                "\n# of unconnected nodes: "+mysim.count_nodes_with_dead_parent;


                                for(i=0;i<MAX_TREES;i++)
                                    stats = stats + "\nActive nodes in VNI "+i+" ="+mysim.count_active[i];

                                stats = stats +"\nTotal Energy initial="+total_energy_ini+
                                "\nTotal Energy final="+total_energy+
                                "\nTotal Energy spent="+total_energy_spent+
                                "\nTotal Energy spent ratio="+(total_energy_ini-total_energy)/total_energy_ini+
                                "\nTotal Energy in tree="+total_energy_tree+
                                "\nRatio Energy="+(total_energy_tree/total_energy)+
                                "\nTM invocations="+count_TM_invocations+
                                "\nCovered Comm Area="+mysim.covered_area+
                                "\nCovered Sensing Area="+mysim.covered_area_sens+
                                "\nAverage K Sensing Coverage="+mysim.covered_area_sens_k+
                                "\nAverage K Sensing Area Coverage="+mysim.covered_area_sens_k_all+
                                "\nTotal Covered Comm Area="+mysim.covered_area_from_sink_c+
                                "\nTotal Covered Sensing Area="+mysim.covered_area_from_sink_s+
                                "\nAlpha Coverage Value="+mysim.alpha_coverage_value+
                                "\nError in simulation="+mysim.sim_error+
                                "";
                                view.update(Observer.SHOW_STATS, stats);
            }

    }

     public void UpdateStats(String stats){
        stats_from_panel = stats;
    }

     public void simulation_pause(){
        if(tempsim != null)
            tempsim.simulation_pause();
    }

    public void simulation_end(){
        if(tempsim != null)
            tempsim.simulation_end();
    }

    public void simulation_start(){
        if(tempsim != null)
            tempsim.simulation_start();
    }
    /*
     public void simulation_pause(){
        if(mysim != null)
            mysim.simulation_pause();
    }

    public void simulation_end(){
        if(mysim != null)
            mysim.simulation_end();
    }

    public void simulation_start(){
        if(mysim != null)
            mysim.simulation_start();
    }
     */
    public void setStartSimulationAttributes(int save_all_stats_step, double max_clock_time,
            double TM_ENERGY_THSLD_STEP, double NEXT_RESET_TIMEOUT, int pm_step, int pm_sleep,
            String report_descriptor) {
        if(save_all_stats)
            this.save_all_stats_step = save_all_stats_step;
        this.max_clock_time = max_clock_time;
        this.TM_ENERGY_THSLD_STEP = TM_ENERGY_THSLD_STEP;
        this.NEXT_RESET_TIMEOUT = NEXT_RESET_TIMEOUT;
        mysim.pm_step = pm_step;
        mysim.pm_sleep = pm_sleep;
        if(!batch_simulation && (save_stats || save_events_log || save_lifetime_log || save_results_log))
            this.report_descriptor = report_descriptor;
    }

    
    public void reset_sim(){
        mysim=null;
        mysim = new the_sim();
    }
    
    public void StartSimulation(){

        int i,j;
        mysim.active_sinks=0;
        num_events=0;
        num_messages=0;
        num_messages_long=0;
        num_messages_r=0;
        num_messages_long_r=0;
        num_messages_long_l=0;
        num_messages_l=0;
        num_messages_data_r_sink=0;
        num_messages_data_generated=0;
        total_energy_spent=0;
        mysim.count_dead=0;
        mysim.mat_area = new byte[mysim.w][mysim.h];
        TC_Prot_final=false;
        temp_lifetime_string = "";
        temp_lifetimeSurvivors_string = "";
        temp_lifetimeBFS_string = "";
        temp_lifetimeBFS_Coverage_c_string = "";
        temp_lifetimeBFS_Coverage_s_string = "";
        temp_lifetimeMessageLoss_string = "";

       

        //Redefining the sorting mode on the nodes
        for(i=0;i<mysim.numpoints;i++){
            getNode(i).setSortingMode(mysim.sortingmode);
            getNode(i).setTM_energy_step(TM_ENERGY_THSLD_STEP);
        }

        //If a motion protocol was selected, then start it on the nodes
        if(selected_Motionprotocol!=0){
          simulator.init_nodes(treeID,MOTION_PROTOCOL);
        }

        for(i=0;i<mysim.w;i++){
            for(j=0;j<mysim.h;j++){
                mysim.mat_area[i][j] = 0;
            }
        }

        if(!mysim.all_trees){                                                 //Each tree will start its sinks at the click of the Start atarraya button.
            treeID++;
            if(treeID <= MAX_TREES){
                simulator.init_nodes(treeID,TC_PROTOCOL);
                for(i=0;i<mysim.num_sinks_per_tree[treeID];i++){
                    simulator.initial_event(mysim.active_sinks+mysim.numnodes, treeID,TC_PROTOCOL);
                    mysim.active_sinks++;
                }
            }

        }else{                                                          //All trees will start their sinks at the same time.


            for(j=0;j<MAX_TREES;j++){
                if(mysim.num_sinks_per_tree[j] > 0){              //If there are sinks in that tree...
                    simulator.init_nodes(j,TC_PROTOCOL);
                    for(i=0;i<mysim.num_sinks_per_tree[j];i++){
                        clock = TREE_CONSTRUCTION_DELAY*j;
                        simulator.initial_event(mysim.active_sinks+mysim.numnodes, j,TC_PROTOCOL);
                        mysim.active_sinks++;
                    }
                }
            }
            clock=0;
        }

         try{

            if(!batch_simulation && (save_stats || save_events_log || save_lifetime_log || save_results_log)){
                timestamp t = new timestamp();
                view.update(Observer.UPDATE_VNI_ID, 0);
                view.update(Observer.UPDATE_TREEIDVIZ, -1);
                view.update(Observer.SET_ACTIVE_TREE_VIZ, "");
                view.update(Observer.SET_VIEW_ACTIVE_TREE, true);
                


                if(myFile!=null){
                    

                    the_parent_dir = myFile.getPath();
                    
                    the_name = myFile.getName();
                    the_name2 = report_descriptor + "_" + mysim.numnodes + "_" + mysim.numsinks + "_" + mysim.w + "_" + mysim.h + "_" + t.toString2();

                }else{
                     view.update(Observer.SET_FILE_SELECTION_MODE, javax.swing.JFileChooser.DIRECTORIES_ONLY);
                     view.update(Observer.SHOW_SAVE_FILE, "");
                     view.update(Observer.SET_FILE_SELECTION_MODE, javax.swing.JFileChooser.FILES_AND_DIRECTORIES);
                    if ( myFile.exists()) {

                        if(myFile.isDirectory()){
                            the_parent_dir = myFile.getPath();

                            //This is where a real application would open the file.
                            view.update(Observer.SHOW_MSG, "Saving stats from simulation in: " + the_parent_dir);//showMessage("Saving stats from simulation in: " + the_parent_dir);

                        }

                    } else {
                        view.update(Observer.SHOW_MSG, "Save command cancelled by user.");//showMessage("Save command cancelled by user.");
                    }

                    the_name2 = report_descriptor + "_" + mysim.numnodes + "_" + mysim.numsinks + "_" + mysim.w + "_" + mysim.h + "_" + t.toString2()+".atar";
                }

                if(save_stats){
                    if(excel_ready_reports)
                        fout_log_stat = new FileWriter(the_parent_dir+"\\stats_"+the_name2+".csv");
                    else
                        fout_log_stat = new FileWriter(the_parent_dir+"\\stats_"+the_name2+".atar");
                    mywrite_log_stat = new BufferedWriter(fout_log_stat);
                }

                if(save_events_log){
                    fout_log_ev = new FileWriter(the_parent_dir+"\\events_"+the_name2+".csv");
                    mywrite_log_ev = new BufferedWriter(fout_log_ev);
                }

                if(save_lifetime_log){
                    fout_log_lt = new FileWriter(the_parent_dir+"\\lifetime_"+the_name2+".csv");
                    mywrite_log_lt = new BufferedWriter(fout_log_lt);
                }

                if(save_results_log){
                    fout_log_results = new FileWriter(the_parent_dir+"\\results_"+the_name2+".csv");
                    mywrite_log_results = new BufferedWriter(fout_log_results);
                }

            }

        }catch(Exception ex){ex.printStackTrace();}


        
        tempsim = null;
        //tempsim = new the_sim();
        try{
        tempsim = (the_sim) mysim.clone();
        tempsim.simulation_start();
        tempsim.start();
        }catch(Exception ex){
            ex.printStackTrace();
            mysim.simulation_start();
            mysim.start();
        }
         
         //mysim.simulation_start();
         //mysim.start();
        
        if(batch_simulation){
            try{
                tempsim.join();
                //mysim.join();
            }catch(Exception ex){ex.printStackTrace();}
        }
    }

    
    
    public void TransformReport2(String the_file, String the_parent_dir, double step_time){

        String temp;
        String temp_time[], temp_bfs[], temp_bfs_coverage_c[], temp_bfs_coverage_s[], temp_message_loss[];
        double temp_ratio,temp_max, temp_val=0, max_time=0, prev_value=0, prev_time=0, temp_time_val=0;
        double prev_value_coverage_c=0, prev_value_coverage_s=0, temp_ratio_coverage_c = 0, temp_ratio_coverage_s = 0, temp_message_loss_ratio=0, prev_value_message_loss=0;
        //double step_time=500.0;
        int i=0, j=0, k=0, temp_lenght, size_r, size_c;
        int count_rows=0;
        double mat[][],mat2[][];

        try{

            fin = new FileReader(the_parent_dir+"\\"+the_file);
            myread = new BufferedReader(fin);

            // Finding the highest time
            while((temp = myread.readLine()) != null){
                temp_time = temp.split(",");
                temp = myread.readLine();
                temp = myread.readLine();
                temp = myread.readLine();
                temp = myread.readLine();
                temp = myread.readLine();

                i = temp_time.length;
                temp_max =  Double.parseDouble(temp_time[i-1]);
                if(temp_max>max_time)
                    max_time = temp_max;

                count_rows++;
            }

            myread.close();
            fin.close();

            size_r = (int)java.lang.Math.ceil(max_time/step_time);
            mat = new double[size_r][5];
            mat2 = new double[size_r][5];

            for(i=0;i<size_r;i++){
                mat[i][0]=step_time*i;
                mat2[i][0]=step_time*i;
                //Active nodes
                mat[i][1]=0;
                mat2[i][1]=0;
                //Covered area comm
                mat[i][2]=0;
                mat2[i][2]=0;
                //Covered area sensing
                mat[i][3]=0;
                mat2[i][3]=0;
                //Message Loss
                mat[i][4]=0;
                mat2[i][4]=0;
            }

            fin = new FileReader(the_parent_dir+"\\"+the_file);
            myread = new BufferedReader(fin);

            // Finding the average fot each time step
            while((temp = myread.readLine()) != null){
                temp_time = temp.split(",");
                temp = myread.readLine();
                temp = myread.readLine();
                temp_bfs = temp.split(",");
                temp = myread.readLine();
                temp_bfs_coverage_c = temp.split(",");
                temp = myread.readLine();
                temp_bfs_coverage_s = temp.split(",");
                temp = myread.readLine();
                temp_message_loss = temp.split(",");

                temp_lenght =temp_time.length;

                temp_max=1;


                /*
                 * Based on the assumption that all not-covered nodes will be covered, we considered that if an
                 * active node died before the TC protocol ended, then the nodes that it was going to cover in the future
                 * will be covered by someone else, so we can ignore them from the count.
                 */

                 prev_value = 1;
                 prev_value_coverage_c = 1;
                 prev_value_coverage_s = 1;
                 prev_time = 0;

                 for(i=0;i<size_r;i++){
                    mat2[i][1]=0;
                    mat2[i][2]=0;
                    mat2[i][3]=0;
                    mat2[i][4]=0;
                 }

                 //For each chunk of time, we will add a proportion of the values based on the time or occurrence in the chunk
                 i=1; //Index for the point in the series
                 j=0; //Index for the row in the matrix mat

                 while(i<temp_lenght){

                    //Getting values of ratio and time from the point

                     temp_ratio = Double.parseDouble(temp_bfs[i]);
                     if(i==1)
                        prev_value = temp_ratio;


                     temp_ratio_coverage_c = Double.parseDouble(temp_bfs_coverage_c[i]);
                     if(i==1)
                            prev_value_coverage_c = temp_ratio_coverage_c;

                     temp_ratio_coverage_s = Double.parseDouble(temp_bfs_coverage_s[i]);
                     if(i==1)
                            prev_value_coverage_s = temp_ratio_coverage_s;

                    temp_message_loss_ratio = Double.parseDouble(temp_message_loss[i]);
                     if(i==1)
                            prev_value_message_loss = temp_message_loss_ratio;
                     
                    temp_time_val = Double.parseDouble(temp_time[i]);


                    //Getting the time chunk in which thid event happened
                    k = (int)(temp_time_val/step_time);
                    if(k==size_r)
                            k--;

                    if(j<k){

                        //Finishing the
                        temp_val = 1-prev_time;
                        mat2[j][1] += prev_value*temp_val;
                        mat2[j][2] += prev_value_coverage_c*temp_val;
                        mat2[j][3] += prev_value_coverage_s*temp_val;
                        mat2[j][4] += prev_value_message_loss*temp_val;
                        j++;

                        while(j<k){
                            //Include the ratio on the chunk on the sum
                            mat2[j][1] = mat2[j-1][1];
                            mat2[j][2] = mat2[j-1][2];
                            mat2[j][3] = mat2[j-1][3];
                            mat2[j][4] = mat2[j-1][4];
                            j++;
                        }
                        prev_time=0;
                    }

                    //Including the initial chunk of the value, previous to the current point
                    temp_val = (temp_time_val - (step_time*k))/step_time;
                    mat2[k][1] += prev_value*(temp_val -prev_time);
                    mat2[k][2] += prev_value_coverage_c*(temp_val -prev_time);
                    mat2[k][3] += prev_value_coverage_s*(temp_val -prev_time);
                    mat2[k][4] += prev_value_message_loss*(temp_val -prev_time);

                    prev_value = temp_ratio;
                    prev_value_coverage_c = temp_ratio_coverage_c;
                    prev_value_coverage_s = temp_ratio_coverage_s;
                    prev_value_message_loss = temp_message_loss_ratio;
                    prev_time = temp_val;

                    i++;
                 }

                 if(k<size_r){

                     //Including the initial chunk of the value, previous to the current point

                    mat2[k][1] += prev_value*(1-prev_time);
                    mat2[k][2] += prev_value_coverage_c*(1-prev_time);
                    mat2[k][3] += prev_value_coverage_s*(1-prev_time);
                    mat2[k][4] += prev_value_message_loss*(1-prev_time);
                    k++;

                    while(k<size_r){
                        //Include the ratio on the chunk on the sum
                        //mat2[k]=mat2[k-1];
                        mat2[k][1]=0;
                        mat2[k][2]=0;
                        mat2[k][3]=0;
                        mat2[k][4]=0;
                        k++;
                    }

                }

                 for(i=0;i<size_r;i++){
                    mat[i][1] += mat2[i][1];
                    mat[i][2] += mat2[i][2];
                    mat[i][3] += mat2[i][3];
                    mat[i][4] += mat2[i][4];
                 }

            }
            myread.close();
            fin.close();

            fout = new FileWriter(the_parent_dir+"\\"+the_file+"_sumary.csv");

            mywrite = new BufferedWriter(fout);

            mywrite.write("Time, Active Nodes, Comm Coverage, Sensing Coverage, Message Loss\n");
            for(i=0;i<size_r;i++)
                mywrite.write(""+(mat[i][0])+","+(mat[i][1]/count_rows)+","+(mat[i][2]/count_rows)+","+(mat[i][3]/count_rows)+","+(mat[i][4]/count_rows)+"\n");

            mywrite.flush();
            mywrite.close();
            fout.close();

        }catch(Exception ex){ex.printStackTrace();}
    }

    public boolean verifpa(int n, int t){
        return getNode(n).getInfrastructure(t).isActive();
    }

    protected class the_sim extends Thread implements Cloneable{
    // Main data structure. All information about the nodes is stored here. YA EN SIM
    Vector<node> mynodes;

    int w, h;                        //Width and Height of the deployment area
    int numnodes;               //Number of regular nodes (no sink)
    int numsinks;                //Total number of sink nodes
    int numpoints;              //The total number of points in the area = nodes + sinks
    int[] num_sinks_per_tree;   //Number of sinks per tree
    int[] count_active;                          // Counts how many nodes are active

    boolean all_trees;                      // Switch to start or not all trees in paralel on the SimulationStart() method
    int active_sinks;                           // Counter of sinks that have been initiated. It has to be global because of the possibility of pressing Start several times
    int simmode;                            // This variable is related to the first combobox on the other params tear in Deployment

    String sim_error;                     // String that includes on stats if there was an error on the execution of the sim
    double candidate_grouping_step;

    Semaphore sem2;                     //Grant access to the data structure Node

    eventQueue myqueue_;
    boolean mainSW_, simstart_, simfin_;
    int count_end;
    double prev_clock;

    double covered_area;                     // Percentage of covered area by the active nodes
    double covered_area_sens;                     // Percentage of covered area by the active nodes
    double covered_area_from_sink_c;      // Percentage of covered area by the active nodes connected to the sink
    double covered_area_from_sink_s;      // Percentage of covered area by the active nodes connected to the sink
    boolean view_covered_area_stat;    // Signal to calculate the covered area on the stats
    byte[][] mat_area;                          // Auxiliary matrix to calculate the covered area

    double covered_area_sens_k;
    double covered_area_sens_k_all;

    int count_dead;                             // Total number of dead nodes
    int count_nodes_with_dead_parent; // Total number of nodes disconnected

    int contNeighb;                       // Temporary variable to calculate the average number of neighbors
    double avgNeighb;                        // Average number of neighbors of a node on the topology
    int[] notCovered_Visited;               //Structure to store not covered and not visited nodes.
    double avgNeighbActiveNodes;      // Average number of neighbors of the active nodes on the topology
    int ReachableNeighbActiveNodes;      // Number of active neighbors reachbale from the sink node
    double avg_level;                          // Average level of the nodes on the topology

    double alpha_coverage_value;

    //simulation variables
    int sortingmode;                        // This variable is related to the second combobox on the other params tear in Deployment

    double bit_error_rate;                  // Bit error rate assigned to the deployment area to simulate random packet loss
    double default_bit_error_rate;                  // Bit error rate assigned to the deployment area to simulate random packet loss
    
    int pm_step;
    int pm_sleep;

    int multiplicity;               // How many times do we want a single scenario to be simulated
    int total_alpha;

    //Temporary variables useful for having control of node id's in nodes creation
    int current_node_count;
    int tempnumnodes;


        public the_sim(){
            mynodes = new Vector<node>();
            numnodes = 0;
            numsinks = 0;
            numpoints = numnodes + numsinks;
            candidate_grouping_step = 0.20;
            num_sinks_per_tree = new int[MAX_TREES];
            count_active = new int[MAX_TREES];
            for(int i=0;i<MAX_TREES;i++){
                num_sinks_per_tree[i] = 0;
                count_active[i] = 0;
            }
            w = 600;
            h = 600;
            sem2 = new Semaphore(1);
            myqueue_ = new eventQueue();
            mainSW_=true;
            simstart_=false;
            simfin_=false;
            count_end = numsinks;
            sim_error = "no error";

            count_dead=0;
            count_nodes_with_dead_parent=0;
            covered_area = 0;
            covered_area_sens = 0;
            covered_area_from_sink_c = 0;
            covered_area_from_sink_s = 0;
            view_covered_area_stat = false;
            covered_area_sens_k = 0;
            covered_area_sens_k_all = 0;
            avgNeighb = 0;
            avgNeighbActiveNodes = 0;
            notCovered_Visited = new int[2];
            avg_level = 0;

            sortingmode = METRIC1_ONLY;
            bit_error_rate = 0;
            default_bit_error_rate = 0;

            pm_step = 20;
            pm_sleep = 10;
            all_trees = false;
            active_sinks = 0;
            simmode = 0;

            multiplicity = 1;
            total_alpha = 1;

            current_node_count = 0;
            tempnumnodes=0;
        }

        public Object clone(){
            try{
              /*the_sim cloned = new the_sim();
              cloned = (the_sim)super.clone();*/
              the_sim cloned = (the_sim)super.clone();
              cloned.mainSW_ = true;
              cloned.count_end = numsinks;
              cloned.simfin_ = false;
              return cloned;
            }
            catch(CloneNotSupportedException e){
              System.out.println(e);
              return null;
            }
        }

        public void clearnodes(){
        
            mynodes = null;
            mynodes = new Vector<node>();
            
        }
        
        public node getNode(int n){

            node temp_node=null;

            try{
                //sem2.acquire();
                temp_node = mynodes.get(n);
                //sem2.release();
            }catch(Exception ex){ex.printStackTrace();}

            return temp_node;
        }

        public int getMatArea(int x, int y){

            if(x<0 || x>w-1 || y<0 || y>h-1)
                return -1;
            //Returning 1 will avoid the calc_coverage_area to evaluate the point x,y that is outside the area of coverage.

            return mat_area[x][y];
        }

        public void CountNotVisited(){

            int contNotVis=0, contNotCov=0 ,i,j;
            int temp_level=0, temp_tree=0;
            int countNeighbActiveNodes=0;
            double[] temp_coverage_k = new double[3];
            int temp=0, temp2=0;
            count_nodes_with_dead_parent=0;
            total_energy=0;
            total_energy_tree=0;
            for(i=0;i<MAX_TREES;i++)
                count_active[i]=0;

            if(mynodes.size()>0){

            for(i=0;i<numpoints;i++){

                temp_tree = getNode(i).getActiveTree();
                if(!getNode(i).isCovered(temp_tree)){
                    contNotCov++;
                }
                if(!getNode(i).isVisited(temp_tree)){
                    contNotVis++;
                }
                for(j=0;j<MAX_TREES;j++){
                    if(getNode(i).isActive(j)){
                        count_active[j]++;
                        total_energy_tree+= getNode(i).getEnergy();
                    }
                }

                if(getNode(i).isActive(temp_tree)){
                    //countNeighbActiveNodes+= getNode(i).getNumGateways(temp_tree);
                    temp = getNode(i).getNumNeighbors();
                    
                    for(j=0;j<temp;j++){
                        temp2=getNode(i).getNeighborID(j);
                        if(getNode(temp).isActive(temp_tree))
                            countNeighbActiveNodes++;
                    }
                        
                    
                }

                if(!getNode(i).isSink(temp_tree)){
                    temp = getNode(i).getDefaultGateway(temp_tree);
                    if(temp!=-1){
                       if(!getNode(temp).isActive(temp_tree)){
                         count_nodes_with_dead_parent++;
                       }
                    }else
                        count_nodes_with_dead_parent++;
                }

                temp_level += getNode(i).getLevel(temp_tree);
                total_energy += getNode(i).getEnergy();

            }

            if(count_active[0]>0)
                    avgNeighbActiveNodes = ((double)countNeighbActiveNodes/(double)count_active[0]);
                else
                    avgNeighbActiveNodes = 0;

            notCovered_Visited[0]=contNotCov;
            notCovered_Visited[1]=contNotVis;
            avg_level = (double)temp_level/(double)numpoints;

            view.update(Observer.UPDATE_IDEAL_P, "");
            view.update(Observer.UPDATE_GRID_MODE_TEXT, "");

            ReachableNeighbActiveNodes = BFS(BFS_MODE_ACTIVE_ALIVE_FROM_SINKS_CHILDREN_ONLY);

            if(view_covered_area_stat || save_stats){
                covered_area = calc_coverage_area(0);
                temp_coverage_k = calc_coverage_area_k(1);
                //covered_area_sens = calc_coverage_area(1);
                covered_area_sens = temp_coverage_k[1];
                covered_area_sens_k  = temp_coverage_k[0];
                covered_area_sens_k_all = temp_coverage_k[2];
            }else{
                covered_area=0;
                covered_area_sens=0;
            }


            }
        }

        public double[] calc_coverage_area_k(int mode){

            int i=0,j=0,k=0, temp_tree=0;
            double[] count= new double[3];
            boolean sw=true;
            int x=0,y=0,range=0, dia=0;
            int tx=0,ty=0, temp=0;
            int desp_x=0, desp_y=0;


            for(i=0;i<w;i++){
                for(j=0;j<h;j++){
                    mat_area[i][j] = 0;
                }
            }

            for(k=0;k<numpoints;k++){
                temp_tree = getNode(k).getActiveTree();

                if(getNode(k).isActive(temp_tree)){
                    //Coordinates of the center of the comm range
                    x = (int)getNode(k).getPosition().getX();
                    y = (int)getNode(k).getPosition().getY();

                    if(mode==0){
                        //Radius of the comm range
                        range = (int)getNode(k).getRadius(temp_tree);
                    }else if(mode==1)
                        range = (int)getNode(k).getSense_Radius();

                    dia = range*2-1;

                    //coordinates od the upper corner of a square containing the comm area
                    tx = x-range;
                    ty = y-range;

                    //Distance from a corner to the circunference
                    temp = (int)java.lang.Math.floor(range*0.4147);

                    for(i=0;i<=range;i++){
                        for(j=0;j<=i;j++){

                            //upper left corner checking
                            desp_y = ty+i-j;
                            desp_x = tx+j;
                            //upper left corner checking

                            if(getMatArea(desp_y, desp_x) >= 0)
                            if(getNode(k).covers(desp_x, desp_y,mode)){
                                mat_area[desp_y][desp_x]++;
                            }

                            desp_y = y-i+j;
                            desp_x = x-j;

                            if(getMatArea(desp_y, desp_x) >= 0){
                                mat_area[desp_y][desp_x]++;
                            }

                            //upper right corner checking
                            desp_y = ty+i-j;
                            desp_x = tx+dia-j;
                            //upper left corner checking
                            if(getMatArea(desp_y, desp_x) >= 0)
                            if(getNode(k).covers(desp_x, desp_y,mode)){
                                mat_area[desp_y][desp_x]++;
                            }
                            desp_y = y-i+j;
                            desp_x = x+j;
                            if(getMatArea(desp_y, desp_x) >= 0){
                                mat_area[desp_y][desp_x]++;
                            }

                            //lower left corner checking
                            desp_y = ty+dia-i+j;
                            desp_x = tx+j;
                            //upper left corner checking
                            if(getMatArea(desp_y, desp_x) >= 0)
                            if(getNode(k).covers(desp_x, desp_y,mode)){
                                mat_area[desp_y][desp_x]++;
                            }
                            desp_y = y+i-j;
                            desp_x = x-j;
                            if(getMatArea(desp_y, desp_x) >= 0){
                                mat_area[desp_y][desp_x]++;
                            }


                            //lower right corner checking
                            desp_y = ty+dia-i+j;
                            desp_x = tx+dia-j;
                            //upper left corner checking
                            if(getMatArea(desp_y, desp_x) >= 0)
                            if(getNode(k).covers(desp_x, desp_y,mode)){
                                mat_area[desp_y][desp_x]++;
                            }
                            desp_y = y+i-j;
                            desp_x = x+j;
                            if(getMatArea(desp_y, desp_x) >= 0){
                                mat_area[desp_y][desp_x]++;
                            }


                        }
                    }

                }
            }



            for(i=0;i<w;i++){
                for(j=0;j<h;j++){
                    count[2] += mat_area[i][j];
                    //K coverage average
                    if(mat_area[i][j] != 0){
                        count[0] += mat_area[i][j];
                        temp++;
                    }
                    //Just coverage
                    if(mat_area[i][j] != 0)
                        count[1]++;
                }
            }

            count[0]/=((double)(temp));
            count[1]/=((double)(h*w));
            count[2]/=((double)(h*w));

            return count;
        }

        public double calc_coverage_area(int mode){

            int i=0,j=0,k=0, temp_tree=0;
            double count=0;
            boolean sw=true;
            int x=0,y=0,range=0, dia=0;
            int tx=0,ty=0, temp=0;
            int desp_x=0, desp_y=0;


            for(i=0;i<w;i++){
                for(j=0;j<h;j++){
                    mat_area[i][j] = 0;
                }
            }

            for(k=0;k<numpoints;k++){
                temp_tree = getNode(k).getActiveTree();

                if(getNode(k).isActive(temp_tree)){
                    //Coordinates of the center of the comm range
                    x = (int)getNode(k).getPosition().getX();
                    y = (int)getNode(k).getPosition().getY();

                    if(mode==0){
                        //Radius of the comm range
                        range = (int)getNode(k).getRadius(temp_tree);
                    }else if(mode==1)
                        range = (int)getNode(k).getSense_Radius();

                    dia = range*2-1;

                    //coordinates od the upper corner of a square containing the comm area
                    tx = x-range;
                    ty = y-range;

                    //Distance from a corner to the circunference
                    temp = (int)java.lang.Math.floor(range*0.4147);

                    for(i=0;i<=range;i++){
                        for(j=0;j<=i;j++){

                            //upper left corner checking
                            desp_y = ty+i-j;
                            desp_x = tx+j;
                            //upper left corner checking
                            if(getMatArea(desp_y, desp_x) == 0){
                                if(getNode(k).covers(desp_x, desp_y,mode)){
                                    mat_area[desp_y][desp_x] = 1;
                                }
                            }
                            desp_y = y-i+j;
                            desp_x = x-j;
                            if(getMatArea(desp_y, desp_x) == 0){
                                mat_area[desp_y][desp_x] = 1;
                            }

                            //upper right corner checking
                            desp_y = ty+i-j;
                            desp_x = tx+dia-j;
                            //upper left corner checking
                            if(getMatArea(desp_y, desp_x) == 0){
                                if(getNode(k).covers(desp_x, desp_y,mode)){
                                    mat_area[desp_y][desp_x] = 1;
                                }
                            }
                            desp_y = y-i+j;
                            desp_x = x+j;
                            if(getMatArea(desp_y, desp_x) == 0){
                                mat_area[desp_y][desp_x] = 1;
                            }

                            //lower left corner checking
                            desp_y = ty+dia-i+j;
                            desp_x = tx+j;
                            //upper left corner checking
                            if(getMatArea(desp_y, desp_x) == 0){
                                if(getNode(k).covers(desp_x, desp_y,mode)){
                                    mat_area[desp_y][desp_x] = 1;
                                }
                            }
                            desp_y = y+i-j;
                            desp_x = x-j;
                            if(getMatArea(desp_y, desp_x) == 0){
                                mat_area[desp_y][desp_x] = 1;
                            }


                            //lower right corner checking
                            desp_y = ty+dia-i+j;
                            desp_x = tx+dia-j;
                            //upper left corner checking
                            if(getMatArea(desp_y, desp_x) == 0){
                                if(getNode(k).covers(desp_x, desp_y,mode)){
                                    mat_area[desp_y][desp_x] = 1;
                                }
                            }
                            desp_y = y+i-j;
                            desp_x = x+j;
                            if(getMatArea(desp_y, desp_x) == 0){
                                mat_area[desp_y][desp_x] = 1;
                            }


                        }
                    }

                }
            }



            for(i=0;i<w;i++){
                for(j=0;j<h;j++){
                    count += mat_area[i][j];
                }
            }

            return count/((double)(h*w));
        }

        public boolean checkSimFinish(){

            int i=0;
            int count_finish=0;
            int count_total=0;

            if(myqueue_.getSize() == 1)
                    i=i+1-1;

            while(i<MAX_TREES){
                if(num_sinks_per_tree[i]>0){
                    if(checkSimFinish(i)){
                        count_finish++;
                    }
                    count_total++;
                }
                i++;
            }

            if(count_total==count_finish){

                //If it is just TC
                if(!TM_Selected && !SD_Selected){
                    view.update(Observer.REPAINT, "");
                    return true;
                }else{
                    //If it is not just TC

                    //If the TC has already finished
                    if(TC_Prot_final){
                        view.update(Observer.REPAINT, "");
                        return true;

                    }else{
                        //If this is the ending of the TC an it is not only TC
                        TC_Prot_final = true;

                        //Save stats when the TC algorithm finished
                        if(save_lifetime_log){
                            addStatToLifetimeLog(""+clock);
                        }

                        if(save_stats){
                            CountNotVisited();
                            addStatToReport(the_name);
                        }


                    }
                }
            }

            return false;
        }

        public boolean checkSimFinish(int tree){

            int i=0;
            boolean sw=false;

            if((!TM_Selected && !SD_Selected) || !TC_Prot_final){

            while(i<numpoints && simulator.CheckIfDesiredFinalState(getNode(i).getState(tree),TC_PROTOCOL)){
                i++;
            }

            if(i==numpoints)
                return true;

            return false;

            }

            return sw;
        }

        public void Push(event_sim ev){
            myqueue_.Push(ev);
        }

        public void InvalidateAllEventsFromIDFromTimeTOfCodeC(int id, double t, int c, int tree){
            myqueue_.InvalidateAllEventsFromIDFromTimeTOfCodeC(id,t,c,tree);
        }

        public void InvalidateAllEventsFromIDFromTimeT(int id, double t, int tree){
            myqueue_.InvalidateAllEventsFromIDFromTimeT(id,t,tree);
        }

        public void InvalidateAllEventsFromIDFromTimeTOfTypeTy(int id, double t, int Ty, int tree){
            myqueue_.InvalidateAllEventsFromIDFromTimeTOfTypeTy(id,t,Ty,tree);
        }

        public void InvalidateAllEventsFromIDFromTimeTOfTypeTyOfCodeC(int id, double t, int Ty, int c, int tree){
            myqueue_.InvalidateAllEventsFromIDFromTimeTOfTypeTyOfCodeC(id,t,Ty,c,tree);
        }

        public void InvalidateRxAllEventsFromIDFromTimeTOfTypeTyOfCodeC(int id, double t, int Ty, int c, int tree){
            myqueue_.InvalidateRxAllEventsFromIDFromTimeTOfTypeTyOfCodeC(id,t,Ty,c,tree);
        }

        public void simulation_end_by_user(){
            mainSW_ = false;
        }

        public void simulation_end(){
            //The simulation will end when all sinks say that the simulation has ended
            if(count_end>1)
                count_end--;
            else
                simfin_ = true;
        }

        public void simulation_start(){
            simstart_ = true;
        }

        public void simulation_pause(){
            simstart_ = false;
        }

        public boolean isSimulationStarted(){
            return simstart_;
        }

        public boolean isSimulationOn(){
            return mainSW_;
        }

        public void updateEnergy(double time){

            int i, temp_tree;

            //Just regular nodes will have their energy updated (0 to numnodes-1)
            //The sink nodes are assumed to have infinite energy resources
            for(i=0; i<numnodes; i++){
                if(getNode(i).isAlive()){
                    getNode(i).useEnergy(OPER_IDLE, time);
                    checkEnergy(i);
                }
            }

        }

        public int getOperType_TX_RX(int _code, int op){

        int oper=0;

        switch(op){
            case OPER_TX:
                if(_code==SON_RECOGNITION || _code==DATA)
                    oper = OPER_TX_LONG;
               else
                    oper = OPER_TX_REGULAR;
            break;

            case OPER_RX:
                if(_code==SON_RECOGNITION || _code==DATA)
                    oper = OPER_RX_LONG;
                else
                    oper = OPER_RX_REGULAR;
            break;

        }



        return oper;
        }

        @Override
        public void run(){
            sim_error = "no error";
            event_sim tempevent_;
            boolean sw=false;
            long c=0;
            clock=0;
            prev_clock=0;
            double temp_clock_for_step=0;
            int i=0,j=0;
            double prob_error;
            int size_packet;
            double temp_radius = 0;
            double temp_distance = 0;
            boolean rx_message = true;
            boolean tx_message = true;
            atarraya.element.register temp_node;

            while(mainSW_){
                /*
                 * 1. Check for the next event on the queue
                 * If event is not null,
                 *   2. Update the clock
                 *   3. Send the event to the event handler
                 * end if
                 * 4. Back to step 1.
                */
                if(simstart_){
                    tempevent_ = myqueue_.Pop();
                    sw = checkSimFinish();
                    if(tempevent_ != null && !sw && !simfin_){

                        if(tempevent_.isValid()){

                            //If the event is a Message....
                            if(tempevent_.getType()==SENSOR_PROTOCOL && tempevent_.getCode()==DATA)
                                    i=0;

                            if(tempevent_.getMessageType() != 0){



                                if(tempevent_.getMessageType() == OPER_RX){
                                    //Boolean that defined if the node is able to receive the message
                                    //rx_message =  getNode(tempevent_.getReceiver()).isAlive() && getNode(tempevent_.getReceiver()).isRadioOn(tempevent_.getTree());
                                    //rx_message =  getNode(tempevent_.getReceiver()).isAlive() && ((getNode(tempevent_.getReceiver()).isRadioOn(tempevent_.getTree()) && getNode(tempevent_.getReceiver()).getEnergyState() != STATE_JUST_RADIO) || tempevent_.getType() == TM_PROTOCOL);
                                    rx_message =  getNode(tempevent_.getReceiver()).isAlive() && (getNode(tempevent_.getReceiver()).isRadioOn() || (tempevent_.getType() == TM_PROTOCOL && getNode(tempevent_.getSender()).getEnergyState() == STATE_SLEEP));
                                    //Comm radius of the sender
                                    temp_radius = getNode(tempevent_.getSender()).getRadius(tempevent_.getTree());
                                } else if(tempevent_.getMessageType() == OPER_TX){
                                    //If the event was the transmission of the packet, it will not be executed. It will be used to use the energy on the sender node.
                                    tempevent_.setInvalid();
                                }
                                //Boolean that defined if the node is able to send the message
                                //tx_message =  getNode(tempevent_.getSender()).isAlive() && getNode(tempevent_.getSender()).isRadioOn(tempevent_.getTree());
                                //tx_message =  getNode(tempevent_.getSender()).isAlive() && ((getNode(tempevent_.getSender()).isRadioOn(tempevent_.getTree()) && getNode(tempevent_.getSender()).getEnergyState() != STATE_JUST_RADIO) || tempevent_.getType() == TM_PROTOCOL);
                                tx_message =  getNode(tempevent_.getSender()).isAlive() && (getNode(tempevent_.getSender()).isRadioOn(tempevent_.getTree()) || (tempevent_.getType() == TM_PROTOCOL && getNode(tempevent_.getSender()).getEnergyState() == STATE_SLEEP));
                                size_packet = simulator.GetMessageSize(tempevent_.getCode(), tempevent_.getType());
                                


                                // If the event is the reception of a packet and both sender and receiver can send and receive the message, then this event will be counted and executed
                                if(tempevent_.getMessageType() == OPER_RX && rx_message && tx_message){

                                    /**************************************************************/
                                
                                    //temp_distance = getNode(tempevent_.getSender()).calcDistance(getNode(tempevent_.getReceiver()));
                                    //bit_error_rate = getNode(tempevent_.getSender()).getCommModel().calcBER(temp_distance);
                                    temp_node = getNode(tempevent_.getSender()).getNeighborFromID(tempevent_.getReceiver());
                                    if(temp_node != null)
                                        bit_error_rate = temp_node.getBer();
                                    else
                                        bit_error_rate = 1;
                                    
                                    if(bit_error_rate == -1)
                                        bit_error_rate = default_bit_error_rate;
                                    
                                    prob_error = 1.0-java.lang.Math.pow(1.0-bit_error_rate,8*size_packet);
                                    //System.out.println(""+prob_error);
                                    
                                    /**************************************************************/
                                    
                                    // If the package did not get lost and if radius of the sender can reach the receiver
                                    if(getRandom(1) >= prob_error && temp_radius>=temp_distance){

                                        //Calculating the number of DATA packages
                                        if(tempevent_.getCode() == DATA){
                                            if(getNode(tempevent_.getReceiver()).isSink(tempevent_.getTree())){
                                                num_messages_data_r_sink++;
                                            }
                                            //If the message was ment to be received by temp_ID, then it will count.
                                            if(tempevent_.getDestination() == tempevent_.getReceiver())
                                                getNode(tempevent_.getReceiver()).addCountDataMessages(tempevent_.getTree());
                                        }


                                        //If the node is not a sink, use energy... Sinks are assumed tp have infinite energy!!
                                        if(!getNode(tempevent_.getReceiver()).isSink()){
                                            //Use of the energy for reception in the regular radio
                                            getNode(tempevent_.getReceiver()).useEnergy(getOperType_TX_RX(tempevent_.getCode(),OPER_RX), tempevent_.getTree());

                                            //Checking if the receiver node is dead after this operation
                                            //checkEnergy(tempevent_.getReceiver());
                                        }

                                        //Register a received packet
                                        getNode(tempevent_.getReceiver()).addPacketsReceived(tempevent_.getCode());
                                        //total_energy_spent = total_energy_spent + getNode(tempevent_.getReceiver()).calcEnergy(getOperType_TX_RX(tempevent_.getCode(),OPER_RX), tempevent_.getTree());

                                        //Counting received packets
                                        if(size_packet == SIZE_LONG_PACKETS){
                                            num_messages_long_r++;
                                        }else{
                                            num_messages_r++;
                                        }

                                    }else{
                                        //Lost packets count
                                         if(size_packet == SIZE_LONG_PACKETS)
                                            num_messages_long_l++;
                                         else
                                            num_messages_l++;
                                         //total_energy_spent = total_energy_spent + getNode(tempevent_.getReceiver()).calcEnergy(getOperType_TX_RX(tempevent_.getCode(),OPER_RX), tempevent_.getTree());
                                         tempevent_.setInvalid();
                                    } //End of the reception of the packet

                                    //If the node is not a sink, use energy... Sinks are assumed tp have infinite energy!!
                                        if(!getNode(tempevent_.getReceiver()).isSink()){
                                            //Use of the energy for reception in the regular radio
                                            getNode(tempevent_.getReceiver()).useEnergy(getOperType_TX_RX(tempevent_.getCode(),OPER_RX), tempevent_.getTree());
                                        }

                                        //Register a received packet
                                        total_energy_spent = total_energy_spent + getNode(tempevent_.getReceiver()).calcEnergy(getOperType_TX_RX(tempevent_.getCode(),OPER_RX), tempevent_.getTree());
                                    
                                    
                                 // If the event was de transmission of the packet and the sender can indeed send it
                                }else if(tempevent_.getMessageType() == OPER_TX && tx_message){

                                        //Counting sent packets
                                        if(size_packet == SIZE_LONG_PACKETS){
                                            num_messages_long++;
                                        }else{
                                            num_messages++;
                                        }

                                        //Updating the total energy spent on the network
                                        total_energy_spent = total_energy_spent + getNode(tempevent_.getSender()).calcEnergy(getOperType_TX_RX(tempevent_.getCode(),OPER_TX),tempevent_.getTree());

                                        //Register a sent packet
                                        getNode(tempevent_.getSender()).addPacketsSent(tempevent_.getCode());

                                        //Use of the energy for transmission, in the node is not a Sink
                                        if(!getNode(tempevent_.getSender()).isSink()){
                                                //Use of the energy for transmission in the regular radio
                                                getNode(tempevent_.getSender()).useEnergy(getOperType_TX_RX(tempevent_.getCode(),OPER_TX), tempevent_.getTree());
                                                //Checking if the sender node is dead
                                                //checkEnergy(tempevent_.getSender());
                                        }

                                    }
                            }

                            if(tempevent_.isValid()){
                            view.update(Observer.SHOW_EVENT_LIST, tempevent_.toString());

                            //Saving all stats if the option was selected
                            if(save_all_stats){
                                try{
                                    if(clock >= temp_clock_for_step){
                                        temp_clock_for_step+=save_all_stats_step;
                                        CountNotVisited();
                                        addStatToReport(the_name);
                                    }
                                }catch(Exception ex){ex.printStackTrace();}
                            }


                            num_events++;

                            if(clock > 500*j){
                              j++;
                              view.update(Observer.SHOW_EVENT_COUNT, "Events: "+num_events+" Clock: "+clock/*clock_format.format(clock)*/); //showEventCount("Events: "+num_events+" Clock: "+clock_format.format(clock));
                              view.update(Observer.SHOW_QUEUE_SIZE, "Queue Size: "+ myqueue_.getSize());//jLabel43.setText("Queue Size: "+ myqueue_.getSize());
                              view.update(Observer.REPAINT, "");//myPanel.repaint();
                            }

//                            showEventCount("Events: "+num_events+" Clock: "+clock_format.format(clock));
  //                          jLabel43.setText("Queue Size: "+ myqueue_.getSize());

                            //If there is such a thing like time travel, then this condition will become true!
                            if(clock > tempevent_.getTime())
                                i=0;

                            clock = tempevent_.getTime();

                            //Updating the energy of all nodes
                            if(clock - prev_clock >0){
                                updateEnergy(clock - prev_clock);
                                //Update the time on the previous clock
                                prev_clock = clock;
                            }


                            simulator.HandleEvent(tempevent_);

                            if(clock > max_clock_time)
                                simfin_ = true;

                            //Online stats shown on the interace
                            if(liveStats/*jCheckBox6.isSelected()*/){
                                UpdateStats();
                            }

                            //Saving all events if the option was selected
                            if(save_events_log){
                                try{
                                    mywrite_log_ev.write(tempevent_.toString());
                                    mywrite_log_ev.newLine();
                                }catch(Exception ex){ex.printStackTrace();}
                            }
                        }
                        }

                    }else{
                        if(clock>0){
                            simstart_=false;
                            mainSW_=false;
                            //sw = checkSimFinish();
                            if(sw || simfin_){
                                view.update(Observer.SHOW_SIM_MSG, "Simulation Finished");
                                 if(!batch_simulation){
                                    view.update(Observer.PRINT_MSG, "Simulation Finished in "+clock);
                                }

                            }else{
                                if(myqueue_.getSize()==0){
                                    if(!batch_simulation)
                                        view.update(Observer.PRINT_MSG,"ERROR IN SIMULATION!! Event queue is empty and algorithm did not finish!!");//printmessage("ERROR IN SIMULATION!! Event queue is empty and algorithm did not finish!!");
                                    sim_error = "error";
                                }
                            }

                            //Saving the last image of the stats of a simulation not in a batch execution
                                if(!batch_simulation){
                                    if(save_stats){
                                        try{
                                            CountNotVisited();
                                            addStatToReport(the_name2);
                                            SaveReport();
                                        }catch(Exception ex){ex.printStackTrace();}
                                    }else{
                                        //Add the line to the report area, just in case no stats are saved.
                                        view.update(Observer.SHOW_STATS_LOG, getStatsHeaderForExcel());//jTextArea2.append(getStatsHeaderForExcel());
                                        CountNotVisited();
                                        view.update(Observer.SHOW_STATS_LOG,getStatsRowForExcel());//jTextArea2.append(getStatsRowForExcel());
                                    }

                                    if(save_lifetime_log){
                                        addStatToLifetimeLog(""+clock);
                                        addLineToLifetimeLog(the_name2);
                                        SaveReportLifetime();
                                    }

                                    if(save_results_log){
                                        addLineToResultsLog(the_name2);
                                        SaveReportResults();
                                    }

                                }

                                //Saving the log of events of a simulation. This is only for individual topologies.
                                if(save_events_log){
                                    try{
                                        mywrite_log_ev.flush();
                                        mywrite_log_ev.close();
                                        fout_log_ev.close();
                                    }catch(Exception ex){ex.printStackTrace();}
                                }

                                if(batch_simulation){

                                    if(save_stats){
                                        try{
                                            CountNotVisited();
                                            addStatToReport(the_name,"final");
                                        }catch(Exception ex){ex.printStackTrace();}
                                    }else{
                                        //Add the line to the report area, just in case no stats are saved.
                                        CountNotVisited();
                                        view.update(Observer.SHOW_STATS_LOG,getStatsRowForExcel());//jTextArea2.append(getStatsRowForExcel());
                                    }


                                    if(indiv_reports && save_stats){
                                        SaveReport();
                                    }else{
                                        if(!save_stats){
                                            CountNotVisited();
                                            view.update(Observer.SET_STATS, ""); //PROBAR QUITANDO ESTA LNEA
                                            view.update(Observer.SHOW_STATS_LOG, statsPaneText);//jTextArea2.append(statsPaneText);
                                        }
                                    }

                                    if(save_lifetime_log){
                                        addStatToLifetimeLog(""+clock);
                                        addLineToLifetimeLog(the_name);
                                    }


                                    if(save_results_log){
                                        addLineToResultsLog(the_name2);
                                    }


                                    current_instance_topology_from_batch++;
                                    if(current_instance_topology_from_batch == multiplicity*total_alpha){
                                        current_topology_from_batch++;
                                        current_instance_topology_from_batch=0;
                                    }
                                    view.update(Observer.SIMULATION_PROGRESS_BAR, current_topology_from_batch*multiplicity*total_alpha + current_instance_topology_from_batch);
                                    
                                    view.update(Observer.SIMULATION_PROGRESS, "Progress: "+current_instance_topology_from_batch+" instance of file "+current_topology_from_batch+" of "+num_files_topology_from_batch+" files total.");
                                    
                                    if(current_topology_from_batch==num_files_topology_from_batch){
                                        current_topology_from_batch=0;
                                        current_instance_topology_from_batch=0;
                                        if(sumarized_reports && save_stats)
                                            SaveReport();
                                        if(save_lifetime_log)
                                            SaveReportLifetime();

                                        view.update(Observer.PRINT_MSG, "All "+num_files_topology_from_batch+" simulation are finished!");//printmessage("All "+num_files_topology_from_batch+" simulation are finished!");
                                    }

                                }



                        }
                        c++;
                    }
                }
            }
            view.update(Observer.SHOW_MSG, "Agent stoped!"+c);
            view.update(Observer.SHOW_EVENT_COUNT, "Events: "+num_events+" Clock: "+clock);
            //batch_simulation = false;
        }

    }

}