/*
 * atarraya_frame.java
 *
 * Created on July 18, 2006, 4:21 PM
 *
 * This file is part of Atarraya.

Atarraya is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Atarraya is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Atarraya.  If not, see <http://www.gnu.org/licenses/>.

 Copyright 2009 Pedro M. Wightman
 *
 */

package atarraya;

import atarraya.element.*;
import atarraya.event.*;
import facade.*;
//import com.sun.image.codec.jpeg.ImageFormatException;
//import com.sun.image.codec.jpeg.JPEGCodec;
//import com.sun.image.codec.jpeg.JPEGImageEncoder;
import java.util.Vector;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import java.io.*;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.util.concurrent.Semaphore;
import javax.imageio.ImageIO;
import  javax.swing.DefaultListModel;
import  javax.swing.JOptionPane;
import java.text.DecimalFormat;


/**
 *
 * @author  pedrow
 */
public class atarraya_frame extends javax.swing.JFrame implements constants, Observer{
    

    Facade facade;
    
 
    DefaultListModel node_creation_list;
    DefaultListModel sink_creation_list;

    /************************************************
     *  Interface and visualization Variables
     ************************************************/
    
    // Class in charge of displaying the topology.
    newpanel myPanel;
    
    boolean show_events;        // signal of showing the event log on the interface
    //int treeID;                          // Temporary variable
    int treeIDViz;                      // id of the tree being displayed, on the manual selection mode (no active_tree mode).
    boolean view_active_tree;   // signal the active tree view mode.
    int gridmode;                      // Index of the grid mode selected
    boolean no_paint;              // Signal of no painting a topology on the panel, to avoid errors
    

    //public FileNameExtensionFilter filter_ata, filter_png, filter_jpg;
    
    DecimalFormat clock_format;
 
                  

    int ideal_p;                                      // Number of cells on a grid that covers the deployment area. One ideal metric
    String grid_mode_text;                    // Shows which graphical grid was used
    
    
            
    /**
     * Creates new form atarraya_frame
     */
    public atarraya_frame(){
        try{
            facade = new Facade(this);
        }catch(Exception e){System.out.println("The View must implement the Observer interface");}
        int i=0;
        
        gridmode = 0;
        
        node_creation_list = new DefaultListModel();
        sink_creation_list = new DefaultListModel();
        
        treeIDViz = -1;
        view_active_tree = false;
        
        
         /*
         * Parameters for the Visualization Panel
         */
        
        //myPanel = new mainPanel(this, w, h, diameter, sense_diameter);
        myPanel = new newpanel(facade.getW(),facade.getH());
        myPanel.setBounds(0, 0, facade.getW(), facade.getH());
        myPanel.setArea(facade.getW(), facade.getH());
        myPanel.setActive_tree_viz(treeIDViz);
        
        clock_format = new DecimalFormat("0.#######");

      /*  filter_ata = new FileNameExtensionFilter("Files Atarraya","*.ata","*.ATA");
        filter_png = new FileNameExtensionFilter("PNG files","png","PNG");
        filter_jpg = new FileNameExtensionFilter("JPEG files","jpg","jpeg","JPG","JEPG");
        */
        initComponents();
        
        
       /*
        jFileChooser2.addChoosableFileFilter(filter_ata);
        jFileChooser2.addChoosableFileFilter(filter_png);
        jFileChooser2.addChoosableFileFilter(filter_jpg);
        */
        
        no_paint = false;
        
        jTextField16.setText("1");
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFileChooser2 = new javax.swing.JFileChooser();
        jFileChooser1 = new javax.swing.JFileChooser();
        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel2 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel15 = new javax.swing.JPanel();
        jTabbedPane2 = new javax.swing.JTabbedPane();
        jPanel16 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextField7 = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jTextField13 = new javax.swing.JTextField();
        jLabel34 = new javax.swing.JLabel();
        jTextField14 = new javax.swing.JTextField();
        jLabel35 = new javax.swing.JLabel();
        jLabel38 = new javax.swing.JLabel();
        jLabel42 = new javax.swing.JLabel();
        jComboBox2 = new javax.swing.JComboBox();
        jTextField15 = new javax.swing.JTextField();
        jLabel37 = new javax.swing.JLabel();
        jLabel51 = new javax.swing.JLabel();
        jComboBox6 = new javax.swing.JComboBox();
        jTextField20 = new javax.swing.JTextField();
        jLabel52 = new javax.swing.JLabel();
        jTextField21 = new javax.swing.JTextField();
        jLabel53 = new javax.swing.JLabel();
        jCheckBox22 = new javax.swing.JCheckBox();
        jTextField23 = new javax.swing.JTextField();
        jTextField24 = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jLabel55 = new javax.swing.JLabel();
        jComboBox8 = new javax.swing.JComboBox();
        jLabel56 = new javax.swing.JLabel();
        jButton12 = new javax.swing.JButton();
        jButton13 = new javax.swing.JButton();
        jLabel57 = new javax.swing.JLabel();
        jButton5 = new javax.swing.JButton();
        jPanel12 = new javax.swing.JPanel();
        jTextField16 = new javax.swing.JTextField();
        jLabel45 = new javax.swing.JLabel();
        jTextField17 = new javax.swing.JTextField();
        jLabel46 = new javax.swing.JLabel();
        jCheckBox16 = new javax.swing.JCheckBox();
        jProgressBar2 = new javax.swing.JProgressBar();
        jLabel27 = new javax.swing.JLabel();
        jCheckBox24 = new javax.swing.JCheckBox();
        jTextField25 = new javax.swing.JTextField();
        jLabel60 = new javax.swing.JLabel();
        jScrollPane7 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jScrollPane4 = new javax.swing.JScrollPane();
        jList2 = new javax.swing.JList();
        jLabel61 = new javax.swing.JLabel();
        jButton15 = new javax.swing.JButton();
        jTextField22 = new javax.swing.JTextField();
        jLabel54 = new javax.swing.JLabel();
        jTextField31 = new javax.swing.JTextField();
        jTextField32 = new javax.swing.JTextField();
        jLabel81 = new javax.swing.JLabel();
        jLabel82 = new javax.swing.JLabel();
        jCheckBox8 = new javax.swing.JCheckBox();
        jComboBox13 = new javax.swing.JComboBox();
        jLabel96 = new javax.swing.JLabel();
        jLabel103 = new javax.swing.JLabel();
        jComboBox14 = new javax.swing.JComboBox();
        jPanel20 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jPanel19 = new javax.swing.JPanel();
        jLabel26 = new javax.swing.JLabel();
        jComboBox5 = new javax.swing.JComboBox();
        jTextField28 = new javax.swing.JTextField();
        jLabel79 = new javax.swing.JLabel();
        jLabel62 = new javax.swing.JLabel();
        jTextField26 = new javax.swing.JTextField();
        jLabel64 = new javax.swing.JLabel();
        jLabel65 = new javax.swing.JLabel();
        jTextField27 = new javax.swing.JTextField();
        jTextField30 = new javax.swing.JTextField();
        jLabel69 = new javax.swing.JLabel();
        jButton14 = new javax.swing.JButton();
        jCheckBox14 = new javax.swing.JCheckBox();
        jPanel21 = new javax.swing.JPanel();
        jTextField9 = new javax.swing.JTextField();
        jLabel63 = new javax.swing.JLabel();
        jButton18 = new javax.swing.JButton();
        jPanel26 = new javax.swing.JPanel();
        jTextField38 = new javax.swing.JTextField();
        jLabel90 = new javax.swing.JLabel();
        jTextField39 = new javax.swing.JTextField();
        jLabel91 = new javax.swing.JLabel();
        jPanel27 = new javax.swing.JPanel();
        jTextField40 = new javax.swing.JTextField();
        jLabel92 = new javax.swing.JLabel();
        jTextField41 = new javax.swing.JTextField();
        jLabel93 = new javax.swing.JLabel();
        jPanel28 = new javax.swing.JPanel();
        jLabel95 = new javax.swing.JLabel();
        jTextField42 = new javax.swing.JTextField();
        jComboBox12 = new javax.swing.JComboBox();
        jPanel29 = new javax.swing.JPanel();
        jTextField43 = new javax.swing.JTextField();
        jLabel97 = new javax.swing.JLabel();
        jTextField44 = new javax.swing.JTextField();
        jLabel98 = new javax.swing.JLabel();
        jTextField45 = new javax.swing.JTextField();
        jLabel99 = new javax.swing.JLabel();
        jCheckBox29 = new javax.swing.JCheckBox();
        jPanel31 = new javax.swing.JPanel();
        jTextField47 = new javax.swing.JTextField();
        jLabel104 = new javax.swing.JLabel();
        jLabel105 = new javax.swing.JLabel();
        jTextField48 = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        jLabel36 = new javax.swing.JLabel();
        jCheckBox7 = new javax.swing.JCheckBox();
        jPanel3 = new javax.swing.JPanel();
        jPanel24 = new javax.swing.JPanel();
        jComboBox7 = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jLabel66 = new javax.swing.JLabel();
        jComboBox10 = new javax.swing.JComboBox();
        jLabel67 = new javax.swing.JLabel();
        jComboBox11 = new javax.swing.JComboBox();
        jLabel68 = new javax.swing.JLabel();
        jCheckBox13 = new javax.swing.JCheckBox();
        jLabel86 = new javax.swing.JLabel();
        jComboBox9 = new javax.swing.JComboBox();
        jComboBox3 = new javax.swing.JComboBox();
        jLabel94 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jLabel33 = new javax.swing.JLabel();
        jCheckBox20 = new javax.swing.JCheckBox();
        jButton11 = new javax.swing.JButton();
        jPanel14 = new javax.swing.JPanel();
        jButton7 = new javax.swing.JButton();
        jLabel47 = new javax.swing.JLabel();
        jTextField19 = new javax.swing.JTextField();
        jLabel49 = new javax.swing.JLabel();
        jLabel50 = new javax.swing.JLabel();
        jProgressBar1 = new javax.swing.JProgressBar();
        jButton8 = new javax.swing.JButton();
        jCheckBox6 = new javax.swing.JCheckBox();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextPane2 = new javax.swing.JTextPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTextPane3 = new javax.swing.JTextPane();
        jLabel59 = new javax.swing.JLabel();
        jCheckBox11 = new javax.swing.JCheckBox();
        jButton6 = new javax.swing.JButton();
        jPanel11 = new javax.swing.JPanel();
        jCheckBox17 = new javax.swing.JCheckBox();
        jCheckBox18 = new javax.swing.JCheckBox();
        jCheckBox19 = new javax.swing.JCheckBox();
        jLabel48 = new javax.swing.JLabel();
        jTextField18 = new javax.swing.JTextField();
        jCheckBox9 = new javax.swing.JCheckBox();
        jCheckBox12 = new javax.swing.JCheckBox();
        jCheckBox15 = new javax.swing.JCheckBox();
        jCheckBox23 = new javax.swing.JCheckBox();
        jTextField3 = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jCheckBox28 = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel43 = new javax.swing.JLabel();
        jTextField12 = new javax.swing.JTextField();
        jLabel44 = new javax.swing.JLabel();
        jPanel25 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jLabel29 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel28 = new javax.swing.JLabel();
        jLabel24 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        jLabel100 = new javax.swing.JLabel();
        jLabel101 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jCheckBox3 = new javax.swing.JCheckBox();
        jCheckBox4 = new javax.swing.JCheckBox();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        jCheckBox5 = new javax.swing.JCheckBox();
        jButton10 = new javax.swing.JButton();
        jCheckBox21 = new javax.swing.JCheckBox();
        jCheckBox10 = new javax.swing.JCheckBox();
        jLabel89 = new javax.swing.JLabel();
        jCheckBox26 = new javax.swing.JCheckBox();
        jPanel9 = new javax.swing.JPanel();
        jComboBox4 = new javax.swing.JComboBox();
        jLabel17 = new javax.swing.JLabel();
        jPanel30 = new javax.swing.JPanel();
        jLabel102 = new javax.swing.JLabel();
        jTextField46 = new javax.swing.JTextField();
        jButton25 = new javax.swing.JButton();
        jPanel10 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jButton4 = new javax.swing.JButton();
        jTextField8 = new javax.swing.JTextField();
        jLabel40 = new javax.swing.JLabel();
        jLabel41 = new javax.swing.JLabel();
        jButton9 = new javax.swing.JButton();
        jPanel23 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jLabel12 = new javax.swing.JLabel();
        jPanel22 = new javax.swing.JPanel();
        jTextField4 = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jButton21 = new javax.swing.JButton();
        jPanel13 = new javax.swing.JPanel();
        jPanel17 = new javax.swing.JPanel();
        jTextField6 = new javax.swing.JTextField();
        jLabel30 = new javax.swing.JLabel();
        jLabel32 = new javax.swing.JLabel();
        jLabel58 = new javax.swing.JLabel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jTextField10 = new javax.swing.JTextField();
        jLabel76 = new javax.swing.JLabel();
        jLabel77 = new javax.swing.JLabel();
        jTextField29 = new javax.swing.JTextField();
        jLabel78 = new javax.swing.JLabel();
        jLabel75 = new javax.swing.JLabel();
        jLabel80 = new javax.swing.JLabel();
        jButton19 = new javax.swing.JButton();
        jPanel18 = new javax.swing.JPanel();
        jLabel71 = new javax.swing.JLabel();
        jRadioButton2 = new javax.swing.JRadioButton();
        jLabel70 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jTextField33 = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        jTextField34 = new javax.swing.JTextField();
        jLabel22 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        jLabel39 = new javax.swing.JLabel();
        jLabel72 = new javax.swing.JLabel();
        jTextField35 = new javax.swing.JTextField();
        jLabel73 = new javax.swing.JLabel();
        jTextField36 = new javax.swing.JTextField();
        jLabel83 = new javax.swing.JLabel();
        jTextField37 = new javax.swing.JTextField();
        jLabel84 = new javax.swing.JLabel();
        jLabel87 = new javax.swing.JLabel();
        jLabel88 = new javax.swing.JLabel();
        jButton16 = new javax.swing.JButton();
        jLabel18 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jButton17 = new javax.swing.JButton();
        jButton20 = new javax.swing.JButton();
        jLabel31 = new javax.swing.JLabel();
        jLabel85 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jCheckBox25 = new javax.swing.JCheckBox();
        jTextField11 = new javax.swing.JTextField();
        jLabel74 = new javax.swing.JLabel();
        jButton22 = new javax.swing.JButton();
        jButton23 = new javax.swing.JButton();
        jButton24 = new javax.swing.JButton();
        jCheckBox27 = new javax.swing.JCheckBox();
        jMenuBar2 = new javax.swing.JMenuBar();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem3 = new javax.swing.JMenuItem();

        jFileChooser2.setFileSelectionMode(javax.swing.JFileChooser.FILES_AND_DIRECTORIES);

        jFileChooser1.setFileFilter(facade.filter);
        jFileChooser1.setFileSelectionMode(javax.swing.JFileChooser.FILES_AND_DIRECTORIES);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Atarraya - A Topology Control Simulator");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));

        jPanel1.setMinimumSize(new java.awt.Dimension(500, 500));
        jPanel1.setPreferredSize(new java.awt.Dimension(500, 500));
        jPanel1.setLayout(new java.awt.BorderLayout());

        jSplitPane1.setDividerLocation(610);
        jSplitPane1.setOneTouchExpandable(true);

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.add(myPanel);
        jPanel2.setBounds(0,0,facade.getW(),facade.getH());
        jPanel2.setLayout(new java.awt.BorderLayout());
        jSplitPane1.setLeftComponent(jPanel2);

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Deployment", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel7.setEnabled(false);
        jPanel7.setLayout(null);

        jLabel3.setText("# Nodes");
        jPanel7.add(jLabel3);
        jLabel3.setBounds(10, 20, 41, 14);

        jTextField1.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField1.setText("100");
        jPanel7.add(jTextField1);
        jTextField1.setBounds(10, 40, 50, 20);

        jTextField2.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField2.setText("100");
        jPanel7.add(jTextField2);
        jTextField2.setBounds(80, 40, 50, 20);

        jLabel4.setText("Comm Radius");
        jPanel7.add(jLabel4);
        jLabel4.setBounds(80, 20, 64, 14);

        jTextField7.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField7.setText("20");
        jPanel7.add(jTextField7);
        jTextField7.setBounds(160, 40, 50, 20);

        jLabel15.setText("Sensing Radius");
        jPanel7.add(jLabel15);
        jLabel15.setBounds(160, 20, 72, 14);

        jTextField13.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField13.setText("600");
        jPanel7.add(jTextField13);
        jTextField13.setBounds(10, 90, 40, 20);

        jLabel34.setText("Width");
        jPanel7.add(jLabel34);
        jLabel34.setBounds(60, 90, 28, 20);

        jTextField14.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField14.setText("600");
        jPanel7.add(jTextField14);
        jTextField14.setBounds(100, 90, 40, 20);

        jLabel35.setText("Height");
        jPanel7.add(jLabel35);
        jLabel35.setBounds(150, 90, 31, 14);

        jLabel38.setForeground(new java.awt.Color(0, 51, 255));
        jLabel38.setText("Deployment Visibility Area");
        jPanel7.add(jLabel38);
        jLabel38.setBounds(10, 70, 160, 14);

        jLabel42.setForeground(new java.awt.Color(51, 51, 255));
        jLabel42.setText("Node Location Distribution");
        jPanel7.add(jLabel42);
        jLabel42.setBounds(10, 130, 170, 14);

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Uniform", "Normal", "Constant", "Center", "Grid H-V", "Grid H-V-D", "Opt. Strip", "Opt. Comb", "Opt. Square", "Opt. Triangle", "Grid Delta", "Grid Poisson" }));
        jComboBox2.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox2ItemStateChanged(evt);
            }
        });
        jPanel7.add(jComboBox2);
        jComboBox2.setBounds(10, 150, 110, 20);

        jTextField15.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField15.setText("5");
        jTextField15.setEnabled(false);
        jPanel7.add(jTextField15);
        jTextField15.setBounds(150, 180, 40, 20);

        jLabel37.setText("Sigma");
        jLabel37.setEnabled(false);
        jPanel7.add(jLabel37);
        jLabel37.setBounds(200, 180, 28, 14);

        jLabel51.setForeground(new java.awt.Color(0, 0, 255));
        jLabel51.setText("Node Energy Distribution (mJoules)");
        jPanel7.add(jLabel51);
        jLabel51.setBounds(10, 210, 170, 14);

        jComboBox6.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Constant", "Gaussian", "Poisson", "Uniform" }));
        jComboBox6.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox6ItemStateChanged(evt);
            }
        });
        jPanel7.add(jComboBox6);
        jComboBox6.setBounds(10, 230, 110, 20);

        jTextField20.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField20.setText("1000");
        jPanel7.add(jTextField20);
        jTextField20.setBounds(130, 250, 40, 20);

        jLabel52.setText("Mean");
        jPanel7.add(jLabel52);
        jLabel52.setBounds(175, 255, 26, 14);

        jTextField21.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField21.setText("5");
        jTextField21.setEnabled(false);
        jPanel7.add(jTextField21);
        jTextField21.setBounds(210, 250, 30, 20);

        jLabel53.setText("Sigma");
        jLabel53.setEnabled(false);
        jPanel7.add(jLabel53);
        jLabel53.setBounds(245, 255, 28, 14);

        jCheckBox22.setText("Sink?");
        jCheckBox22.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox22ItemStateChanged(evt);
            }
        });
        jCheckBox22.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox22ActionPerformed(evt);
            }
        });
        jPanel7.add(jCheckBox22);
        jCheckBox22.setBounds(250, 40, 49, 23);

        jTextField23.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField23.setText("300");
        jPanel7.add(jTextField23);
        jTextField23.setBounds(10, 180, 40, 20);

        jTextField24.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField24.setText("300");
        jPanel7.add(jTextField24);
        jTextField24.setBounds(80, 180, 40, 20);

        jLabel10.setText("Y");
        jPanel7.add(jLabel10);
        jLabel10.setBounds(130, 180, 10, 14);

        jLabel55.setText("X");
        jPanel7.add(jLabel55);
        jLabel55.setBounds(60, 180, 10, 14);

        jComboBox8.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Black", "Red", "Blue", "Green", "Orange", "Pink", "Yellow" }));
        jComboBox8.setEnabled(false);
        jPanel7.add(jComboBox8);
        jComboBox8.setBounds(300, 40, 70, 20);

        jLabel56.setText("<html>Infrastructure <br> Association</html>");
        jLabel56.setEnabled(false);
        jPanel7.add(jLabel56);
        jLabel56.setBounds(300, 10, 80, 30);

        jButton12.setText("Add");
        jButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton12ActionPerformed(evt);
            }
        });
        jPanel7.add(jButton12);
        jButton12.setBounds(10, 440, 60, 23);

        jButton13.setText("Remove");
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton13ActionPerformed(evt);
            }
        });
        jPanel7.add(jButton13);
        jButton13.setBounds(75, 440, 71, 23);

        jLabel57.setForeground(new java.awt.Color(51, 51, 255));
        jLabel57.setText("Node Creation List");
        jPanel7.add(jLabel57);
        jLabel57.setBounds(10, 260, 90, 14);

        jButton5.setText("Manual Pos.");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jPanel7.add(jButton5);
        jButton5.setBounds(260, 177, 91, 23);

        jPanel12.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Batch Creation", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel12.setLayout(null);

        jTextField16.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField16.setText("1");
        jTextField16.setEnabled(false);
        jPanel12.add(jTextField16);
        jTextField16.setBounds(10, 50, 30, 20);

        jLabel45.setText("# of Topologies");
        jLabel45.setEnabled(false);
        jPanel12.add(jLabel45);
        jLabel45.setBounds(60, 50, 75, 14);

        jTextField17.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField17.setText("0");
        jTextField17.setEnabled(false);
        jPanel12.add(jTextField17);
        jTextField17.setBounds(10, 80, 30, 20);

        jLabel46.setText("Index start in:");
        jLabel46.setEnabled(false);
        jPanel12.add(jLabel46);
        jLabel46.setBounds(70, 80, 69, 14);

        jCheckBox16.setText("Batch Creation");
        jCheckBox16.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox16.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox16.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox16ItemStateChanged(evt);
            }
        });
        jPanel12.add(jCheckBox16);
        jCheckBox16.setBounds(10, 20, 89, 15);
        jPanel12.add(jProgressBar2);
        jProgressBar2.setBounds(10, 130, 130, 19);

        jLabel27.setText("Progress:");
        jPanel12.add(jLabel27);
        jLabel27.setBounds(10, 110, 130, 14);

        jCheckBox24.setSelected(true);
        jCheckBox24.setText("Check Max. Trials");
        jCheckBox24.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox24ActionPerformed(evt);
            }
        });
        jPanel12.add(jCheckBox24);
        jCheckBox24.setBounds(10, 150, 120, 23);

        jPanel7.add(jPanel12);
        jPanel12.setBounds(220, 280, 150, 180);

        jTextField25.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField25.setText("1000");
        jTextField25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField25ActionPerformed(evt);
            }
        });
        jPanel7.add(jTextField25);
        jTextField25.setBounds(130, 230, 40, 20);

        jLabel60.setText("Max");
        jPanel7.add(jLabel60);
        jLabel60.setBounds(175, 235, 20, 14);

        jScrollPane7.setViewportView(jList1);

        jPanel7.add(jScrollPane7);
        jScrollPane7.setBounds(10, 280, 200, 60);

        jScrollPane4.setViewportView(jList2);

        jPanel7.add(jScrollPane4);
        jScrollPane4.setBounds(10, 370, 200, 60);

        jLabel61.setForeground(new java.awt.Color(0, 51, 255));
        jLabel61.setText("Sink Creation List");
        jPanel7.add(jLabel61);
        jLabel61.setBounds(10, 350, 100, 14);

        jButton15.setText("Clear");
        jButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton15ActionPerformed(evt);
            }
        });
        jPanel7.add(jButton15);
        jButton15.setBounds(150, 440, 60, 23);

        jTextField22.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField22.setText("0");
        jPanel7.add(jTextField22);
        jTextField22.setBounds(280, 250, 30, 20);

        jLabel54.setText("Bit Error Rate");
        jPanel7.add(jLabel54);
        jLabel54.setBounds(315, 255, 65, 14);

        jTextField31.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField31.setText("600");
        jPanel7.add(jTextField31);
        jTextField31.setBounds(130, 150, 40, 20);

        jTextField32.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField32.setText("600");
        jPanel7.add(jTextField32);
        jTextField32.setBounds(220, 150, 40, 20);

        jLabel81.setText("Width");
        jPanel7.add(jLabel81);
        jLabel81.setBounds(180, 150, 28, 14);

        jLabel82.setText("Height");
        jPanel7.add(jLabel82);
        jLabel82.setBounds(270, 150, 31, 14);

        jCheckBox8.setText("Move?");
        jPanel7.add(jCheckBox8);
        jCheckBox8.setBounds(310, 145, 57, 23);

        jComboBox13.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Simple", "Mote", "ACOS", "WaspMote", "Mica2" }));
        jComboBox13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox13ActionPerformed(evt);
            }
        });
        jPanel7.add(jComboBox13);
        jComboBox13.setBounds(280, 205, 100, 20);

        jLabel96.setText("<html>Energy Model</html>");
        jPanel7.add(jLabel96);
        jLabel96.setBounds(210, 200, 80, 30);

        jLabel103.setText("Comm Model");
        jPanel7.add(jLabel103);
        jLabel103.setBounds(210, 230, 70, 14);

        jComboBox14.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Simple", "WaspMote", "MICA2" }));
        jComboBox14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox14ActionPerformed(evt);
            }
        });
        jPanel7.add(jComboBox14);
        jComboBox14.setBounds(280, 230, 100, 20);

        org.jdesktop.layout.GroupLayout jPanel16Layout = new org.jdesktop.layout.GroupLayout(jPanel16);
        jPanel16.setLayout(jPanel16Layout);
        jPanel16Layout.setHorizontalGroup(
            jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel16Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 391, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(25, Short.MAX_VALUE))
        );
        jPanel16Layout.setVerticalGroup(
            jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel16Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 473, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane2.addTab("Deployment", jPanel16);

        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Other Parameters", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel8.setEnabled(false);
        jPanel8.setLayout(null);

        jPanel19.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Metric Definition", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N

        jLabel26.setText("Sorting mode");

        jComboBox5.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Metric1 only", "Metric2 only", "Metric1 Primary", "Metric2 Primary", "Linear Combination (W1*Metric1+W2*Metric1)/(W1+W2)" }));
        jComboBox5.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox5ItemStateChanged(evt);
            }
        });

        jTextField28.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField28.setText("0.25");

        jLabel79.setText("Candidate Grouping Step");

        jLabel62.setForeground(new java.awt.Color(0, 0, 255));
        jLabel62.setText("Weights");

        jTextField26.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField26.setText("0.5");

        jLabel64.setText("W1");

        jLabel65.setText("W2");

        jTextField27.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField27.setText("0.5");

        jTextField30.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField30.setText("0.20");

        jLabel69.setText("Step");

        jButton14.setText("Set Weights Now");
        jButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton14ActionPerformed(evt);
            }
        });

        jCheckBox14.setText("Create all steps");

        org.jdesktop.layout.GroupLayout jPanel19Layout = new org.jdesktop.layout.GroupLayout(jPanel19);
        jPanel19.setLayout(jPanel19Layout);
        jPanel19Layout.setHorizontalGroup(
            jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel19Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel26)
                    .add(jComboBox5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 230, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel19Layout.createSequentialGroup()
                        .add(jTextField28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(jLabel79))
                    .add(jLabel62)
                    .add(jPanel19Layout.createSequentialGroup()
                        .add(jTextField26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(jLabel64))
                    .add(jPanel19Layout.createSequentialGroup()
                        .add(jTextField27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(jLabel65)
                        .add(18, 18, 18)
                        .add(jCheckBox14))
                    .add(jPanel19Layout.createSequentialGroup()
                        .add(jTextField30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(10, 10, 10)
                        .add(jLabel69)
                        .add(8, 8, 8)
                        .add(jButton14)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel19Layout.setVerticalGroup(
            jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel19Layout.createSequentialGroup()
                .add(jLabel26)
                .add(6, 6, 6)
                .add(jComboBox5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(10, 10, 10)
                .add(jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextField28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel79))
                .add(10, 10, 10)
                .add(jLabel62)
                .add(6, 6, 6)
                .add(jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextField26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel64))
                .add(10, 10, 10)
                .add(jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextField27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel65)
                        .add(jCheckBox14)))
                .add(10, 10, 10)
                .add(jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextField30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel69)
                    .add(jButton14))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel8.add(jPanel19);
        jPanel19.setBounds(10, 30, 260, 220);

        jPanel21.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "S-D protocol Interquery time", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N

        jTextField9.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField9.setText("10");

        jLabel63.setText("Interquery time");

        jButton18.setText("Set InterQ Time Now");
        jButton18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton18ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel21Layout = new org.jdesktop.layout.GroupLayout(jPanel21);
        jPanel21.setLayout(jPanel21Layout);
        jPanel21Layout.setHorizontalGroup(
            jPanel21Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel21Layout.createSequentialGroup()
                .addContainerGap()
                .add(jTextField9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(10, 10, 10)
                .add(jLabel63)
                .add(5, 5, 5)
                .add(jButton18)
                .addContainerGap(11, Short.MAX_VALUE))
        );
        jPanel21Layout.setVerticalGroup(
            jPanel21Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel21Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel21Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextField9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel63)
                    .add(jButton18))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel8.add(jPanel21);
        jPanel21.setBounds(10, 250, 290, 70);

        jPanel26.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "TM Protocols Variables", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N

        jTextField38.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField38.setText("1000");

        jLabel90.setText("Inter-Reset Period");

        jTextField39.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField39.setText("0.9");

        jLabel91.setText("Energy Threshold Step");

        org.jdesktop.layout.GroupLayout jPanel26Layout = new org.jdesktop.layout.GroupLayout(jPanel26);
        jPanel26.setLayout(jPanel26Layout);
        jPanel26Layout.setHorizontalGroup(
            jPanel26Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel26Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel26Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField39, 0, 0, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField38, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 50, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel26Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jLabel91, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jLabel90, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel26Layout.setVerticalGroup(
            jPanel26Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel26Layout.createSequentialGroup()
                .add(jPanel26Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jTextField38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel90))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel26Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jTextField39, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel91))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel8.add(jPanel26);
        jPanel26.setBounds(10, 320, 200, 80);

        jPanel27.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Node Mobility parameters", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N

        jTextField40.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField40.setText("20");

        jLabel92.setText("Step size");

        jTextField41.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField41.setText("10");

        jLabel93.setText("Sleep time");

        org.jdesktop.layout.GroupLayout jPanel27Layout = new org.jdesktop.layout.GroupLayout(jPanel27);
        jPanel27.setLayout(jPanel27Layout);
        jPanel27Layout.setHorizontalGroup(
            jPanel27Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel27Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel27Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField41, 0, 0, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField40, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 49, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel27Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel92)
                    .add(jLabel93))
                .addContainerGap(66, Short.MAX_VALUE))
        );
        jPanel27Layout.setVerticalGroup(
            jPanel27Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel27Layout.createSequentialGroup()
                .add(jPanel27Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jTextField40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel92))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 10, Short.MAX_VALUE)
                .add(jPanel27Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jTextField41, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel93)))
        );

        jPanel8.add(jPanel27);
        jPanel27.setBounds(10, 400, 200, 80);

        jPanel28.setBorder(javax.swing.BorderFactory.createTitledBorder("KNeighTree"));

        jLabel95.setText("K variable");

        jTextField42.setText("6");

        jComboBox12.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Just low level", "Low level + k", "Just k" }));
        jComboBox12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox12ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel28Layout = new org.jdesktop.layout.GroupLayout(jPanel28);
        jPanel28.setLayout(jPanel28Layout);
        jPanel28Layout.setHorizontalGroup(
            jPanel28Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel28Layout.createSequentialGroup()
                .add(jTextField42, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 42, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jLabel95)
                .addContainerGap(55, Short.MAX_VALUE))
            .add(jComboBox12, 0, 154, Short.MAX_VALUE)
        );
        jPanel28Layout.setVerticalGroup(
            jPanel28Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel28Layout.createSequentialGroup()
                .add(jPanel28Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jTextField42, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel95))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jComboBox12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel8.add(jPanel28);
        jPanel28.setBounds(210, 400, 170, 80);

        jPanel29.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Alpha Coverage", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N

        jTextField43.setText("1.0");

        jLabel97.setText("Ini");

        jTextField44.setText("1.0");

        jLabel98.setText("Fin");

        jTextField45.setText("0.1");

        jLabel99.setText("Step");

        jCheckBox29.setText("All alphas?");

        org.jdesktop.layout.GroupLayout jPanel29Layout = new org.jdesktop.layout.GroupLayout(jPanel29);
        jPanel29.setLayout(jPanel29Layout);
        jPanel29Layout.setHorizontalGroup(
            jPanel29Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel29Layout.createSequentialGroup()
                .add(jPanel29Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField44, 0, 0, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField43, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 35, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel29Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel98)
                    .add(jLabel97))
                .add(10, 10, 10)
                .add(jPanel29Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jCheckBox29)
                    .add(jPanel29Layout.createSequentialGroup()
                        .add(jTextField45, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 32, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel99)))
                .addContainerGap())
        );
        jPanel29Layout.setVerticalGroup(
            jPanel29Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel29Layout.createSequentialGroup()
                .add(jPanel29Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jTextField43, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel97)
                    .add(jCheckBox29))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 6, Short.MAX_VALUE)
                .add(jPanel29Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jTextField44, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel98)
                    .add(jTextField45, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel99))
                .addContainerGap())
        );

        jPanel8.add(jPanel29);
        jPanel29.setBounds(220, 320, 160, 80);

        jPanel31.setBorder(javax.swing.BorderFactory.createTitledBorder("Other"));

        jTextField47.setText("100");

        jLabel104.setText("Preferred Radius");

        jLabel105.setText("Max. Tx Trials");

        jTextField48.setText("5");

        org.jdesktop.layout.GroupLayout jPanel31Layout = new org.jdesktop.layout.GroupLayout(jPanel31);
        jPanel31.setLayout(jPanel31Layout);
        jPanel31Layout.setHorizontalGroup(
            jPanel31Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel31Layout.createSequentialGroup()
                .add(jPanel31Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel104, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTextField47, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel105, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 80, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTextField48, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel31Layout.setVerticalGroup(
            jPanel31Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel31Layout.createSequentialGroup()
                .add(jLabel104)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextField47, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel105)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextField48, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(104, Short.MAX_VALUE))
        );

        jPanel8.add(jPanel31);
        jPanel31.setBounds(280, 30, 116, 220);

        org.jdesktop.layout.GroupLayout jPanel20Layout = new org.jdesktop.layout.GroupLayout(jPanel20);
        jPanel20.setLayout(jPanel20Layout);
        jPanel20Layout.setHorizontalGroup(
            jPanel20Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel20Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 391, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(25, Short.MAX_VALUE))
        );
        jPanel20Layout.setVerticalGroup(
            jPanel20Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel20Layout.createSequentialGroup()
                .add(jPanel8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 484, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane2.addTab("Other Params.", jPanel20);

        jButton3.setText("Create Deployment");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jLabel36.setForeground(new java.awt.Color(255, 0, 0));
        jLabel36.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jCheckBox7.setSelected(true);
        jCheckBox7.setText("Check Connectivity Exhaustively");
        jCheckBox7.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox7.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox7.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jCheckBox7StateChanged(evt);
            }
        });
        jCheckBox7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox7ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel15Layout = new org.jdesktop.layout.GroupLayout(jPanel15);
        jPanel15.setLayout(jPanel15Layout);
        jPanel15Layout.setHorizontalGroup(
            jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel15Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel15Layout.createSequentialGroup()
                        .add(jButton3)
                        .add(jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel15Layout.createSequentialGroup()
                                .add(190, 190, 190)
                                .add(jLabel36, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 290, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(jPanel15Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jCheckBox7))))
                    .add(jTabbedPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 431, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel15Layout.setVerticalGroup(
            jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel15Layout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jTabbedPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 523, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(7, 7, 7)
                .add(jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 35, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jCheckBox7))
                .add(502, 502, 502)
                .add(jLabel36, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(117, 117, 117))
        );

        jTabbedPane1.addTab("Deployment Options", jPanel15);

        jPanel3.setPreferredSize(new java.awt.Dimension(350, 350));
        jPanel3.setLayout(null);

        jPanel24.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Select Protocol", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel24.setLayout(null);

        jComboBox7.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "No TC Protocol", "A3", "A3 Coverage", "EECDS", "CDS Rule K", "SimpleTree", "Just Tree", "KNEIGH-Tree" }));
        jComboBox7.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox7ItemStateChanged(evt);
            }
        });
        jPanel24.add(jComboBox7);
        jComboBox7.setBounds(10, 40, 210, 20);
        jPanel24.add(jLabel2);
        jLabel2.setBounds(0, 0, 0, 0);

        jLabel66.setForeground(new java.awt.Color(0, 0, 255));
        jLabel66.setText("TC protocol");
        jPanel24.add(jLabel66);
        jLabel66.setBounds(30, 20, 70, 14);

        jComboBox10.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "No TM protocol", "Non Isolated Sink", "DGTTRec", "SGTTRot", "HGTTRecRot", "Energy Local Patching DSR", "DGETRec", "SGETRot", "HGETRecRot" }));
        jComboBox10.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox10ItemStateChanged(evt);
            }
        });
        jPanel24.add(jComboBox10);
        jComboBox10.setBounds(10, 80, 210, 20);

        jLabel67.setForeground(new java.awt.Color(0, 0, 255));
        jLabel67.setText("TM Protocol");
        jPanel24.add(jLabel67);
        jLabel67.setBounds(30, 65, 70, 14);

        jComboBox11.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "No S&D protocol", "Simple S&D protocol" }));
        jComboBox11.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox11ItemStateChanged(evt);
            }
        });
        jPanel24.add(jComboBox11);
        jComboBox11.setBounds(230, 40, 210, 20);

        jLabel68.setForeground(new java.awt.Color(0, 0, 255));
        jLabel68.setText("Sensor & Data protocol");
        jPanel24.add(jLabel68);
        jLabel68.setBounds(230, 20, 150, 14);

        jCheckBox13.setText("<html>All sinks at once? <br>(if multiple infrastructure selected)");
        jCheckBox13.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox13.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox13.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox13ItemStateChanged(evt);
            }
        });
        jPanel24.add(jCheckBox13);
        jCheckBox13.setBounds(10, 110, 190, 29);

        jLabel86.setForeground(new java.awt.Color(0, 0, 255));
        jLabel86.setText("Routing / Forwarding Protocol");
        jPanel24.add(jLabel86);
        jLabel86.setBounds(230, 60, 200, 14);

        jComboBox9.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "No Routing/Forwarding Protocol", "Simple Forwarding" }));
        jComboBox9.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox9ItemStateChanged(evt);
            }
        });
        jPanel24.add(jComboBox9);
        jComboBox9.setBounds(230, 80, 210, 20);

        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "No Mobility", "Simple Random Walk Mobility" }));
        jComboBox3.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox3ItemStateChanged(evt);
            }
        });
        jPanel24.add(jComboBox3);
        jComboBox3.setBounds(230, 120, 210, 20);

        jLabel94.setForeground(new java.awt.Color(0, 0, 255));
        jLabel94.setText("Node Mobility");
        jPanel24.add(jLabel94);
        jLabel94.setBounds(230, 100, 120, 14);

        jPanel3.add(jPanel24);
        jPanel24.setBounds(0, 0, 450, 150);

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Actions / Events", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel5.setPreferredSize(new java.awt.Dimension(400, 160));
        jPanel5.setLayout(null);

        jButton1.setFont(new java.awt.Font("Tahoma", 1, 12));
        jButton1.setText("<html> Start Atarraya!");
        jButton1.setToolTipText("Start Simulation");
        jButton1.setActionCommand("Start Atarraya!");
        jButton1.setEnabled(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel5.add(jButton1);
        jButton1.setBounds(10, 20, 130, 70);

        jButton2.setText("Pause");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel5.add(jButton2);
        jButton2.setBounds(145, 60, 70, 30);

        jLabel33.setForeground(new java.awt.Color(0, 0, 255));
        jLabel33.setText("Events: ");
        jPanel5.add(jLabel33);
        jLabel33.setBounds(10, 120, 220, 14);

        jCheckBox20.setText("Show Events");
        jCheckBox20.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox20.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox20.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox20ItemStateChanged(evt);
            }
        });
        jPanel5.add(jCheckBox20);
        jCheckBox20.setBounds(150, 420, 79, 15);

        jButton11.setText("Clear events");
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });
        jPanel5.add(jButton11);
        jButton11.setBounds(10, 420, 93, 20);

        jPanel14.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Batch Simulation", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel14.setLayout(null);

        jButton7.setText("Select Files");
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jPanel14.add(jButton7);
        jButton7.setBounds(10, 20, 90, 30);

        jLabel47.setText("0 files selected");
        jPanel14.add(jLabel47);
        jLabel47.setBounds(10, 60, 80, 14);

        jTextField19.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField19.setText("1");
        jTextField19.setToolTipText("Multiplicity");
        jPanel14.add(jTextField19);
        jTextField19.setBounds(120, 60, 20, 20);

        jLabel49.setText("X           Replicates");
        jPanel14.add(jLabel49);
        jLabel49.setBounds(110, 60, 90, 20);

        jLabel50.setText("Progress");
        jPanel14.add(jLabel50);
        jLabel50.setBounds(10, 80, 200, 14);
        jPanel14.add(jProgressBar1);
        jProgressBar1.setBounds(10, 100, 190, 19);

        jButton8.setText("Clear Files");
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });
        jPanel14.add(jButton8);
        jButton8.setBounds(110, 20, 90, 30);

        jPanel5.add(jPanel14);
        jPanel14.setBounds(220, 10, 220, 130);

        jCheckBox6.setText("Live stats");
        jCheckBox6.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox6.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox6.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox6ItemStateChanged(evt);
            }
        });
        jPanel5.add(jCheckBox6);
        jCheckBox6.setBounds(50, 160, 70, 15);

        jScrollPane5.setViewportView(jTextPane2);

        jPanel5.add(jScrollPane5);
        jScrollPane5.setBounds(10, 180, 220, 230);

        jTextArea1.setColumns(20);
        jTextArea1.setRows(2);
        jScrollPane1.setViewportView(jTextArea1);

        jPanel5.add(jScrollPane1);
        jScrollPane1.setBounds(240, 390, 200, 50);

        jScrollPane6.setViewportView(jTextPane3);

        jPanel5.add(jScrollPane6);
        jScrollPane6.setBounds(240, 350, 200, 30);

        jLabel59.setForeground(new java.awt.Color(0, 0, 255));
        jLabel59.setText("Stats");
        jPanel5.add(jLabel59);
        jLabel59.setBounds(10, 160, 25, 14);

        jCheckBox11.setText("Covered Area too?");
        jCheckBox11.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox11.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox11.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox11ItemStateChanged(evt);
            }
        });
        jPanel5.add(jCheckBox11);
        jCheckBox11.setBounds(120, 160, 109, 15);

        jButton6.setText("Stop");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jPanel5.add(jButton6);
        jButton6.setBounds(145, 20, 70, 30);

        jPanel11.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Stats Repot", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel11.setLayout(null);

        jCheckBox17.setText("Individual Report");
        jCheckBox17.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox17.setEnabled(false);
        jCheckBox17.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox17.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox17ItemStateChanged(evt);
            }
        });
        jPanel11.add(jCheckBox17);
        jCheckBox17.setBounds(20, 60, 99, 15);

        jCheckBox18.setSelected(true);
        jCheckBox18.setText("Summarized Report");
        jCheckBox18.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox18.setEnabled(false);
        jCheckBox18.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox18.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox18ItemStateChanged(evt);
            }
        });
        jPanel11.add(jCheckBox18);
        jCheckBox18.setBounds(20, 80, 111, 15);

        jCheckBox19.setSelected(true);
        jCheckBox19.setText("Excel ready format (CSV)");
        jCheckBox19.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox19.setEnabled(false);
        jCheckBox19.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox19.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox19ItemStateChanged(evt);
            }
        });
        jPanel11.add(jCheckBox19);
        jCheckBox19.setBounds(20, 40, 139, 15);

        jLabel48.setText("Description");
        jPanel11.add(jLabel48);
        jLabel48.setBounds(140, 160, 53, 14);
        jPanel11.add(jTextField18);
        jTextField18.setBounds(10, 160, 120, 20);

        jCheckBox9.setText("Save Lifetime log (Summ. Only)");
        jCheckBox9.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox9.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox9.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox9ItemStateChanged(evt);
            }
        });
        jPanel11.add(jCheckBox9);
        jCheckBox9.setBounds(10, 120, 167, 15);

        jCheckBox12.setText("Save events log (indiv only)");
        jCheckBox12.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox12.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox12.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox12ItemStateChanged(evt);
            }
        });
        jPanel11.add(jCheckBox12);
        jCheckBox12.setBounds(10, 100, 160, 15);

        jCheckBox15.setText("Save Stats");
        jCheckBox15.setAlignmentY(0.0F);
        jCheckBox15.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox15.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox15ItemStateChanged(evt);
            }
        });
        jPanel11.add(jCheckBox15);
        jCheckBox15.setBounds(10, 20, 73, 19);

        jCheckBox23.setText("All?");
        jCheckBox23.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox23.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox23ItemStateChanged(evt);
            }
        });
        jPanel11.add(jCheckBox23);
        jCheckBox23.setBounds(90, 20, 40, 19);

        jTextField3.setText("20");
        jTextField3.setEnabled(false);
        jPanel11.add(jTextField3);
        jTextField3.setBounds(160, 20, 40, 20);

        jLabel11.setText("Step");
        jPanel11.add(jLabel11);
        jLabel11.setBounds(130, 22, 22, 14);

        jCheckBox28.setText("Save Solutions");
        jCheckBox28.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox28ItemStateChanged(evt);
            }
        });
        jPanel11.add(jCheckBox28);
        jCheckBox28.setBounds(6, 135, 130, 23);

        jPanel5.add(jPanel11);
        jPanel11.setBounds(230, 140, 210, 190);

        jLabel1.setForeground(new java.awt.Color(0, 0, 255));
        jLabel1.setText("Simulator Messages");
        jPanel5.add(jLabel1);
        jLabel1.setBounds(240, 330, 100, 14);

        jLabel43.setText("Queue Size: 0");
        jPanel5.add(jLabel43);
        jLabel43.setBounds(10, 140, 150, 14);

        jTextField12.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField12.setText("3000000");
        jPanel5.add(jTextField12);
        jTextField12.setBounds(145, 100, 70, 20);

        jLabel44.setForeground(new java.awt.Color(0, 0, 255));
        jLabel44.setText("Maximum Simulation Time");
        jPanel5.add(jLabel44);
        jLabel44.setBounds(10, 100, 120, 14);

        jPanel3.add(jPanel5);
        jPanel5.setBounds(0, 150, 450, 450);

        jTabbedPane1.addTab("Atarraya", jPanel3);

        jPanel25.setLayout(null);

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Deployment Info", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel6.setLayout(null);

        jLabel6.setText("100");
        jPanel6.add(jLabel6);
        jLabel6.setBounds(10, 30, 18, 14);

        jLabel29.setText("# of sinks");
        jPanel6.add(jLabel29);
        jLabel29.setBounds(70, 90, 47, 14);

        jLabel7.setText("100");
        jPanel6.add(jLabel7);
        jLabel7.setBounds(10, 50, 30, 14);

        jLabel8.setText("# of Nodes");
        jPanel6.add(jLabel8);
        jLabel8.setBounds(70, 30, 54, 14);

        jLabel9.setText("Comm Radius");
        jPanel6.add(jLabel9);
        jLabel9.setBounds(70, 50, 70, 14);

        jLabel28.setText("1");
        jPanel6.add(jLabel28);
        jLabel28.setBounds(10, 90, 6, 14);
        jPanel6.add(jLabel24);
        jLabel24.setBounds(10, 110, 40, 15);

        jLabel25.setText("Avg # of Ngb");
        jPanel6.add(jLabel25);
        jLabel25.setBounds(70, 110, 70, 14);

        jLabel100.setText("20");
        jPanel6.add(jLabel100);
        jLabel100.setBounds(10, 70, 12, 14);

        jLabel101.setText("Sensing Radius");
        jPanel6.add(jLabel101);
        jLabel101.setBounds(70, 70, 80, 14);

        jPanel25.add(jPanel6);
        jPanel6.setBounds(230, 90, 160, 150);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Visual Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel4.setPreferredSize(new java.awt.Dimension(160, 160));
        jPanel4.setLayout(null);

        jCheckBox1.setText("Atarraya");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox1ItemStateChanged(evt);
            }
        });
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });
        jPanel4.add(jCheckBox1);
        jCheckBox1.setBounds(20, 20, 70, 15);

        jCheckBox2.setText("Area Comm");
        jCheckBox2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox2ActionPerformed(evt);
            }
        });
        jPanel4.add(jCheckBox2);
        jCheckBox2.setBounds(110, 20, 90, 15);

        jCheckBox3.setText("Active Nodes");
        jCheckBox3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox3.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox3ItemStateChanged(evt);
            }
        });
        jCheckBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox3ActionPerformed(evt);
            }
        });
        jPanel4.add(jCheckBox3);
        jCheckBox3.setBounds(20, 40, 81, 15);

        jCheckBox4.setText("Filled Area");
        jCheckBox4.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox4.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox4ActionPerformed(evt);
            }
        });
        jPanel4.add(jCheckBox4);
        jCheckBox4.setBounds(110, 60, 70, 15);

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "All", "Black", "Red", "Blue", "Green", "Orange", "Pink", "Yellow" }));
        jComboBox1.setEnabled(false);
        jComboBox1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox1ItemStateChanged(evt);
            }
        });
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jPanel4.add(jComboBox1);
        jComboBox1.setBounds(120, 150, 61, 20);

        jLabel5.setText("<html>\nVirtual Network <br> Infrastructure ID");
        jPanel4.add(jLabel5);
        jLabel5.setBounds(20, 140, 100, 30);

        jCheckBox5.setText("Node Id");
        jCheckBox5.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox5.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox5.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox5ItemStateChanged(evt);
            }
        });
        jPanel4.add(jCheckBox5);
        jCheckBox5.setBounds(20, 60, 55, 15);

        jButton10.setText("Update View");
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10ActionPerformed(evt);
            }
        });
        jPanel4.add(jButton10);
        jButton10.setBounds(20, 90, 110, 20);

        jCheckBox21.setText("Area Sensing");
        jCheckBox21.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox21.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox21ActionPerformed(evt);
            }
        });
        jPanel4.add(jCheckBox21);
        jCheckBox21.setBounds(110, 40, 90, 15);

        jCheckBox10.setText("Active VNI");
        jCheckBox10.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox10ItemStateChanged(evt);
            }
        });
        jCheckBox10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox10ActionPerformed(evt);
            }
        });
        jPanel4.add(jCheckBox10);
        jCheckBox10.setBounds(20, 170, 140, 23);

        jLabel89.setForeground(new java.awt.Color(0, 0, 255));
        jLabel89.setText("View VNI");
        jPanel4.add(jLabel89);
        jLabel89.setBounds(20, 120, 130, 14);

        jCheckBox26.setText("All Gateways");
        jCheckBox26.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox26ActionPerformed(evt);
            }
        });
        jPanel4.add(jCheckBox26);
        jCheckBox26.setBounds(20, 190, 130, 23);

        jPanel25.add(jPanel4);
        jPanel4.setBounds(20, 20, 210, 220);

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Grid Coverage", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel9.setLayout(null);

        jComboBox4.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "None", "Square", "Diagonal" }));
        jComboBox4.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBox4ItemStateChanged(evt);
            }
        });
        jPanel9.add(jComboBox4);
        jComboBox4.setBounds(80, 30, 66, 20);

        jLabel17.setText("View Grid");
        jPanel9.add(jLabel17);
        jLabel17.setBounds(10, 30, 60, 14);

        jPanel25.add(jPanel9);
        jPanel9.setBounds(230, 20, 160, 70);

        jPanel30.setBorder(javax.swing.BorderFactory.createTitledBorder("Other variables"));

        jLabel102.setText("Max Energy");

        jTextField46.setText("1000");

        jButton25.setText("Update");
        jButton25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton25ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel30Layout = new org.jdesktop.layout.GroupLayout(jPanel30);
        jPanel30.setLayout(jPanel30Layout);
        jPanel30Layout.setHorizontalGroup(
            jPanel30Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel30Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel30Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel30Layout.createSequentialGroup()
                        .add(jTextField46, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 48, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel102)
                        .add(25, 25, 25))
                    .add(jPanel30Layout.createSequentialGroup()
                        .add(jButton25)
                        .addContainerGap(67, Short.MAX_VALUE))))
        );
        jPanel30Layout.setVerticalGroup(
            jPanel30Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel30Layout.createSequentialGroup()
                .add(jPanel30Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel102)
                    .add(jTextField46, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton25)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel25.add(jPanel30);
        jPanel30.setBounds(230, 240, 160, 80);

        jTabbedPane1.addTab("Visualization", jPanel25);

        jScrollPane2.setViewportView(jTextPane1);

        jButton4.setText("Generate Stats");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jTextField8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jLabel40.setText("Node ID");

        jLabel41.setForeground(new java.awt.Color(51, 51, 255));
        jLabel41.setText("Node Info");

        jButton9.setText("Switch Node State");
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel10Layout = new org.jdesktop.layout.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 369, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel10Layout.createSequentialGroup()
                        .add(jButton4)
                        .add(20, 20, 20)
                        .add(jTextField8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 89, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(12, 12, 12)
                        .add(jLabel40))
                    .add(jLabel41)
                    .add(jButton9))
                .addContainerGap(102, Short.MAX_VALUE))
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton4)
                    .add(jTextField8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel40))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel41)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 445, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jButton9)
                .addContainerGap(676, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Node Stats", jPanel10);

        jPanel23.setLayout(null);

        jTextArea2.setColumns(20);
        jTextArea2.setRows(5);
        jScrollPane3.setViewportView(jTextArea2);

        jPanel23.add(jScrollPane3);
        jScrollPane3.setBounds(10, 30, 360, 160);

        jLabel12.setForeground(new java.awt.Color(0, 0, 204));
        jLabel12.setText("Stats log");
        jPanel23.add(jLabel12);
        jLabel12.setBounds(10, 10, 42, 14);

        jPanel22.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Lifetime Report Analysis", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N

        jTextField4.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField4.setText("500");

        jLabel13.setText("Time step");

        jButton21.setText("Transform Report");
        jButton21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton21ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel22Layout = new org.jdesktop.layout.GroupLayout(jPanel22);
        jPanel22.setLayout(jPanel22Layout);
        jPanel22Layout.setHorizontalGroup(
            jPanel22Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel22Layout.createSequentialGroup()
                .addContainerGap()
                .add(jButton21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 139, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(jTextField4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel13)
                .addContainerGap(87, Short.MAX_VALUE))
        );
        jPanel22Layout.setVerticalGroup(
            jPanel22Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel22Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel22Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 42, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel13)
                    .add(jTextField4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel23.add(jPanel22);
        jPanel22.setBounds(10, 210, 360, 90);

        jTabbedPane1.addTab("Report", jPanel23);

        jPanel13.setLayout(null);

        jPanel17.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "CTR Dense Topologies", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel17.setLayout(null);

        jTextField6.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField6.setText("100");
        jPanel17.add(jTextField6);
        jTextField6.setBounds(10, 50, 50, 20);

        jLabel30.setText("Num Nodes");
        jPanel17.add(jLabel30);
        jLabel30.setBounds(70, 50, 60, 14);

        jLabel32.setText("0");
        jPanel17.add(jLabel32);
        jLabel32.setBounds(260, 70, 100, 14);

        jLabel58.setText("CTR Penrose-Santi");
        jPanel17.add(jLabel58);
        jLabel58.setBounds(260, 50, 100, 14);

        buttonGroup1.add(jRadioButton1);
        jRadioButton1.setSelected(true);
        jRadioButton1.setText("Dense");
        jPanel17.add(jRadioButton1);
        jRadioButton1.setBounds(300, 20, 80, 23);

        jTextField10.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField10.setText("0.01");
        jPanel17.add(jTextField10);
        jTextField10.setBounds(140, 80, 40, 20);

        jLabel76.setText("CTR Step");
        jPanel17.add(jLabel76);
        jLabel76.setBounds(190, 80, 60, 14);

        jLabel77.setText("Current:");
        jPanel17.add(jLabel77);
        jLabel77.setBounds(10, 120, 230, 14);

        jTextField29.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField29.setText("0.01");
        jPanel17.add(jTextField29);
        jTextField29.setBounds(140, 50, 40, 20);

        jLabel78.setText("Initial CTR");
        jPanel17.add(jLabel78);
        jLabel78.setBounds(190, 50, 60, 14);

        jLabel75.setText("CTR Santi and Blough");
        jPanel17.add(jLabel75);
        jLabel75.setBounds(260, 90, 110, 14);

        jLabel80.setText("0");
        jPanel17.add(jLabel80);
        jLabel80.setBounds(260, 110, 100, 14);

        jPanel13.add(jPanel17);
        jPanel17.setBounds(10, 10, 390, 150);

        jButton19.setText("MST");
        jButton19.setToolTipText("<html>Generates the Minimal Spanning Tree of the graph.<br>It also provides the total sum of edges of the MST.</html>");
        jButton19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton19ActionPerformed(evt);
            }
        });
        jPanel13.add(jButton19);
        jButton19.setBounds(20, 500, 90, 30);

        jPanel18.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "CTR Sparse Topologies - Experiment 3 for 2 dimensions", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 255))); // NOI18N
        jPanel18.setLayout(null);

        jLabel71.setText("CTR Pensore-Santi");
        jPanel18.add(jLabel71);
        jLabel71.setBounds(260, 50, 110, 14);

        buttonGroup1.add(jRadioButton2);
        jRadioButton2.setText("Sparse");
        jPanel18.add(jRadioButton2);
        jRadioButton2.setBounds(300, 10, 80, 20);

        jLabel70.setText("0");
        jPanel18.add(jLabel70);
        jLabel70.setBounds(260, 70, 100, 14);

        jLabel19.setForeground(new java.awt.Color(0, 0, 255));
        jLabel19.setText("L - Area Side");
        jPanel18.add(jLabel19);
        jLabel19.setBounds(10, 30, 80, 14);

        jLabel20.setText("L=2^(2*i)");
        jPanel18.add(jLabel20);
        jLabel20.setBounds(10, 110, 130, 14);

        jTextField33.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField33.setText("4");
        jPanel18.add(jTextField33);
        jTextField33.setBounds(10, 50, 30, 20);

        jLabel21.setText("Initial i");
        jPanel18.add(jLabel21);
        jLabel21.setBounds(50, 50, 31, 14);

        jTextField34.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField34.setText("10");
        jPanel18.add(jTextField34);
        jTextField34.setBounds(10, 80, 30, 20);

        jLabel22.setText("Final i");
        jPanel18.add(jLabel22);
        jLabel22.setBounds(50, 80, 27, 14);

        jLabel23.setText("n = sqrt(l)");
        jPanel18.add(jLabel23);
        jLabel23.setBounds(10, 130, 130, 14);

        jLabel39.setText("r = k*l^(3/4)*sqrt(log2(l))");
        jPanel18.add(jLabel39);
        jLabel39.setBounds(10, 150, 230, 14);

        jLabel72.setForeground(new java.awt.Color(0, 0, 255));
        jLabel72.setText("K parameter");
        jPanel18.add(jLabel72);
        jLabel72.setBounds(140, 30, 70, 14);

        jTextField35.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField35.setText("0.5");
        jPanel18.add(jTextField35);
        jTextField35.setBounds(140, 50, 50, 20);

        jLabel73.setText("Initial K");
        jPanel18.add(jLabel73);
        jLabel73.setBounds(210, 50, 35, 14);

        jTextField36.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField36.setText("1");
        jPanel18.add(jTextField36);
        jTextField36.setBounds(140, 80, 50, 20);

        jLabel83.setText("Final K");
        jPanel18.add(jLabel83);
        jLabel83.setBounds(210, 80, 31, 14);

        jTextField37.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField37.setText("0.1");
        jPanel18.add(jTextField37);
        jTextField37.setBounds(140, 110, 50, 20);

        jLabel84.setText("Step");
        jPanel18.add(jLabel84);
        jLabel84.setBounds(210, 110, 22, 14);

        jLabel87.setText("CTR Santi and Blough");
        jPanel18.add(jLabel87);
        jLabel87.setBounds(260, 90, 120, 14);

        jLabel88.setText("0");
        jPanel18.add(jLabel88);
        jLabel88.setBounds(260, 110, 110, 14);

        jPanel13.add(jPanel18);
        jPanel18.setBounds(10, 160, 390, 180);

        jButton16.setText("Giant Component");
        jButton16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton16ActionPerformed(evt);
            }
        });
        jPanel13.add(jButton16);
        jButton16.setBounds(10, 350, 120, 40);
        jPanel13.add(jLabel18);
        jLabel18.setBounds(20, 440, 380, 20);

        jTextField5.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField5.setText("100");
        jPanel13.add(jTextField5);
        jTextField5.setBounds(140, 360, 50, 20);

        jLabel14.setText("Num Topologies");
        jPanel13.add(jLabel14);
        jLabel14.setBounds(200, 360, 90, 14);

        jButton17.setText("Update CTR");
        jButton17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton17ActionPerformed(evt);
            }
        });
        jPanel13.add(jButton17);
        jButton17.setBounds(300, 350, 100, 40);

        jButton20.setText("Save Neighborhoods");
        jButton20.setToolTipText("<html>Saves the neighborhoods of all the nodes in the topology. <br>This information can be useful for solving optimization problems with linear programming.</html>");
        jButton20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton20ActionPerformed(evt);
            }
        });
        jPanel13.add(jButton20);
        jButton20.setBounds(270, 470, 140, 30);

        jLabel31.setForeground(new java.awt.Color(0, 0, 204));
        jLabel31.setText("Other options");
        jPanel13.add(jLabel31);
        jLabel31.setBounds(20, 470, 100, 14);

        jLabel85.setText("Sum of Edges: ");
        jPanel13.add(jLabel85);
        jLabel85.setBounds(130, 510, 120, 14);

        jLabel16.setForeground(new java.awt.Color(0, 0, 255));
        jLabel16.setText("Progress");
        jPanel13.add(jLabel16);
        jLabel16.setBounds(20, 420, 90, 14);

        jCheckBox25.setText("Node Degree Ratio");
        jPanel13.add(jCheckBox25);
        jCheckBox25.setBounds(10, 390, 120, 23);

        jTextField11.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTextField11.setText("100");
        jPanel13.add(jTextField11);
        jTextField11.setBounds(140, 390, 50, 20);

        jLabel74.setText("Area Side");
        jPanel13.add(jLabel74);
        jLabel74.setBounds(200, 390, 60, 14);

        jButton22.setText("BFS");
        jButton22.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton22ActionPerformed(evt);
            }
        });
        jPanel13.add(jButton22);
        jButton22.setBounds(270, 500, 140, 30);

        jButton23.setText("Save positions");
        jButton23.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton23ActionPerformed(evt);
            }
        });
        jPanel13.add(jButton23);
        jButton23.setBounds(270, 530, 140, 30);

        jButton24.setText("Solve CDS");
        jButton24.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton24ActionPerformed(evt);
            }
        });
        jPanel13.add(jButton24);
        jButton24.setBounds(20, 530, 90, 30);

        jCheckBox27.setText("Just 1 minimum?");
        jPanel13.add(jCheckBox27);
        jCheckBox27.setBounds(120, 535, 140, 23);

        jTabbedPane1.addTab("TC Theoretical", jPanel13);

        jSplitPane1.setRightComponent(jTabbedPane1);

        jPanel1.add(jSplitPane1, java.awt.BorderLayout.PAGE_START);

        jMenu2.setText("Menu");

        jMenuItem2.setText("Save Deployment");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem2);

        jMenuItem1.setText("Load Deployment");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem1);

        jMenuItem5.setText("Reset Topology");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem5);

        jMenuItem6.setText("Save Creaton Words");
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem6);
        jMenu2.add(jSeparator1);

        jMenuItem4.setText("Save deployment as png");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem4);

        jMenuBar2.add(jMenu2);

        jMenu1.setText("Help");

        jMenuItem3.setText("About Atarraya");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem3);

        jMenuBar2.add(jMenu1);

        setJMenuBar(jMenuBar2);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 635, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jCheckBox11ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox11ItemStateChanged
// TODO add your handling code here:
        
        facade.setView_covered_area_stat(jCheckBox11.isSelected());
        //CountNotVisited();
        
    }//GEN-LAST:event_jCheckBox11ItemStateChanged

    private void jCheckBox21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox21ActionPerformed
// TODO add your handling code here:
        myPanel.setRangeArea(jCheckBox2.isSelected(),jCheckBox21.isSelected());
        
    }//GEN-LAST:event_jCheckBox21ActionPerformed

    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed
// TODO add your handling code here:
        
        jTextArea1.setText("");
        
    }//GEN-LAST:event_jButton11ActionPerformed

    private void jButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
// TODO add your handling code here:
      
        myPanel.repaint();
        
    }//GEN-LAST:event_jButton10ActionPerformed

    private void jCheckBox20ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox20ItemStateChanged
// TODO add your handling code here:
        show_events = jCheckBox20.isSelected();
        
    }//GEN-LAST:event_jCheckBox20ItemStateChanged

    private void jComboBox7ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox7ItemStateChanged
// TODO add your handling code here:
        
        facade.selected_TCprotocol = jComboBox7.getSelectedIndex();
        
        switch(facade.selected_TCprotocol){
        
            case PROTOCOL_NO_SELECTED:
                    jButton1.setEnabled(false);
                    jButton8.setEnabled(false);
                    facade.TC_Selected = false;
                    break;
            
            default:
                    jButton1.setEnabled(true);
                    jButton8.setEnabled(true);
                    facade.TC_Selected = true;
                    break;
                   
        }
        
    }//GEN-LAST:event_jComboBox7ItemStateChanged

    private void jComboBox6ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox6ItemStateChanged
// TODO add your handling code here:
        
        facade.energy_distribution = jComboBox6.getSelectedIndex();
        
        switch(facade.energy_distribution){
        
            case ENERGY_CONSTANT:
                    jLabel53.setText("Value");
                    jTextField21.setEnabled(false);
                    jLabel53.setEnabled(false);      
                    break;

            case ENERGY_NORMAL:
                    jLabel52.setText("Mean");
                    jTextField21.setEnabled(true);
                    jLabel53.setEnabled(true);
                    try{
                    facade.sigma_e = Double.parseDouble(jTextField21.getText());
                    }catch(Exception ex){ex.printStackTrace();}       
                            
                    break;
            
            case ENERGY_POISSON:
                    jLabel53.setText("Lambda");
                    jTextField21.setEnabled(true);
                    jLabel53.setEnabled(true);
                    break;
                        
            case ENERGY_UNIFORM:
                    jLabel53.setText("Max Value");
                    jTextField21.setEnabled(false);
                    jLabel53.setEnabled(false);
                    break;
                    
        }
        
    }//GEN-LAST:event_jComboBox6ItemStateChanged

    private void jCheckBox19ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox19ItemStateChanged
// TODO add your handling code here:
        
         facade.excel_ready_reports = jCheckBox19.isSelected();
        
    }//GEN-LAST:event_jCheckBox19ItemStateChanged

    private void jCheckBox18ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox18ItemStateChanged
// TODO add your handling code here:
        
        facade.sumarized_reports = jCheckBox18.isSelected();
        
        if(facade.sumarized_reports){
            facade.indiv_reports  = false;
            jCheckBox17.setSelected(false);
            jTextField18.setEnabled(true);
            jLabel48.setEnabled(true);
        }else{
            facade.indiv_reports  = true;
            jCheckBox17.setSelected(true);
            jTextField18.setEnabled(false);
            jLabel48.setEnabled(false);
        
        }
        
    }//GEN-LAST:event_jCheckBox18ItemStateChanged

    private void jCheckBox17ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox17ItemStateChanged
// TODO add your handling code here:
        
        facade.indiv_reports = jCheckBox17.isSelected();
        if(facade.indiv_reports){
            facade.sumarized_reports = false;
            jCheckBox18.setSelected(false);
            jTextField18.setEnabled(false);
            jLabel48.setEnabled(false);
        }else{
            facade.sumarized_reports  = true;
            jCheckBox18.setSelected(true);
            jTextField18.setEnabled(true);
            jLabel48.setEnabled(true);
        }
        
    }//GEN-LAST:event_jCheckBox17ItemStateChanged
  
    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
// TODO add your handling code here:
        update(SET_BATCH_SIM_FILES, "");//batchSimulationSelectFiles();
    }//GEN-LAST:event_jButton7ActionPerformed

    private void jCheckBox16ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox16ItemStateChanged
// TODO add your handling code here:
        facade.setBatch_creation(jCheckBox16.isSelected());
        //batch_creation = jCheckBox16.isSelected();
        if(jCheckBox16.isSelected()){
            jTextField16.setEnabled(true);
            jLabel45.setEnabled(true);
            jTextField17.setEnabled(true);
            jLabel46.setEnabled(true);
            jButton3.setText("Create Batch");
        }else{
            jButton3.setText("Create Deployment");
            jTextField16.setEnabled(false);
            jLabel45.setEnabled(false);
            jTextField17.setEnabled(false);
            jLabel46.setEnabled(false);
        }
            
        
    }//GEN-LAST:event_jCheckBox16ItemStateChanged

    
    private void jComboBox2ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox2ItemStateChanged
// TODO add your handling code here:
        
        facade.rand_distribution = jComboBox2.getSelectedIndex();
        
        switch(facade.rand_distribution){
        
            case UNIFORM_DIST:
                    jTextField23.setEnabled(true);
                    jTextField24.setEnabled(true);
                    jLabel10.setEnabled(false);
                    jLabel55.setEnabled(false);
                    jTextField1.setEnabled(true);
                    jTextField15.setEnabled(false);
                    jLabel37.setEnabled(false);                     
                    break;

            case NORMAL_DIST:
                    jTextField23.setEnabled(true);
                    jTextField24.setEnabled(true);
                    jLabel10.setEnabled(true);
                    jLabel55.setEnabled(true);
                    jTextField1.setEnabled(true);
                    jTextField15.setEnabled(true);
                    jLabel37.setEnabled(true);
                    jLabel37.setText("Sigma");
                    try{
                    facade.sigma = Double.parseDouble(jTextField15.getText());
                    }catch(Exception ex){ex.printStackTrace();}       
                            
                    break;
            
            case GRID_H_V:
            case GRID_H_V_D:
                    jTextField1.setEnabled(false);
                    break;
                    
            case CONSTANT:
                 jTextField23.setEnabled(true);
                    jTextField24.setEnabled(true);
                    jLabel10.setEnabled(true);
                    jLabel55.setEnabled(true);
                    jTextField1.setEnabled(true);
                    jTextField15.setEnabled(false);
                    jLabel37.setEnabled(false);
                break;
                    
                case CENTER:
                    jTextField23.setEnabled(false);
                    jTextField24.setEnabled(false);
                    jLabel10.setEnabled(false);
                    jLabel55.setEnabled(false);
                    jTextField23.setText(Integer.toString(facade.getH()/2));
                    jTextField24.setText(Integer.toString(facade.getW()/2));
                    jTextField1.setEnabled(true);
                    jTextField15.setEnabled(false);
                    jLabel37.setEnabled(false);
                break;

            case GRID_LAMBDA:
            case GRID_POISSON:
                jTextField15.setEnabled(true);
                jLabel37.setEnabled(true);
                jLabel37.setText("Lambda");
                jTextField1.setEnabled(false);
                break;

        }
        
    }//GEN-LAST:event_jComboBox2ItemStateChanged

    private void jCheckBox13ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox13ItemStateChanged
// TODO add your handling code here:
        
        facade.setAll_trees(jCheckBox13.isSelected());//all_trees = jCheckBox13.isSelected();
        
    }//GEN-LAST:event_jCheckBox13ItemStateChanged

    private void jCheckBox6ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox6ItemStateChanged
// TODO add your handling code here:
        facade.setLiveStats(jCheckBox6.isSelected());
        if(facade.isLiveStats()){
            facade.UpdateStats();
        }
        
    }//GEN-LAST:event_jCheckBox6ItemStateChanged
    
    private void jCheckBox5ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox5ItemStateChanged
// TODO add your handling code here:
        
        setViewNodeNumber(jCheckBox5.isSelected());
        
    }//GEN-LAST:event_jCheckBox5ItemStateChanged

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
// TODO add your handling code here:
        
        int i=-1;
        
        if(!jTextField8.getText().equals(""))
            try{
                i = Integer.parseInt(jTextField8.getText());
            }catch(Exception e){e.printStackTrace();}
        
        update(SHOW_NODE_INFO, i);//showNodeInfo(i);
        
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
// TODO add your handling code here:
        //I can use numnodes because I will use it for real just when the topology is being generated, not before.
        facade.setTempnumnodes(0);
        try{
            facade.setNumnodes(Integer.parseInt(jTextField1.getText()));
        }catch(Exception ex){ex.printStackTrace();}
        jButton5.setText("Nodes left: "+(facade.getNumnodes()));
        myPanel.setNumNodes(facade.getNumnodes());
        myPanel.setlistenPosNode(true);
        
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jComboBox5ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox5ItemStateChanged
// TODO add your handling code here:
        facade.setSortingmode(jComboBox5.getSelectedIndex());//sortingmode = jComboBox5.getSelectedIndex();
    }//GEN-LAST:event_jComboBox5ItemStateChanged

    private void jComboBox4ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox4ItemStateChanged
// TODO add your handling code here:
        
        gridmode = jComboBox4.getSelectedIndex();
        myPanel.setGridmode(gridmode);
    }//GEN-LAST:event_jComboBox4ItemStateChanged

    private void jComboBox1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox1ItemStateChanged
// TODO add your handling code here:
        
        treeIDViz = jComboBox1.getSelectedIndex()-1;
        myPanel.setActive_tree_viz(treeIDViz);
        if(jCheckBox6.isSelected())
            facade.CountNotVisited();
        myPanel.repaint();
        
    }//GEN-LAST:event_jComboBox1ItemStateChanged

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
// TODO add your handling code here:
        
        facade.resetSim();
        update(SET_FILE_SELECTION_MODE, jFileChooser1.FILES_AND_DIRECTORIES);
        update(SET_MYFILE, "");
               
        if (facade.getMyFile() != null) {
                
                if(facade.getMyFile().length() > 0){
                    //This is where a real application would open the file.
                    update(SHOW_MSG, "Opening: " + facade.getMyFile().getName() + ".");
                    facade.setBatch_simulation(false);
                    facade.save_stats = false;
                    jCheckBox15.setSelected(false);
                    facade.LoadDeployment(facade.getMyFile().getPath());
                    jTextField1.setText(""+facade.getNumnodes());
                    jTextField2.setText(""+facade.radius);
                }else{
                    update(SHOW_MSG, "No files selected by user.");//showMessage("No files selected by user.");
                }
            } else {
                update(SHOW_MSG,"Open command cancelled by user.");//showMessage("Open command cancelled by user.");
            }
        
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
// TODO add your handling code here:
        update(SET_FILE_SELECTION_MODE, jFileChooser1.FILES_AND_DIRECTORIES);
        update(SHOW_SAVE_FILE, "");
        String the_name="";
        
        if (facade.getMyFile() != null) {
                //This is where a real application would open the file.
                update(SHOW_MSG, "Saving: " + facade.getMyFile().getName() + ".ata");//showMessage("Opening: " + myFile.getName() + ".");
                the_name = facade.getMyFile().getPath();
                if(!the_name.endsWith(".ata"))
                    the_name=the_name+".ata";
                
                facade.SaveDeployment(the_name);
                
            } else {
                update(SHOW_MSG, "Open command cancelled by user.");
            }

        
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jCheckBox4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox4ActionPerformed
// TODO add your handling code here:
        
        myPanel.setFilledActiveNodes(jCheckBox4.isSelected());
        
    }//GEN-LAST:event_jCheckBox4ActionPerformed

    private void jCheckBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox3ActionPerformed
// TODO add your handling code here:
        
        myPanel.setActiveNodes(jCheckBox3.isSelected());
        
    }//GEN-LAST:event_jCheckBox3ActionPerformed
   
    public void updateNodeCreationWordsParams(){
    
        try{
            facade.setNodeCreationWordAttributes(Integer.parseInt(jTextField1.getText()), Double.parseDouble(jTextField2.getText()),
                                Double.parseDouble(jTextField7.getText()), Double.parseDouble(jTextField9.getText()),
                                jComboBox2.getSelectedIndex(), Integer.parseInt(jTextField23.getText()), Integer.parseInt(jTextField24.getText()),
                                jComboBox6.getSelectedIndex(), Integer.parseInt(jTextField25.getText()), Integer.parseInt(jTextField20.getText()),
                                Double.parseDouble(jTextField15.getText()), Double.parseDouble(jTextField21.getText()),
                                Double.parseDouble(jTextField26.getText()), Double.parseDouble(jTextField27.getText()), jCheckBox8.isSelected(),
                                jComboBox13.getSelectedIndex(), jComboBox14.getSelectedIndex(), jComboBox8.getSelectedIndex(), Integer.parseInt(jTextField31.getText()),
                                Integer.parseInt(jTextField32.getText()),Integer.parseInt(jTextField48.getText()));
        }catch(Exception e){
            e.printStackTrace();
            facade.setNodeCreationWordAttributes(1, 40.0, 20.0, 10, 0, 300, 300, 0, 1000, 1000, 1, 1, facade.weight_metric1, facade.weight_metric2, false, 0, 0, 0, 600, 600, 5);
        }
        
    }
    
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
// TODO add your handling code here:
       int i,j=0;
       boolean sw;
       String the_path;
       int count_trials=0;
       int result=0;
       
       facade.resetSim();
       
       facade.setCurrent_node_count(0);
       //current_node_count=0;
       
       String[] options = new String[2];
       options[0] = "Yes";
       options[1] = "No";
       
        update(CLEAR_SIM, "");
        facade.setBatch_simulation(false);
        
        if(!facade.isBatch_creation()){
            do{
                myPanel.clearAll();
                /*try{
                    facade.setNodeCreationWordAttributes(Integer.parseInt(jTextField1.getText()), Double.parseDouble(jTextField2.getText()),
                                        Double.parseDouble(jTextField7.getText()), Double.parseDouble(jTextField9.getText()),
                                        jComboBox2.getSelectedIndex(), Integer.parseInt(jTextField23.getText()), Integer.parseInt(jTextField24.getText()),
                                        jComboBox6.getSelectedIndex(), Integer.parseInt(jTextField25.getText()), Integer.parseInt(jTextField20.getText()),
                                        Double.parseDouble(jTextField15.getText()), Double.parseDouble(jTextField21.getText()),
                                        Double.parseDouble(jTextField26.getText()), Double.parseDouble(jTextField27.getText()), jCheckBox8.isSelected(),
                                        jComboBox13.getSelectedIndex(), jComboBox14.getSelectedIndex(), jComboBox8.getSelectedIndex(), Integer.parseInt(jTextField31.getText()),
                                        Integer.parseInt(jTextField32.getText()),Integer.parseInt(jTextField48.getText()));
                }catch(Exception e){
                    e.printStackTrace();
                    facade.setNodeCreationWordAttributes(1, 40.0, 20.0, 10, 0, 300, 300, 0, 1000, 1000, 1, 1, facade.weight_metric1, facade.weight_metric2, false, 0, 0, 0, 600, 600, 5);
                }*/
                updateNodeCreationWordsParams();
                sw=facade.NodeGenerator();
                count_trials++;
                
                if(count_trials>=MAX_TRIALS){
                    
                    result = JOptionPane.showOptionDialog( 
 		    this,                             // the parent that the dialog blocks 
 		    "The maximum amount of failed trials was reached. Want to try again?",                                    // the dialog message array 
 		    "Topology Creation Error", // the title of the dialog window 
 		    JOptionPane.DEFAULT_OPTION,                 // option type 
 		    JOptionPane.INFORMATION_MESSAGE,            // message type 
 		    null,                                       // optional icon, use null to use the default icon 
 		    options,                                    // options string array, will be made into buttons 
 		    options[1]                                  // option that should be made into a default button 
 		); 
 		switch(result) { 
 		   case 0: // yes 
 		     count_trials=0;
 		     break; 
 		   case 1: // no 
 		     //count_trials = MAX_TRIALS+1;
                     sw=true;
                     update(CLEAR_SIM, "");
 		     break; 
 		   default: 
 		     break; 
 		} 
                
                }else{
                    if(sw)
                        facade.setTopology_loaded(true);
                }
                
            }while(!sw);
            myPanel.repaint();
        }else{
            
            try{
                j=Integer.parseInt(jTextField16.getText());
                facade.setNumTopologies(Integer.parseInt(jTextField16.getText()));
            }catch(Exception ex){ex.printStackTrace();}
            
            if(j>0){
            
             i = jFileChooser1.showOpenDialog(this);
             
            if (i == JFileChooser.APPROVE_OPTION) {
                facade.setMyFile(jFileChooser1.getSelectedFile());
                
                if(facade.getMyFile().isDirectory()){
                    the_path = facade.getMyFile().getPath();
                    
                    //This is where a real application would open the file.
                    update(SHOW_MSG, "Saving batch deployments in: " + the_path);//showMessage("Saving batch deployments in: " + the_path);
                    facade.getThe_batch_sim().setParamsForBatchCreation(j, the_path);
                    facade.CGStep = jTextField28.getText();
                    facade.createAllSteps = jCheckBox14.isSelected();
                    facade.getThe_batch_sim().setWork(GENERATE_TOPOS);
                    jProgressBar2.setMaximum(j);
                    jProgressBar2.setValue(0);
                    
                }
                
            } else {
                update(SHOW_MSG, "Save command cancelled by user.");//showMessage("Save command cancelled by user.");
            }
             
        }else
            update(PRINT_MSG, "Non valid batch number!");//javax.swing.JOptionPane.showMessageDialog(this, "Non valid batch number!");
            
        }
        
    }//GEN-LAST:event_jButton3ActionPerformed

    
    private void jCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox2ActionPerformed
// TODO add your handling code here:
        myPanel.setRangeArea(jCheckBox2.isSelected(),jCheckBox21.isSelected());
    }//GEN-LAST:event_jCheckBox2ActionPerformed

    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
// TODO add your handling code here:
        
        myPanel.setAtarraya(jCheckBox1.isSelected());
        
    }//GEN-LAST:event_jCheckBox1ActionPerformed

    
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
// TODO add your handling code here:
        //mainSW = false;
        if(facade.getTempsim()!=null){
        //if(facade.getSim()!=null){
            if(facade.isSimulationStarted()){
                facade.simulation_pause();
                jButton2.setText("Restart agent");
            }else{
                facade.simulation_start();
                jButton2.setText("Pause agent");
            }
        }
    }//GEN-LAST:event_jButton2ActionPerformed
   
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// TODO add your handling code here:
        
        if(facade.topology_loaded){
            updateNodeCreationWordsParams();
            facade.clock=0;
            facade.selectSimulator();
            jCheckBox3.setSelected(true);
            jCheckBox1.setSelected(true);
            jCheckBox10.setSelected(true);
            jComboBox1.setEnabled(true);
            facade.sim_assigned = true;
            try {
                facade.setStartSimulationAttributes(Integer.parseInt(jTextField3.getText()),
                        Double.parseDouble(jTextField12.getText()), Double.parseDouble(jTextField39.getText()),
                        Double.parseDouble(jTextField38.getText()),Integer.parseInt(jTextField40.getText()),
                        Integer.parseInt(jTextField41.getText()), jTextField18.getText());
            } catch(Exception e){
                e.printStackTrace();
                try{
                    facade.setStartSimulationAttributes(0, Double.parseDouble(jTextField12.getText()),
                            Double.parseDouble(jTextField39.getText()), Double.parseDouble(jTextField38.getText()),
                            Integer.parseInt(jTextField40.getText()), Integer.parseInt(jTextField41.getText()),"");
                }catch(Exception e2){
                    e.printStackTrace();
                }
            }
            facade.StartSimulation();
            facade.setTopology_loaded(false);//topology_loaded = false;
        }else if(facade.num_files_topology_from_batch>0){
            updateNodeCreationWordsParams();
            facade.selectSimulator();
            try {
                facade.setStartSimulationAttributes(Integer.parseInt(jTextField3.getText()),
                        Double.parseDouble(jTextField12.getText()), Double.parseDouble(jTextField39.getText()),
                        Double.parseDouble(jTextField38.getText()),Integer.parseInt(jTextField40.getText()),
                        Integer.parseInt(jTextField41.getText()), jTextField18.getText());
            } catch(Exception e){
                //e.printStackTrace();
                try{
                    facade.setStartSimulationAttributes(0, Double.parseDouble(jTextField12.getText()),
                            Double.parseDouble(jTextField39.getText()), Double.parseDouble(jTextField38.getText()),
                            Integer.parseInt(jTextField40.getText()), Integer.parseInt(jTextField41.getText()),"");
                }catch(Exception e2){
                    e.printStackTrace();
                }
            }
            try{
                facade.setBatchSimAttributes(Double.parseDouble(jTextField43.getText()),
                        Double.parseDouble(jTextField44.getText()), Double.parseDouble(jTextField45.getText()),
                        Integer.parseInt(jTextField19.getText()), jTextField18.getText());
            }catch(Exception ex){
                update(PRINT_MSG, "Error while setting Batch Simulation Attributes.");
            }
            facade.getThe_batch_sim().setWork(SIMULATE);
        }


    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton12ActionPerformed
        // TODO add your handling code here:
        /*
        try{
            facade.setNodeCreationWordAttributes(Integer.parseInt(jTextField1.getText()), Double.parseDouble(jTextField2.getText()),
                                    Double.parseDouble(jTextField7.getText()), Double.parseDouble(jTextField9.getText()),
                                    jComboBox2.getSelectedIndex(), Integer.parseInt(jTextField23.getText()), Integer.parseInt(jTextField24.getText()),
                                    jComboBox6.getSelectedIndex(), Integer.parseInt(jTextField25.getText()), Integer.parseInt(jTextField20.getText()),
                                    Double.parseDouble(jTextField15.getText()), Double.parseDouble(jTextField21.getText()),
                                    Double.parseDouble(jTextField26.getText()), Double.parseDouble(jTextField27.getText()), jCheckBox8.isSelected(),
                                    jComboBox13.getSelectedIndex(), jComboBox14.getSelectedIndex(), jComboBox8.getSelectedIndex(), Integer.parseInt(jTextField31.getText()),
                                    Integer.parseInt(jTextField32.getText()),Integer.parseInt(jTextField48.getText()));
        }catch(Exception e){
            e.printStackTrace();
            facade.setNodeCreationWordAttributes(1, 40.0, 20.0, 10, 0, 300, 300, 0, 1000, 1000, 1, 1, facade.weight_metric1, facade.weight_metric2, false, 0, 0, 0, 600, 600, 5);
        }*/
        
            updateNodeCreationWordsParams();
            facade.addNodeCreationWord();
    }//GEN-LAST:event_jButton12ActionPerformed
    
    private void jButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton13ActionPerformed
        // TODO add your handling code here:
       int i = jList1.getSelectedIndex();
       
       if(i!=-1){
        facade.node_creation_words.remove(i);
       }
       
       i = jList2.getSelectedIndex();
       if(i!=-1){
          facade.sink_creation_words.remove(i);
       }
       
       this.update(UPDATE_NODE_CREATION_WORDS, "");
               //UpdateNodeCreationWords();
       
    }//GEN-LAST:event_jButton13ActionPerformed

    private void jCheckBox22ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox22ActionPerformed
        // TODO add your handling code here:
        
         if(jCheckBox22.isSelected()){
            jTextField1.setText("1");
            jComboBox2.setSelectedIndex(3);
            jComboBox8.setEnabled(true);
            facade.sinkNode = true;
        }else{
            jComboBox2.setSelectedIndex(0);
            jComboBox8.setEnabled(false);
            jComboBox8.setSelectedIndex(0);
            facade.sinkNode = false;
        }
        
    }//GEN-LAST:event_jCheckBox22ActionPerformed

    private void jCheckBox22ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox22ItemStateChanged
        // TODO add your handling code here:
        
        if(jCheckBox22.isSelected()){
            jTextField1.setText("1");
            jComboBox2.setSelectedIndex(CENTER);
        }else{
            jComboBox2.setSelectedIndex(0);
        }
    }//GEN-LAST:event_jCheckBox22ItemStateChanged

    private void jButton14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton14ActionPerformed
        // TODO add your handling code here:
    
        facade.setWeights(jTextField26.getText(), jTextField27.getText());
        
    }//GEN-LAST:event_jButton14ActionPerformed

    private void jComboBox10ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox10ItemStateChanged
        // TODO add your handling code here:
        
        facade.selected_TMprotocol = jComboBox10.getSelectedIndex();
        
        if(facade.selected_TMprotocol == 0){
            facade.TM_Selected=false;
            if(!facade.SD_Selected && !facade.COMM_Selected && facade.TC_Selected)
                jButton1.setEnabled(true);
            else
                jButton1.setEnabled(false);
        }else{
            facade.TM_Selected=true;
            if(facade.SD_Selected && facade.COMM_Selected && facade.TC_Selected)
                jButton1.setEnabled(true);
            else
                jButton1.setEnabled(false);
        }
        
    }//GEN-LAST:event_jComboBox10ItemStateChanged

    private void jComboBox11ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox11ItemStateChanged
        // TODO add your handling code here:
        
        facade.selected_SDprotocol = jComboBox11.getSelectedIndex();
        
        if(facade.selected_SDprotocol == 0){
            facade.SD_Selected=false;
            if(!facade.TM_Selected && !facade.COMM_Selected && facade.TC_Selected)
                jButton1.setEnabled(true);
            else
                jButton1.setEnabled(false);
        }else{
            facade.SD_Selected=true;
            if(facade.TM_Selected && facade.COMM_Selected && facade.TC_Selected)
                jButton1.setEnabled(true);
            else
                jButton1.setEnabled(false);
        }
        
    }//GEN-LAST:event_jComboBox11ItemStateChanged

    
    private void jButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton15ActionPerformed
        // TODO add your handling code here:
        
        facade.clean_creation_words();
        
    }//GEN-LAST:event_jButton15ActionPerformed

    private void jCheckBox10ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox10ItemStateChanged
        // TODO add your handling code here:
        
        view_active_tree = jCheckBox10.isSelected();
        myPanel.repaint();
        
    }//GEN-LAST:event_jCheckBox10ItemStateChanged

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        // TODO add your handling code here:
        facade.simulation_end();
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jCheckBox15ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox15ItemStateChanged
        // TODO add your handling code here:
        
        facade.save_stats = jCheckBox15.isSelected();
        
        if(facade.save_stats){
            
                jCheckBox17.setSelected(false);
                jCheckBox17.setEnabled(true);
                facade.indiv_reports=false;
                jCheckBox18.setSelected(true);
                jCheckBox18.setEnabled(true);
                facade.sumarized_reports=true;
                jCheckBox19.setSelected(true);
                jCheckBox19.setEnabled(true);
                facade.excel_ready_reports=true;
                jCheckBox23.setSelected(false);
                jCheckBox23.setEnabled(true);
                facade.save_all_stats=false;
                
        }else{
            jCheckBox17.setSelected(false);
            jCheckBox17.setEnabled(false);
            facade.indiv_reports=false;
            jCheckBox18.setSelected(true);
            jCheckBox18.setEnabled(false);
            facade.sumarized_reports=true;
            jCheckBox19.setSelected(true);
            jCheckBox19.setEnabled(false);
            facade.excel_ready_reports=true;
            jCheckBox23.setSelected(false);
            jCheckBox23.setEnabled(false);
            facade.save_all_stats=false;
        }
        
    }//GEN-LAST:event_jCheckBox15ItemStateChanged

    private void jCheckBox23ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox23ItemStateChanged
        // TODO add your handling code here:
        
        facade.save_all_stats = jCheckBox23.isSelected();
        
        if(facade.save_all_stats){
            jTextField3.setEnabled(true);
            try{
                facade.save_all_stats_step = Integer.parseInt(jTextField3.getText());
            }catch(Exception ex){ex.printStackTrace();}

        }else{
            jTextField3.setEnabled(false);
        }
            
        
    }//GEN-LAST:event_jCheckBox23ItemStateChanged

    private void jCheckBox9ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox9ItemStateChanged
        // TODO add your handling code here:
        facade.save_lifetime_log = jCheckBox9.isSelected();
        
    }//GEN-LAST:event_jCheckBox9ItemStateChanged

    private void jCheckBox12ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox12ItemStateChanged
        // TODO add your handling code here:
        facade.save_events_log = jCheckBox12.isSelected();
    }//GEN-LAST:event_jCheckBox12ItemStateChanged

    private void jButton16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton16ActionPerformed
        // TODO add your handling code here:
       
       //GiantComponentTest();
       
        try{
            facade.setGiantComponentTestAttributes(Integer.parseInt(jTextField6.getText()),Integer.parseInt(jTextField11.getText()),
                    Integer.parseInt(jTextField5.getText()), Double.parseDouble(jTextField29.getText()), Double.parseDouble(jTextField10.getText()),
                    Double.parseDouble(jTextField35.getText()), Double.parseDouble(jTextField36.getText()), Double.parseDouble(jTextField37.getText()),
                    Integer.parseInt(jTextField33.getText()), Integer.parseInt(jTextField34.getText()), jRadioButton1.isSelected(), jCheckBox25.isSelected(),
                    jRadioButton2.isSelected());
            facade.CGStep = jTextField28.getText();
            facade.createAllSteps = jCheckBox14.isSelected();
       }catch(Exception ex){
           ex.printStackTrace();
           facade.setGiantComponentTestAttributes(100, 100, 100, 0.01, 0.01, 0.5, 1, 0.1, 4, 10, jRadioButton1.isSelected(), jCheckBox25.isSelected(),
                    jRadioButton2.isSelected());
           facade.CGStep = 0.25+"";
           facade.createAllSteps = false;
       }
        
            facade.getThe_batch_sim().setWork(GIANTCOMPONENT);
        
    }//GEN-LAST:event_jButton16ActionPerformed
   
    private void jButton17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton17ActionPerformed
        // TODO add your handling code here:
        try{
        facade.setGiantComponentTestAttributes(Integer.parseInt(jTextField6.getText()),Integer.parseInt(jTextField11.getText()),
                    Integer.parseInt(jTextField5.getText()), Double.parseDouble(jTextField29.getText()), Double.parseDouble(jTextField10.getText()),
                    Double.parseDouble(jTextField35.getText()), Double.parseDouble(jTextField36.getText()), Double.parseDouble(jTextField37.getText()),
                    Integer.parseInt(jTextField33.getText()), Integer.parseInt(jTextField34.getText()), jRadioButton1.isSelected(), jCheckBox25.isSelected(),
                    jRadioButton2.isSelected());
        }catch(Exception ex){
            ex.printStackTrace();

            facade.setGiantComponentTestAttributes(100, 100, 100, 0.01, 0.01, 0.5, 1, 0.1, 4, 10, jRadioButton1.isSelected(), jCheckBox25.isSelected(),
                    jRadioButton2.isSelected());
        }
        //update_ctr();
        
    }//GEN-LAST:event_jButton17ActionPerformed

    private void jButton18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton18ActionPerformed
        // TODO add your handling code here:
        
        facade.setInterqueryTime(Double.parseDouble(jTextField9.getText()));
        
    }//GEN-LAST:event_jButton18ActionPerformed

    private void jButton19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton19ActionPerformed
        // TODO add your handling code here:
        
        facade.ExecuteMST();
        jCheckBox26.setSelected(true);
        
    }//GEN-LAST:event_jButton19ActionPerformed

    private void jCheckBox24ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox24ActionPerformed
        // TODO add your handling code here:
        
        if(jCheckBox24.isSelected())
            facade.setCheckTrials(true);
        else
            facade.setCheckTrials(false);
        
    }//GEN-LAST:event_jCheckBox24ActionPerformed

    private void jButton20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton20ActionPerformed
        // TODO add your handling code here:
        
        boolean ok = facade.SaveNeighborhoods();
        if(ok)
            update(PRINT_MSG, "Neighborhoods saved");
           
        
    }//GEN-LAST:event_jButton20ActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        // TODO add your handling code here:
        AboutFrame theAboutFrame = new AboutFrame();
        theAboutFrame.setBounds(100,100,600, 400);
        theAboutFrame.setVisible(true);
        
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jCheckBox1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox1ItemStateChanged
        // TODO add your handling code here:
        
        myPanel.setAtarraya(jCheckBox1.isSelected());
        
    }//GEN-LAST:event_jCheckBox1ItemStateChanged

    private void jCheckBox3ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox3ItemStateChanged
        // TODO add your handling code here:
        myPanel.setActiveNodes(jCheckBox3.isSelected());
    }//GEN-LAST:event_jCheckBox3ItemStateChanged

    private void jButton21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton21ActionPerformed
        // TODO add your handling code here:
        
        jFileChooser1.setMultiSelectionEnabled(true);
         int i = jFileChooser1.showOpenDialog(this);
         int j;
         double st = 500.0;
        
        if (i == JFileChooser.APPROVE_OPTION) {
                facade.myFiles = jFileChooser1.getSelectedFiles();
                //This is where a real application would open the file.
                for(j=0;j<facade.myFiles.length;j++){
                    try{
                        st = Double.parseDouble(jTextField4.getText());
                    }catch(Exception ex){}
                    facade.TransformReport2(facade.myFiles[j].getName(), facade.myFiles[j].getParent(), st);
                }
                update(PRINT_MSG,"Transfomed Reports!!" );//printmessage("Transfomed Reports!!");
                
            } else {
                update(SHOW_MSG, "Open command cancelled by user.");//showMessage("Open command cancelled by user.");
            }
         
         jFileChooser1.setMultiSelectionEnabled(false);
        
    }//GEN-LAST:event_jButton21ActionPerformed

private void jCheckBox26ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox26ActionPerformed
// TODO add your handling code here:
    frame_repaint();
}//GEN-LAST:event_jCheckBox26ActionPerformed

private void jComboBox9ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox9ItemStateChanged
    // TODO add your handling code here:
    
    facade.selected_COMMprotocol = jComboBox9.getSelectedIndex();
        
        if(facade.selected_COMMprotocol == 0){
            facade.COMM_Selected=false;
            if(!facade.TM_Selected && !facade.SD_Selected && facade.TC_Selected)
                jButton1.setEnabled(true);
            else
                jButton1.setEnabled(false);
        }else{
            facade.COMM_Selected=true;
            if(facade.TM_Selected && facade.SD_Selected && facade.TC_Selected)
                jButton1.setEnabled(true);
            else
                jButton1.setEnabled(false);
        }
    
}//GEN-LAST:event_jComboBox9ItemStateChanged

private void jCheckBox10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox10ActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_jCheckBox10ActionPerformed

private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton9ActionPerformed
    // TODO add your handling code here:
    int temp=myPanel.selected_node;
    int temp2 = 0;

    if(temp!=-1){
        temp2 = facade.getNode(temp).getActiveTree();
        if(facade.getNode(temp).isActive(temp2)){
            facade.getNode(temp).getInfrastructure(temp2).setSleepingNodeState();
        }else if(facade.getNode(temp).isSleeping(temp2))
            facade.getNode(temp).getInfrastructure(temp2).setActiveNodeState();

        myPanel.repaint();

    }

}//GEN-LAST:event_jButton9ActionPerformed

private void jButton22ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton22ActionPerformed
    // TODO add your handling code here:

    int i=facade.BFS(BFS_MODE_STANDARD, facade.getNumnodes());
    boolean ok = facade.SaveBFSMatrix();
    if(ok)
        update(PRINT_MSG, "BFS matrix saved");//printmessage("BFS matrix saved");

}//GEN-LAST:event_jButton22ActionPerformed

private void jButton23ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton23ActionPerformed
    // TODO add your handling code here:

    facade.getThe_batch_sim().setWork(POSITIONFILES);
    
}//GEN-LAST:event_jButton23ActionPerformed

private void jComboBox3ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox3ItemStateChanged
    // TODO add your handling code here:

    facade.selected_Motionprotocol = jComboBox3.getSelectedIndex();

}//GEN-LAST:event_jComboBox3ItemStateChanged

private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed

    // TODO add your handling code here:
        // Try to export an image from JPanel
    
    jFileChooser2.setMultiSelectionEnabled(false);
    int i = jFileChooser2.showSaveDialog(this);
    String the_path="";
    timestamp the_time = new timestamp();
    
    //if (facade.getMyFile() != null) {
    //if (jFileChooser2.getCurrentDirectory() != null) {
    if (i == JFileChooser.APPROVE_OPTION){
            the_path=jFileChooser2.getSelectedFile().getPath();
            
            if(jFileChooser2.getSelectedFile().isDirectory())
                the_path = the_path+"\\";
            else
                the_path = the_path+"_";
        
        //This is where a real application would open the file.
        myPanel.saveComponentAsJPEG(the_path+the_time.toString2()+".png");

        update(SHOW_MSG, "Topology Saved!!");
    } else {
        update(SHOW_MSG, "Open command cancelled by user.");//showMessage("Open command cancelled by user.");
    }
    
}//GEN-LAST:event_jMenuItem4ActionPerformed

private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
    // TODO add your handling code here:

    facade.reset_topology();

}//GEN-LAST:event_jMenuItem5ActionPerformed

private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
    // TODO add your handling code here:

    facade.setNum_topology_from_batch(0);
    facade.myFiles = null;
    facade.setBatch_simulation(false);
    jLabel47.setText("0 files selected");

}//GEN-LAST:event_jButton8ActionPerformed

private void jComboBox12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox12ActionPerformed
    // TODO add your handling code here:

    facade.kneigh_type = jComboBox12.getSelectedIndex();

}//GEN-LAST:event_jComboBox12ActionPerformed

private void jComboBox13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox13ActionPerformed
    // TODO add your handling code here:

    facade.selected_energy_model = jComboBox13.getSelectedIndex();

    switch(facade.selected_energy_model){

        case SIMPLE_ENERGY_MODEL:
            jLabel51.setText("Node Energy Distribution (mJoules)");
            jTextField25.setText("1000");
            jTextField20.setText("1000");
            facade.MAX_ENERGY = MAX_ENERGY_SIMPLE;
            jTextField46.setText(""+facade.MAX_ENERGY);
            break;

        case MOTE_ENERGY_MODEL:
            jLabel51.setText("Node Energy Distribution (mA-h)");
            jTextField25.setText("2000");
            jTextField20.setText("2000");
            facade.MAX_ENERGY = MAX_ENERGY_MOTE;
            jTextField46.setText(""+facade.MAX_ENERGY);
            break;

        case ACOS_ENERGY_MODEL:
            jLabel51.setText("Node Energy Distribution (mA-h)");
            jTextField25.setText("3200");
            jTextField20.setText("3200");
            facade.MAX_ENERGY = MAX_ENERGY_ACOS;
            jTextField46.setText(""+facade.MAX_ENERGY);
            break;
            
        case WASPMOTE_ENERGY_MODEL:
            jLabel51.setText("Node Energy Distribution (mA-h)");
            jTextField25.setText("1150");
            jTextField20.setText("1150");
            facade.MAX_ENERGY = MAX_ENERGY_WASPMOTE;
            jTextField46.setText(""+facade.MAX_ENERGY);
            break;
                
        case MICA2_ENERGY_MODEL:
            jLabel51.setText("Node Energy Distribution (mA-h)");
            jTextField25.setText("2000");
            jTextField20.setText("2000");
            facade.MAX_ENERGY = MAX_ENERGY_MICA2;
            jTextField46.setText(""+facade.MAX_ENERGY);
            break;

    }

}//GEN-LAST:event_jComboBox13ActionPerformed

private void jTextField25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField25ActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_jTextField25ActionPerformed

private void jButton24ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton24ActionPerformed
    // TODO add your handling code here:

     if(facade.topology_loaded){
        facade.sw_just_min = jCheckBox27.isSelected();
        facade.getThe_batch_sim().setWork(OPTIMALSOLUTION);
    }
    else
        facade.getThe_batch_sim().setWork(OPTIMALSOLUTIONBATCH);

}//GEN-LAST:event_jButton24ActionPerformed

private void jCheckBox28ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox28ItemStateChanged

    // TODO add your handling code here:

    facade.save_results_log = jCheckBox28.isSelected();

}//GEN-LAST:event_jCheckBox28ItemStateChanged

private void jButton25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton25ActionPerformed
    // TODO add your handling code here:

    try{
        facade.MAX_ENERGY = Double.parseDouble(jTextField46.getText());
    }catch(Exception ex){ex.printStackTrace();}

    myPanel.repaint();

}//GEN-LAST:event_jButton25ActionPerformed

private void jCheckBox7StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jCheckBox7StateChanged
    // TODO add your handling code here:
    facade.check_connectivity = jCheckBox7.isSelected();
}//GEN-LAST:event_jCheckBox7StateChanged

private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_jComboBox1ActionPerformed

private void jCheckBox7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox7ActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_jCheckBox7ActionPerformed

private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
    // TODO add your handling code here:
    jFileChooser1.setMultiSelectionEnabled(false);
    jFileChooser1.setFileSelectionMode(jFileChooser1.DIRECTORIES_ONLY);
    int p = jFileChooser1.showSaveDialog(this);
    File f = null;
    if (p == JFileChooser.APPROVE_OPTION) {
        f = jFileChooser1.getSelectedFile();
        facade.saveCreationWordsFile(f.getPath(), jTextField16.getText(), jTextField17.getText());
    }
    else{
        update(PRINT_MSG, "Save command cancelled by the user.");
    }
    jFileChooser1.setFileSelectionMode(jFileChooser1.FILES_AND_DIRECTORIES);
}//GEN-LAST:event_jMenuItem6ActionPerformed

private void jComboBox14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox14ActionPerformed
    // TODO add your handling code here:
    
    facade.selected_comm_model = jComboBox14.getSelectedIndex();

    switch(facade.selected_comm_model){

        case SIMPLE_COMM_MODEL:
            jTextField2.setText("100");
            jTextField2.setEnabled(true);
            jLabel7.setText("100");
            jTextField22.setEnabled(true);
            jTextField47.setText("100");
            break;
            
        case WASPMOTE_COMM_MODEL:
            jTextField2.setText("80");
            jTextField2.setEnabled(false);
            jLabel7.setText("80");
            jTextField22.setEnabled(false);
            jTextField47.setText("30");
            break;
                
        case MICA2_COMM_MODEL:
            jTextField2.setText("230");
            jTextField2.setEnabled(false);
            jLabel7.setText("230");
            jTextField22.setEnabled(false);
            jTextField47.setText("90");
            break;

    }
    
}//GEN-LAST:event_jComboBox14ActionPerformed
  
    public void setViewNodeNumber(boolean sw){
        myPanel.setViewNodeNumber(sw);
    }
    
    public void frame_repaint(){
        myPanel.repaint();
    }
    

        public void setNodePos(int _x, int _y){

        jTextField1.setText("1");
        jComboBox2.setSelectedIndex(4);
        jTextField23.setText(""+_x);
        jTextField24.setText(""+_y);

        /*try{
            facade.setNodeCreationWordAttributes(Integer.parseInt(jTextField1.getText()), Double.parseDouble(jTextField2.getText()),
                                        Double.parseDouble(jTextField7.getText()), Double.parseDouble(jTextField9.getText()),
                                        jComboBox2.getSelectedIndex(), Integer.parseInt(jTextField23.getText()), Integer.parseInt(jTextField24.getText()),
                                        jComboBox6.getSelectedIndex(), Integer.parseInt(jTextField25.getText()), Integer.parseInt(jTextField20.getText()),
                                        Double.parseDouble(jTextField15.getText()), Double.parseDouble(jTextField21.getText()),
                                        Double.parseDouble(jTextField26.getText()), Double.parseDouble(jTextField27.getText()), jCheckBox8.isSelected(),
                                        jComboBox13.getSelectedIndex(), jComboBox14.getSelectedIndex(), jComboBox8.getSelectedIndex(), Integer.parseInt(jTextField31.getText()),
                                        Integer.parseInt(jTextField32.getText()),Integer.parseInt(jTextField48.getText()));
        }catch(Exception e){
            facade.setNodeCreationWordAttributes(1, 40.0, 20.0, 10, 4, _x, _y, 0, 1000, 1000, 1, 1, facade.weight_metric1, facade.weight_metric2, false, 0, 0, 0, 600, 600, 5);
        }*/
        updateNodeCreationWordsParams();
        facade.addNodeCreationWord();

        jButton5.setText("Nodes left: "+(facade.getNumnodes()-facade.getTempnumnodes()-1));


        if(facade.getNumnodes()==facade.getTMType()){
            update(CLEAR_SIM, "");//clear_all_sim();
            facade.NodeGenerator();
            myPanel.setActive_tree_viz(treeIDViz);
            myPanel.repaint();
            jButton5.setText("Locate Sinks");
            jTabbedPane1.setSelectedIndex(1);
        }

    }
    
    public void update(int action, Object o){
        try{
            switch(action){                   
                
            case PRINT_MSG:
                javax.swing.JOptionPane.showMessageDialog(this, (String) o) ; break;

            case SHOW_EVENT_COUNT:
                jLabel33.setText((String) o); break;

            case SHOW_EVENT_LIST:
                if(show_events){
                    jTextArea1.append((String) o +"\n");
                }break;

            case SHOW_MSG:
                jTextPane3.setText((String) o); break;

            case SHOW_SIM_MSG:
                    jLabel1.setText((String) o ); break;

            case SHOW_NODE_INFO:
                int id = (Integer) o;
                if(id<facade.getNumpoints() && id>-1){
                    jTextField8.setText(""+id);
                    jTextPane1.setText(facade.getNode(id).toString4(facade.treeID));
                }else{
                    jTextField8.setText("");
                    jTextPane1.setText("");
                }
                myPanel.setSelectedNode(id);
                break;

            case UPDATE_TREEIDVIZ:
               treeIDViz = (Integer) o;
               break;

            case SHOW_STATS:
                jTextPane2.setText((String) o); break;

            case REPAINT:
                myPanel.repaint(); break;

            case CONNECTED_TOPOLOGIES:
                jLabel36.setText((String) o); break;

            case TOPOLOGY_PROGRESS:
                jLabel25.setText((String) o); break;

            case TOPOLOGY_PROGRESS_BAR:
                jProgressBar2.setValue((Integer) o); break;

            case TOPOLOGY_PROGRESS_BAR_MAX:
                jProgressBar2.setMaximum((Integer) o); break;

            case SIMULATION_PROGRESS:
                jLabel50.setText((String) o); break;

            case SIMULATION_PROGRESS_BAR:
                jProgressBar1.setValue((Integer) o); break;

            case SIMULATION_PROGRESS_BAR_MAX:
                jProgressBar1.setMaximum((Integer) o); break;

            case SHOW_WE:
                    jTextField26.setText((String) o); break;

            case SHOW_WD:
                    jTextField27.setText((String) o); break;

            case UPDATE_NODE_CREATION_WORDS:
                    int l;
                    node_creation_list.removeAllElements();
                    sink_creation_list.removeAllElements();
                    for(l=0;l<facade.node_creation_words.size();l++){
                        node_creation_list.add(l,facade.node_creation_words.get(l));
                    }
                    for(l=0;l<facade.sink_creation_words.size();l++){
                        sink_creation_list.add(l,facade.sink_creation_words.get(l));
                    }
                    jList1.setModel(node_creation_list);
                    jList2.setModel(sink_creation_list);
                    break;

            case SHOW_NUM_NODES:
                jLabel6.setText((String)o); break;

            case SHOW_NUM_SINKS:
                jLabel28.setText((String) o); break;

            case SHOW_AVG_NGB:
                jLabel24.setText((String) o); break;

            case SHOW_QUEUE_SIZE:
                jLabel43.setText((String) o); break;

            case UPDATE_NUM_NODES_FIELD:
                jTextField1.setText((String)o);
                break;

            case UPDATE_NO_PAINT:
                no_paint = (Boolean) o;
                break;

            case SHOW_DIALOG_TRY_AGAIN:
                int result;
                String[] options = new String[2];
                options[0]="Yes";
                options[1]="No";
                result = JOptionPane.showOptionDialog(
                    this,                             // the parent that the dialog blocks
                    "The maximum amount of failed trials was reached. Want to try again?",                                    // the dialog message array
                    "Topology Creation Error", // the title of the dialog window
                    JOptionPane.DEFAULT_OPTION,                 // option type
                    JOptionPane.INFORMATION_MESSAGE,            // message type
                    null,                                       // optional icon, use null to use the default icon
                    options,                                    // options string array, will be made into buttons
                    options[1]                                  // option that should be made into a default button
                );
                facade.setResultTryAgain(result);
                break;

            case SHOW_MSG_DIALOG:
                 javax.swing.JOptionPane.showMessageDialog(this, (String) o ); break;

            case SET_STATS:
                facade.statsPaneText = jTextPane2.getText(); break;

            case SET_REPORT:
                facade.report = jTextArea2.getText(); break;

            case CLEAN_CREATION_WORDS:
                sink_creation_list.clear();
                node_creation_list.clear();
                jList1.setModel(node_creation_list);
                jList2.setModel(sink_creation_list);
                break;

            case SHOW_DEPLOYMENT_TAB:
                jTabbedPane1.setSelectedIndex(1);
                break;
                
           case SET_MYFILE:
                facade.setMyFile(null);
                jFileChooser1.setMultiSelectionEnabled(false);
                //jFileChooser1.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
                int m = jFileChooser1.showOpenDialog(this);


                if (m == JFileChooser.APPROVE_OPTION) {
                    facade.setMyFile(jFileChooser1.getSelectedFile());
                }
                jFileChooser1.setSelectedFile(null);
                break;

            case SET_MYFILES:
                facade.myFiles = null;
                jFileChooser1.setMultiSelectionEnabled(true);
                 int k = jFileChooser1.showOpenDialog(this);


                if (k == JFileChooser.APPROVE_OPTION) {
                    facade.myFiles = jFileChooser1.getSelectedFiles();
                }
                else{
                     update(SHOW_MSG, "Save command cancelled by user.");
                }
                jFileChooser1.setMultiSelectionEnabled(false);
                jFileChooser1.setSelectedFile(null);
                break;


            case SET_BATCH_SIM_FILES:
                update(SET_MYFILES, "");
                if(facade.myFiles!=null){
                    jLabel47.setText(""+facade.myFiles.length+" files selected");
                    facade.num_files_topology_from_batch = facade.myFiles.length;
                    //jFileChooser1.setSelectedFile(null);
                }
                break;

            case SHOW_CREATING_TOPOS:
                jLabel18.setText((String) o);
                break;

            case SHOW_CURRENT_CTR:
                jLabel77.setText((String) o);
                break;

            case SHOW_STATS_LOG:
                jTextArea2.append((String) o);
                break;

            case SET_STATS_LOG:
                jTextArea2.setText((String) o);
                break;

            case REMOVE_NODE_LINES:
                myPanel.removeAllLinesFromSource((Integer) o);
                break;

            case CLEAR_PANEL:
                myPanel.clearAll();
                break;

            case ADD_LINE:
                Vector v = (Vector) o;
                myPanel.addLine((Integer)v.get(0),(Integer)v.get(1));
                break;

            case CLEAR_SIM:
                facade.setSim_assigned(false);//sim_assigned = false;
                //cleaning the structures
                facade.getMynodes().clear();
                myPanel.clearAll();
                facade.topology_loaded=false;
                facade.count_TM_invocations=0;



                facade.radius = Double.parseDouble(jTextField2.getText());
                facade.diameter = facade.radius*2;

                facade.sense_radius = Double.parseDouble(jTextField7.getText());
                facade.sense_diameter = 2*facade.sense_radius;

                facade.pref_radius = Double.parseDouble(jTextField47.getText());
                
                facade.sigma = Double.parseDouble(jTextField15.getText());
                facade.start_index = Integer.parseInt(jTextField17.getText());

                facade.energy_distribution_parameter = Double.parseDouble(jTextField20.getText());
                facade.sigma_e = Double.parseDouble(jTextField21.getText());

                facade.setBit_error_rate(Double.parseDouble(jTextField22.getText()));// = Double.parseDouble(jTextField22.getText());

                facade.setCadidate_grouping_step(Double.parseDouble(jTextField30.getText()));//candidate_grouping_step = Double.parseDouble(jTextField30.getText());

                facade.setAlpha_coverage_value(Double.parseDouble(jTextField43.getText()));// = Double.parseDouble(jTextField43.getText());

                //Draw only default gateways
                jCheckBox26.setSelected(false);

                facade.setW(Integer.parseInt(jTextField13.getText()));//w = Integer.parseInt(jTextField13.getText());
                facade.setH(Integer.parseInt(jTextField14.getText()));//h = Integer.parseInt(jTextField14.getText());
                myPanel.setArea(facade.getW(), facade.getH());
                myPanel.setRangeArea(false, false);

                facade.setNumnodes(0);//numnodes=0;
                facade.setNumsinks(0);
                facade.setNumpoints(0);

                //Updating labels
                update(SHOW_NUM_NODES, ""+facade.getNumnodes());//jLabel6.setText(""+facade.getNumnodes());
                update(SHOW_COMM_RADIUS, ""+facade.radius);//jLabel7.setText(""+facade.radius);
                update(SHOW_NUM_SINKS, ""+facade.getNumsinks());//jLabel28.setText(""+facade.getNumsinks());

                facade.setSortingmode(jComboBox5.getSelectedIndex());



                //Parameter for the motion protocol
                facade.setPm_step(Integer.parseInt(jTextField40.getText()));
                facade.setPm_sleep(Integer.parseInt(jTextField41.getText()));


                // Parameter for the KNEIGH algorithm
                facade.kneigh_k = Integer.parseInt(jTextField42.getText());

                treeIDViz = jComboBox1.getSelectedIndex()-1;
                myPanel.setActive_tree_viz(treeIDViz);
                facade.treeID=-1;
                jComboBox1.setSelectedIndex(0);

                myPanel.setActive_tree_viz(treeIDViz);
                myPanel.setNumNodes(0);

                //no_paint=true;

                update(REPAINT, "");//myPanel.repaint();
                break;

            case SHOW_COMM_RADIUS:
                jLabel7.setText((String) o);
                break;

            case SET_PANEL_AREA:
                myPanel.setArea(facade.getW(), facade.getH());
                break;

            case SET_RANGE_AREA:
                Vector<Boolean> bool = new Vector<Boolean>((Vector) o);
                myPanel.setRangeArea(bool.get(0), bool.get(1));
                break;

            case CHANGE_PANE_VIEW:
                jTabbedPane1.setSelectedIndex((Integer) o);
                break;

            case UPDATE_L:
                jLabel20.setText((String) o );
                break;

            case UPDATE_N:
                jLabel23.setText((String)o);
                break;

            case UPDATE_R:
                jLabel39.setText((String) o);
                break;

            case SET_FILE_SELECTION_MODE:
                jFileChooser1.setFileSelectionMode((Integer)o);
                break;

            case SHOW_SAVE_FILE:
                jFileChooser1.setMultiSelectionEnabled(false);
                int p = jFileChooser1.showSaveDialog(this);

                if (p == JFileChooser.APPROVE_OPTION) {
                    facade.setMyFile(jFileChooser1.getSelectedFile());
                }break;

            case SHOW_SORTING_MODE:
                jComboBox5.setSelectedIndex((Integer) o);
                break;

            case SET_ATARRAYA:
                //myPanel.setAtarraya((Boolean) o);
                jCheckBox1.setSelected((Boolean) o);
                break;

            case SET_VIEW_ACTIVE_TREE:
                //view_active_tree = (Boolean) o;
                jCheckBox10.setSelected((Boolean) o);
                break;

            case SET_ACTIVE_NODES:
                //myPanel.setActiveNodes((Boolean) o);
                jCheckBox3.setSelected((Boolean) o);
                break;

            case UPDATE_VNI_ID:
                jComboBox1.setSelectedIndex(0);
                break;

            case UPDATE_ALL_GATEWAYS:
                jCheckBox26.setSelected((Boolean) o);
                break;

            case SET_ACTIVE_TREE_VIZ:
                myPanel.setActive_tree_viz(treeIDViz);
                break;

            case UPDATE_IDEAL_P:
                ideal_p = myPanel.getGridParents();
                break;

            case UPDATE_GRID_MODE_TEXT:
                grid_mode_text = myPanel.getGridMode();
                break;

            case SHOW_SUM_OF_EDGES:
                jLabel85.setText((String)o);
                break;

            case SHOW_CTR_DENSE_PS:
                jLabel32.setText((String)o);
                break;

            case SHOW_CTR_DENSE_SANTI:
                jLabel80.setText((String)o);
                break;

            case SHOW_CTR_SPARSE_PS:
                jLabel70.setText((String)o);
                break;

            case SHOW_CTR_SPARSE_SANTI:
                jLabel88.setText((String)o);
                break;
           
            default:
                break;
            }
        }catch (Exception e){
            e.printStackTrace();
            javax.swing.JOptionPane.showMessageDialog(this, "Error when updating GUI");
        }
    }
    
   /*
    ****************************************************************
    */
    
    protected class newpanel extends JPanel implements MouseListener, MouseMotionListener, constants{
        
        Graphics2D g2;
        int h,w;
        int x,y;
        int active_tree_viz;
        boolean listenPosNode;
        String node_num;
        int selected_node;
        int gridmode;
        int numnodes;
        boolean atarraya,areaC,areaS,active_nodes,filled_active_nodes,viewnumnodes;
        Vector<pair> lines;
        Color[] palette;

        int ls;
        int intl;
        int num_cells_h;
        int num_cells_w;
        int temp_cell_point;
        int ideal_p;
        
        int i,j,k;
        int d;
        int dia_point, med_diapoint;
        double temp_rad, temp_dia;
        boolean temp_active;
        
        int offset = 2;

        public newpanel(int _x, int _y){
            
            super();
            
            active_tree_viz = 0;
            listenPosNode = false;
            lines = new Vector<pair>();
            
            jLabel1 = new javax.swing.JLabel();

            setLayout(null);

            setToolTipText("");
            addMouseListener(new java.awt.event.MouseAdapter() {
                @Override
                public void mouseReleased(java.awt.event.MouseEvent evt) {
                    formMouseReleased(evt);
                }
            });
            addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
                @Override
                public void mouseMoved(java.awt.event.MouseEvent evt) {
                    formMouseMoved(evt);
                }
            });

            add(jLabel1);
            jLabel1.setBounds(10, 580, 300, 20);
            
            h=_y;
            w=_x;
            x=20;
            y=20;
            active_tree_viz = 0;
            gridmode = 0;
            selected_node = -1;
            

            atarraya = false;
            areaC = false;
            areaS = false;
            active_nodes = false;
            listenPosNode = false;
            viewnumnodes=false;
            numnodes = 1;

            node_num="Node: ";

            facade.total_energy = 0;

            lines = new Vector<pair>();
            

            palette = new Color[12];

            palette[0] = java.awt.Color.DARK_GRAY;
            palette[1] = java.awt.Color.RED;
            palette[2] = java.awt.Color.BLUE;
            palette[3] = java.awt.Color.GREEN;
            palette[4] = java.awt.Color.ORANGE;
            palette[5] = java.awt.Color.PINK;
            palette[6] = java.awt.Color.MAGENTA;
            palette[7] = java.awt.Color.CYAN;
            palette[8] = java.awt.Color.BLACK;
            palette[9] = java.awt.Color.YELLOW;
            palette[10] = java.awt.Color.GRAY;
            palette[11] = java.awt.Color.LIGHT_GRAY;

            this.setBackground(java.awt.Color.WHITE);

            ls=0;
            intl=1;
            num_cells_h=0;
            num_cells_w=0;
            temp_cell_point=0;
            ideal_p=0;
            
        }

        /*********************************************************************/
        public void saveComponentAsJPEG(String filename) {
            //Dimension size = this.getSize();
            Dimension size = new Dimension(h+10,w+10);
            BufferedImage myImage =
                    new BufferedImage(size.width, size.height,
                    BufferedImage.TYPE_INT_RGB);
            Graphics2D g3 = myImage.createGraphics();
            this.paint(g3);
            try {
                /*OutputStream out = new FileOutputStream(filename);
                JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(out);
                encoder.encode(myImage);
                out.close();*/
                
                java.awt.image.RenderedImage rendImage = myImage;

                // Write generated image to a file
                
                // Save as PNG
                File file = new File(filename);
                ImageIO.write(rendImage, "png", file);

                // Save as JPEG
                //file = new File("newimage.jpg");
                //ImageIO.write(rendImage, "jpg", file);

            } catch (Exception e) {
                System.out.println(e);
            }
        }
        /*********************************************************************/



        public void clearAll(){
            lines.clear();
        }
        
        public void addLine(int _s, int _d){
            lines.add(new pair(_s, _d));
        }

        public void removeAllLinesFromSource(int s){
            int v;
            for(v=0;v<lines.size();v++){
                if(lines.get(v).getX() == s){
                    lines.remove(v);
                    v--;
                }
            }
        }

        public void removeLine(int _s, int _d){
            lines.remove(new pair(_s, _d));
        }

        public int getW(){
            return w;
        }
        
        public int getH(){
            return h;
        }
        
        public void setArea(int _x, int _y){
            setBounds(0,0, _x+100, _y+100);
            h=_y;
            w=_x;
            repaint();
        }
        
        public void setActive_tree_viz(int active_tree_){
            active_tree_viz=active_tree_;
        }
        
        public void setRangeArea(boolean s, boolean s2){
            areaC = s;
            areaS = s2;
            repaint();
        }
        
        private void formMouseMoved(java.awt.event.MouseEvent evt) {                                
    // TODO add your handling code here:

        if(listenPosNode){
            x = evt.getX();
            y = evt.getY();
            //showMessage("X="+x+" Y="+y);
            jTextField23.setText(""+x);
            jTextField24.setText(""+y);
        }

        }                               

        private void formMouseReleased(java.awt.event.MouseEvent evt) {                                   
    // TODO add your handling code here:
            x = evt.getX()-5;
            y = evt.getY()-5;
            int temp=0;

            if(listenPosNode){
                
                setNodePos(x, y);
                facade.setTempnumnodes(facade.getTempnumnodes()+1);
                
                if(facade.getTempnumnodes()==numnodes)
                    listenPosNode = false;

            }else{
                temp = getNodeNum(x,y);
                if(temp!=-1){
                    node_num = "Node: " + temp;
                }else{
                    node_num = "No node selected";
                }
                selected_node = temp;
                atarraya_frame.this.update(SHOW_NODE_INFO, temp);
                this.setToolTipText(node_num);
            }

            atarraya_frame.this.update(SHOW_MSG, "");

        }                                  

        public void mouseClicked(MouseEvent e){}
        public void mouseEntered(MouseEvent e){}
        public void mouseExited(MouseEvent e){}
        public void mousePressed(MouseEvent e){}
        public void mouseReleased(MouseEvent e){}

        public void mouseDragged(MouseEvent e){}
        public void mouseMoved(MouseEvent e){}
        
        
        public void setSelectedNode(int id){
            if(id<facade.getNumpoints()){
                selected_node = id;
                node_num = "Node: " + id;
            } else{
                selected_node = -1;
                node_num = "No node selected";
            }
            this.setToolTipText(node_num);
            repaint();
        }

        public int getNodeNum(int x_, int y_){

            boolean found=false;
            int x1,y1;

            i=0;
            while(!found && i<facade.getNumpoints()){
                x1 = (int)facade.getNode(i).getPosition().getX();
                y1 = (int)facade.getNode(i).getPosition().getY();

                if(x_>=x1-offset && x_<=x1+offset && y_>=y1-offset && y_<=y1+offset){
                    found=true;
                    return i;
                }
                i++;
            }

            return -1;
        }
    
        public void setGridmode(int val){
            gridmode = val;
            repaint();
        }

        public String getGridMode(){
            if(gridmode==1)
                return "H-V";
            else
                if(gridmode==2)
                    return "Diagonal";

            return "No grid";
        }
        
        public int CalcGridSide(){

            ls=0;
            intl=1;
            num_cells_h=0;
            num_cells_w=0;
            temp_cell_point=0;
            ideal_p=0;

            //Calculating parameters of the grid
                if(gridmode>0){

                    if(gridmode==1){
                        ls = (int)facade.radius;
                    }

                    if(gridmode==2){
                        ls = (int)((facade.radius/java.lang.Math.sqrt(2)));
                    }

                    intl = (int)java.lang.Math.ceil(ls);

                    num_cells_h = h/intl;
                    num_cells_w = w/intl;
                    temp_cell_point=0;
                }

                ideal_p = java.lang.Math.round((h/intl)*(w/intl));
            return 0;
        }

        public int getGridParents(){
            return ideal_p;
        }
        
        public void setNumNodes(int _numnodes){
            numnodes = _numnodes;
        }

        public void setlistenPosNode(boolean l){
            listenPosNode=l;
            facade.setTempnumnodes(0);
        }
        
        public void setAtarraya(boolean s){
            atarraya = s;
            repaint();
        }

        public void setActiveNodes(boolean s){
            active_nodes = s;
            repaint();
        }

        public void setFilledActiveNodes(boolean s){
            filled_active_nodes = s;
            repaint();
        }

        public void setViewNodeNumber(boolean sw){
            viewnumnodes = sw;
            repaint();
        }

        @Override
        public void paint(Graphics g){
            
            if(!facade.isBatch_simulation() && !facade.isBatch_creation()){
                super.paint(g);
                paint_(g);
            }
        
        }
        
        public void paint_(Graphics g){
            int temp = 0, temp2=0;
            node temp_node;
            
            if(!facade.isBatch_simulation() && !facade.isBatch_creation() && !no_paint){
                //super.paint(g);
                g2 = (Graphics2D) g;

                g2.translate(5,5);

                g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
                CalcGridSide();
                
                i=0;
                j=0;
                k=0;
                dia_point=6;
                med_diapoint=3;
                temp_active=false;

                
                //Drawing the grid
                if(gridmode>0){
                    for(i=0;i<=num_cells_h;i++){
                        g2.drawLine(0,temp_cell_point,w,temp_cell_point);
                        temp_cell_point+=intl;
                    }

                    temp_cell_point=0;

                    for(i=0;i<=num_cells_w;i++){
                        g2.drawLine(temp_cell_point,0,temp_cell_point,h);
                        temp_cell_point+=intl;
                    }

                }
                
                
                //If the Ataraya mode is false, then the program will show the max graph.
                if(!atarraya){
                    for(i=0;i<facade.getNumpoints();i++){
                        dia_point = (int)java.lang.Math.round(6*((double)facade.getNode(i).getEnergy()/facade.MAX_ENERGY));
                        med_diapoint = dia_point/2;
                        g2.fillOval((int)facade.getNode(i).getPosition().getX()-med_diapoint,(int)facade.getNode(i).getPosition().getY()-med_diapoint,dia_point,dia_point);
                        if(viewnumnodes){
                            g2.drawString(""+i,(int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY()-2);
                        }
                    }

                    for(i=0;i<lines.size();i++){
                        g2.drawLine((int)facade.getNode(lines.get(i).getX()).getPosition().getX(),(int)facade.getNode(lines.get(i).getX()).getPosition().getY(),(int)facade.getNode(lines.get(i).getY()).getPosition().getX(),(int)facade.getNode(lines.get(i).getY()).getPosition().getY());
                    }



                }else{

                    if(atarraya){
                        if(active_tree_viz != -1 && !view_active_tree){
                            //******************************************
                            // DRAWING TOPOLOGY IN INDIVIDUAL SELECTED TREE MODE
                            //******************************************

                            for(i=0;i<facade.getNumpoints();i++){
                                
                                //Save the active/non-active state of the node i
                                temp_active = facade.getNode(i).isActive(active_tree_viz);

                                //Draw communication area
                                if(areaC && temp_active){
                                    g2.setColor(palette[8]);
                                    temp_rad = facade.getNode(i).getRadius(active_tree_viz);
                                    temp_dia = temp_rad*2;

                                    if(filled_active_nodes)
                                        g2.fillOval((int)(facade.getNode(i).getPosition().getX()-temp_rad),(int)(facade.getNode(i).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);
                                    else
                                        g2.drawOval((int)(facade.getNode(i).getPosition().getX()-temp_rad),(int)(facade.getNode(i).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);
                                }
                            }

                            for(i=0;i<facade.getNumpoints();i++){
                                //Save the active/non-active state of the node i
                                temp_active = facade.getNode(i).isActive(active_tree_viz);

                                //Draw sensing area
                                if(areaS && temp_active){
                                    g2.setColor(palette[5]);
                                    temp_rad = facade.getNode(i).getSense_Radius();
                                    temp_dia = temp_rad*2;
                                    if(filled_active_nodes)
                                        g2.fillOval((int)(facade.getNode(i).getPosition().getX()-temp_rad),(int)(facade.getNode(i).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);
                                    else
                                        g2.drawOval((int)(facade.getNode(i).getPosition().getX()-temp_rad),(int)(facade.getNode(i).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);
                                }

                            }

                            for(i=0;i<facade.getNumpoints();i++){
                                
                                // if the node is not alive, then draw nothing
                                if(facade.getNode(i).isAlive()){
                                    
                                    //Save the active/non-active state of the node i
                                    temp_active = facade.getNode(i).isActive(active_tree_viz);
                                
                                    g2.setColor(palette[active_tree_viz]);
                                    
                                    
                                    if(jCheckBox26.isSelected()){
                                        //All gateways
                                        temp=facade.getNode(i).getInfrastructure(active_tree_viz).getNumGateways();

                                        for(j=0;j<temp;j++){
                                            d = facade.getNode(i).getGatewayID(active_tree_viz,j);
                                            if(d>=0){
                                                if(facade.getNode(d).isAlive() && facade.getNode(i).isNeighbor(d)){
                                                    if(d>=0 && d!=i)
                                                        g2.drawLine((int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY(),(int)facade.getNode(d).getPosition().getX(),(int)facade.getNode(d).getPosition().getY());
                                                }
                                            }
                                        }
                                    
                                    }
                                        //Just the default gateway
                                        d = facade.getNode(i).getDefaultGateway(active_tree_viz);
                                        if(d>=0){
                                            if(facade.getNode(d).isAlive() && facade.getNode(i).isNeighbor(d)){
                                                if(d>=0 && d!=i)
                                                    g2.drawLine((int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY(),(int)facade.getNode(d).getPosition().getX(),(int)facade.getNode(d).getPosition().getY());
                                            }
                                        }
                                    
                                    
                                    g2.setColor(palette[0]);
                                    if(!active_nodes){
                                        //See the Id of every node
                                        if(viewnumnodes){
                                                g2.drawString(""+i,(int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY()-2);
                                            }
                                    }else{
                                        if(temp_active){
                                            //See the Id of the active node
                                            if(viewnumnodes){
                                                g2.drawString(""+i,(int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY()-2);
                                            }
                                            // Asign a different color to parents compared to the tree color
                                            g2.setColor(palette[active_tree_viz+1]);
                                        }else
                                            if(facade.getNode(i).isSleeping(active_tree_viz))
                                                g2.setColor(palette[7]);
                                            else if(facade.getNode(i).isInactive(active_tree_viz))
                                                g2.setColor(palette[11]);
                                            else
                                                g2.setColor(palette[0]);
                                    }

                                    dia_point = (int)java.lang.Math.round(6*((double)facade.getNode(i).getEnergy()/facade.MAX_ENERGY));
                                    med_diapoint = dia_point/2;
                                    g2.fillOval((int)facade.getNode(i).getPosition().getX()-med_diapoint,(int)facade.getNode(i).getPosition().getY()-med_diapoint,dia_point,dia_point);
                                }
                            }
                        }else{
                            if(!view_active_tree){
                                //******************************************
                                // DRAWING ALL TOPOLOGIES MODE
                                //******************************************
                                for(k=0;k<MAX_TREES;k++){
                                    for(i=0;i<facade.getNumpoints();i++){
                                        if(facade.getNode(i).isAlive()){
                                           //Draw all the lines of the trees 
                                            g2.setColor(palette[k]);
                                            
                                            if(jCheckBox26.isSelected()){
                                                //All gateways
                                                temp=facade.getNode(i).getNumGateways(k);
                                                for(j=0;j<temp;j++){
                                                    d = facade.getNode(i).getGatewayID(k,j);
                                                    if(d>=0){
                                                        if(facade.getNode(d).isAlive() && facade.getNode(i).isNeighbor(d)){
                                                            if(d>=0 && d!=i)
                                                                g2.drawLine((int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY(),(int)facade.getNode(d).getPosition().getX(),(int)facade.getNode(d).getPosition().getY());
                                                        }
                                                    }
                                                }
                                            }
                                                //Just default gateways
                                                d = facade.getNode(i).getDefaultGateway(k);
                                                if(d>=0){
                                                    if(facade.getNode(d).isAlive() && facade.getNode(i).isNeighbor(d)){
                                                        if(d>=0 && d!=i)
                                                            g2.drawLine((int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY(),(int)facade.getNode(d).getPosition().getX(),(int)facade.getNode(d).getPosition().getY());
                                                    }
                                                }
                                            
                                            
                                        }
                                    }

                                }
                                
                                for(i=0;i<facade.getNumpoints();i++){
                                
                                    if(facade.getNode(i).isAlive()){
                                         temp = facade.getNode(i).getActiveTree();
                                         temp_active = facade.getNode(i).isActive(temp);

                                         g2.setColor(palette[0]);
                                            if(!active_nodes){
                                                //See the Id of every node
                                                if(viewnumnodes){
                                                        g2.drawString(""+i,(int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY()-2);
                                                    }
                                            }else{
                                                if(temp_active){
                                                    //See the Id of the active node
                                                    if(viewnumnodes){
                                                        g2.drawString(""+i,(int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY()-2);
                                                    }
                                                    // Asign a different color to parents compared to the tree color
                                                    g2.setColor(palette[temp+1]);
                                                }else
                                                    if(facade.getNode(i).isSleeping(temp))
                                                        g2.setColor(palette[7]);
                                                    else if(facade.getNode(i).isInactive(temp))
                                                        g2.setColor(palette[11]);
                                                    else
                                                        g2.setColor(palette[0]);
                                            }

                                        dia_point = (int)java.lang.Math.round(6*((double)facade.getNode(i).getEnergy()/facade.MAX_ENERGY));
                                        med_diapoint = dia_point/2;
                                        g2.fillOval((int)facade.getNode(i).getPosition().getX()-med_diapoint,(int)facade.getNode(i).getPosition().getY()-med_diapoint,dia_point,dia_point);
                                        }
                                }
                                
                            }else{
                              //******************************************
                              // DRAWING INDIVIDUAL TOPOLOGY IN ACTIVE TREE MODE
                              //******************************************
                                    for(i=0;i<facade.getNumpoints();i++){

                                        temp = facade.getNode(i).getActiveTree();
                                        //Save the active/non-active state of the node i
                                        temp_active = facade.getNode(i).isActive(temp);

                                        //Draw communication area
                                        if(areaC && temp_active){
                                            g2.setColor(palette[8]);
                                            temp_rad = facade.getNode(i).getRadius();
                                            temp_dia = temp_rad*2;

                                            if(filled_active_nodes)
                                                g2.fillOval((int)(facade.getNode(i).getPosition().getX()-temp_rad),(int)(facade.getNode(i).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);
                                            else
                                                g2.drawOval((int)(facade.getNode(i).getPosition().getX()-temp_rad),(int)(facade.getNode(i).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);
                                        }
                                    }

                                    for(i=0;i<facade.getNumpoints();i++){
                                        //Save the active/non-active state of the node i
                                        //temp_active = getNode(i).isActive();
                                        temp_active = facade.getNode(i).isActive(temp);

                                        //Draw sensing area
                                        if(areaS && temp_active){
                                            g2.setColor(palette[5]);
                                            temp_rad = facade.getNode(i).getSense_Radius();
                                            temp_dia = temp_rad*2;
                                            if(filled_active_nodes)
                                                g2.fillOval((int)(facade.getNode(i).getPosition().getX()-temp_rad),(int)(facade.getNode(i).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);
                                            else
                                                g2.drawOval((int)(facade.getNode(i).getPosition().getX()-temp_rad),(int)(facade.getNode(i).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);
                                        }

                                    }

                                    for(i=0;i<facade.getNumpoints();i++){
                                        
                                        if(facade.getNode(i).isAlive()){
                                            k=facade.getNode(i).getActiveTree();
                                            //Save the active/non-active state of the node i
                                            temp_active = facade.getNode(i).isActive(k);

                                            g2.setColor(palette[k]);
                                            
                                            if(jCheckBox26.isSelected()){
                                                //All gateways
                                                temp=facade.getNode(i).getInfrastructure(k).getNumGateways();

                                                for(j=0;j<temp;j++){
                                                    d = facade.getNode(i).getGatewayID(k,j);
                                                    if(d>=0){
                                                        if(facade.getNode(d).isAlive() && facade.getNode(i).isNeighbor(d)){
                                                            if(d>=0 && d!=i)
                                                                g2.drawLine((int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY(),(int)facade.getNode(d).getPosition().getX(),(int)facade.getNode(d).getPosition().getY());
                                                        }
                                                    }
                                                }
                                           }
                                                //just default gateways
                                                d = facade.getNode(i).getDefaultGateway(k);
                                                if(d>=0){
                                                    if(facade.getNode(d).isAlive() && facade.getNode(i).isNeighbor(d)){
                                                        if(d>=0 && d!=i)
                                                            g2.drawLine((int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY(),(int)facade.getNode(d).getPosition().getX(),(int)facade.getNode(d).getPosition().getY());
                                                    }
                                                }
                                           
                                            
                                            g2.setColor(palette[0]);
                                            if(!active_nodes){
                                                //See the Id of every node
                                                if(viewnumnodes){
                                                        g2.drawString(""+i,(int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY()-2);
                                                    }
                                            }else{
                                                if(temp_active){
                                                    //See the Id of the active node
                                                    if(viewnumnodes){
                                                        g2.drawString(""+i,(int)facade.getNode(i).getPosition().getX(),(int)facade.getNode(i).getPosition().getY()-2);
                                                    }
                                                    // Asign a different color to parents compared to the tree color
                                                    g2.setColor(palette[k+1]);
                                                }else
                                                    if(facade.getNode(i).isSleeping(k))
                                                        g2.setColor(palette[7]);
                                                    else if(facade.getNode(i).isInactive(k))
                                                        g2.setColor(palette[11]);
                                                    else
                                                        g2.setColor(palette[0]);
                                                        
                                            }


                                            dia_point = (int)java.lang.Math.round(6*((double)facade.getNode(i).getEnergy()/facade.MAX_ENERGY));
                                            med_diapoint = dia_point/2;
                                            g2.fillOval((int)facade.getNode(i).getPosition().getX()-med_diapoint,(int)facade.getNode(i).getPosition().getY()-med_diapoint,dia_point,dia_point);

                                        }

                            }
                                
                            }
                        }
                        }


                    }

                    if(selected_node!=-1){
                        g2.setColor(palette[4]);
                        g2.fillOval((int)facade.getNode(selected_node).getPosition().getX()-4,(int)facade.getNode(selected_node).getPosition().getY()-4,8,8);

                        //Draw comm area on the selected node
                        g2.setColor(palette[8]);
                        temp_rad = facade.getNode(selected_node).getRadius(facade.getNode(selected_node).getActiveTree());
                        temp_dia = temp_rad*2;
                        g2.drawOval((int)(facade.getNode(selected_node).getPosition().getX()-temp_rad),(int)(facade.getNode(selected_node).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);

                        //Draw sensing area on the selected node
                        g2.setColor(palette[5]);
                        temp_rad = facade.getNode(selected_node).getSense_Radius();
                        temp_dia = temp_rad*2;
                        g2.drawOval((int)(facade.getNode(selected_node).getPosition().getX()-temp_rad),(int)(facade.getNode(selected_node).getPosition().getY()-temp_rad),(int)temp_dia,(int)temp_dia);

                    }
                
                //area lines
                if(filled_active_nodes)
                    g2.setColor(palette[11]);
                else
                    g2.setColor(palette[0]);
                g2.drawLine(0,w,h,w);
                g2.drawLine(h,0,h,w);
                g2.drawLine(0,0,0,w);
                g2.drawLine(0,0,h,0);
                
                }
            
            g.dispose();
            
        }
            
        }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new atarraya_frame().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton11;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton14;
    private javax.swing.JButton jButton15;
    private javax.swing.JButton jButton16;
    private javax.swing.JButton jButton17;
    private javax.swing.JButton jButton18;
    private javax.swing.JButton jButton19;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton20;
    private javax.swing.JButton jButton21;
    private javax.swing.JButton jButton22;
    private javax.swing.JButton jButton23;
    private javax.swing.JButton jButton24;
    private javax.swing.JButton jButton25;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox10;
    private javax.swing.JCheckBox jCheckBox11;
    private javax.swing.JCheckBox jCheckBox12;
    private javax.swing.JCheckBox jCheckBox13;
    private javax.swing.JCheckBox jCheckBox14;
    private javax.swing.JCheckBox jCheckBox15;
    private javax.swing.JCheckBox jCheckBox16;
    private javax.swing.JCheckBox jCheckBox17;
    private javax.swing.JCheckBox jCheckBox18;
    private javax.swing.JCheckBox jCheckBox19;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox20;
    private javax.swing.JCheckBox jCheckBox21;
    private javax.swing.JCheckBox jCheckBox22;
    private javax.swing.JCheckBox jCheckBox23;
    private javax.swing.JCheckBox jCheckBox24;
    private javax.swing.JCheckBox jCheckBox25;
    private javax.swing.JCheckBox jCheckBox26;
    private javax.swing.JCheckBox jCheckBox27;
    private javax.swing.JCheckBox jCheckBox28;
    private javax.swing.JCheckBox jCheckBox29;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox7;
    private javax.swing.JCheckBox jCheckBox8;
    private javax.swing.JCheckBox jCheckBox9;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JComboBox jComboBox10;
    private javax.swing.JComboBox jComboBox11;
    private javax.swing.JComboBox jComboBox12;
    private javax.swing.JComboBox jComboBox13;
    private javax.swing.JComboBox jComboBox14;
    private javax.swing.JComboBox jComboBox2;
    private javax.swing.JComboBox jComboBox3;
    private javax.swing.JComboBox jComboBox4;
    private javax.swing.JComboBox jComboBox5;
    private javax.swing.JComboBox jComboBox6;
    private javax.swing.JComboBox jComboBox7;
    private javax.swing.JComboBox jComboBox8;
    private javax.swing.JComboBox jComboBox9;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JFileChooser jFileChooser2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel100;
    private javax.swing.JLabel jLabel101;
    private javax.swing.JLabel jLabel102;
    private javax.swing.JLabel jLabel103;
    private javax.swing.JLabel jLabel104;
    private javax.swing.JLabel jLabel105;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel40;
    private javax.swing.JLabel jLabel41;
    private javax.swing.JLabel jLabel42;
    private javax.swing.JLabel jLabel43;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel45;
    private javax.swing.JLabel jLabel46;
    private javax.swing.JLabel jLabel47;
    private javax.swing.JLabel jLabel48;
    private javax.swing.JLabel jLabel49;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel50;
    private javax.swing.JLabel jLabel51;
    private javax.swing.JLabel jLabel52;
    private javax.swing.JLabel jLabel53;
    private javax.swing.JLabel jLabel54;
    private javax.swing.JLabel jLabel55;
    private javax.swing.JLabel jLabel56;
    private javax.swing.JLabel jLabel57;
    private javax.swing.JLabel jLabel58;
    private javax.swing.JLabel jLabel59;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel60;
    private javax.swing.JLabel jLabel61;
    private javax.swing.JLabel jLabel62;
    private javax.swing.JLabel jLabel63;
    private javax.swing.JLabel jLabel64;
    private javax.swing.JLabel jLabel65;
    private javax.swing.JLabel jLabel66;
    private javax.swing.JLabel jLabel67;
    private javax.swing.JLabel jLabel68;
    private javax.swing.JLabel jLabel69;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel70;
    private javax.swing.JLabel jLabel71;
    private javax.swing.JLabel jLabel72;
    private javax.swing.JLabel jLabel73;
    private javax.swing.JLabel jLabel74;
    private javax.swing.JLabel jLabel75;
    private javax.swing.JLabel jLabel76;
    private javax.swing.JLabel jLabel77;
    private javax.swing.JLabel jLabel78;
    private javax.swing.JLabel jLabel79;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel80;
    private javax.swing.JLabel jLabel81;
    private javax.swing.JLabel jLabel82;
    private javax.swing.JLabel jLabel83;
    private javax.swing.JLabel jLabel84;
    private javax.swing.JLabel jLabel85;
    private javax.swing.JLabel jLabel86;
    private javax.swing.JLabel jLabel87;
    private javax.swing.JLabel jLabel88;
    private javax.swing.JLabel jLabel89;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabel90;
    private javax.swing.JLabel jLabel91;
    private javax.swing.JLabel jLabel92;
    private javax.swing.JLabel jLabel93;
    private javax.swing.JLabel jLabel94;
    private javax.swing.JLabel jLabel95;
    private javax.swing.JLabel jLabel96;
    private javax.swing.JLabel jLabel97;
    private javax.swing.JLabel jLabel98;
    private javax.swing.JLabel jLabel99;
    private javax.swing.JList jList1;
    private javax.swing.JList jList2;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar2;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel22;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel24;
    private javax.swing.JPanel jPanel25;
    private javax.swing.JPanel jPanel26;
    private javax.swing.JPanel jPanel27;
    private javax.swing.JPanel jPanel28;
    private javax.swing.JPanel jPanel29;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel30;
    private javax.swing.JPanel jPanel31;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JProgressBar jProgressBar2;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTabbedPane jTabbedPane2;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField10;
    private javax.swing.JTextField jTextField11;
    private javax.swing.JTextField jTextField12;
    private javax.swing.JTextField jTextField13;
    private javax.swing.JTextField jTextField14;
    private javax.swing.JTextField jTextField15;
    private javax.swing.JTextField jTextField16;
    private javax.swing.JTextField jTextField17;
    private javax.swing.JTextField jTextField18;
    private javax.swing.JTextField jTextField19;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField20;
    private javax.swing.JTextField jTextField21;
    private javax.swing.JTextField jTextField22;
    private javax.swing.JTextField jTextField23;
    private javax.swing.JTextField jTextField24;
    private javax.swing.JTextField jTextField25;
    private javax.swing.JTextField jTextField26;
    private javax.swing.JTextField jTextField27;
    private javax.swing.JTextField jTextField28;
    private javax.swing.JTextField jTextField29;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField30;
    private javax.swing.JTextField jTextField31;
    private javax.swing.JTextField jTextField32;
    private javax.swing.JTextField jTextField33;
    private javax.swing.JTextField jTextField34;
    private javax.swing.JTextField jTextField35;
    private javax.swing.JTextField jTextField36;
    private javax.swing.JTextField jTextField37;
    private javax.swing.JTextField jTextField38;
    private javax.swing.JTextField jTextField39;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField40;
    private javax.swing.JTextField jTextField41;
    private javax.swing.JTextField jTextField42;
    private javax.swing.JTextField jTextField43;
    private javax.swing.JTextField jTextField44;
    private javax.swing.JTextField jTextField45;
    private javax.swing.JTextField jTextField46;
    private javax.swing.JTextField jTextField47;
    private javax.swing.JTextField jTextField48;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    private javax.swing.JTextField jTextField9;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JTextPane jTextPane2;
    private javax.swing.JTextPane jTextPane3;
    // End of variables declaration//GEN-END:variables

}
